#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <deque>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <cmath>
#include <string>
#include <vector>
#include <bitset>
#include <iomanip>

#define sp << " "
#define sps << " " <<
#define ln << "\n"
#define vi vector<int>
#define pii pair<int, int>
#define all(a) (a).begin(), (a).end()
#define rall(a) a.rbegin(), a.rend()
#define optimise cin.sync_with_stdio(false); cout.sync_with_stdio(false); cin.tie(NULL);

typedef long long ll;
typedef unsigned long long ull;
using namespace std;

template<class T>
istream& operator>> (istream& is, vector<T>& vec) { for (int i = 0; i < (int)vec.size(); ++i)is >> vec[i]; return is; }
template<class T>
ostream& operator<< (ostream& os, vector<T>& vec) { for (int i = 0; i < (int)vec.size(); ++i)os << vec[i] sp; return os; }
template<class T>
istream& operator>> (istream& is, pair<T, T>& a) { is >> a.first >> a.second; return is; }

const double pi = acos(-1.0);
const ll mod = (1ll << 30); //(int)1e9 + 7;
const ll INF = 2e18;
const int inf = 1e9;
const int maxlen = (int)1e5 + 10;
const double eps = 1e-4;
//--------------------------

void solve() {
    int n; cin >> n;

    int ans = inf, mincost = inf;

    for (int i = 0; i < n; ++i) {
        int cost; cin >> cost;
        string s; cin >> s;
        int cnt2 = 0, cnt1 = 0, cnt0 = 0;

        for (auto ch : s) {
            if (ch == '2') cnt2++;
            if (ch == '1') cnt1++;
            if (ch == '0') cnt0++;
        }

        if (cnt2 >= 2 && cnt1 && cnt0 && cost < mincost) {
            ans = i + 1;
            mincost = cost;
        }
    }

    if (ans == inf) cout << 0;
    else cout << ans;

}

int main() {
    optimise
#ifdef _DEBUG
        freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#else
        //freopen("output.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
#endif

        int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}