﻿#pragma warning(disable: 4996);
#pragma warning(disable: 4081);
#pragma warning(disable: 6031);

#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <tuple>
#include <queue>
#include <set>
#include <cmath>
#include <stack>
#include <numeric>
#include <iomanip>
#include <ctype.h>
#include <algorithm>

#define ll long long
#define vi vector<int>
#define vl vector<int>
#define vb vector<bool>
#define vvi vector<vector<int>>
#define vvl vector<vector<int>>
#define vs vector<string>

#define ii pair<int, int>
#define vii vector<ii>
#define mp make_pair

const long long INF = 1e9 + 7;

using namespace std;

ll counter = 0;

void fill(vector<ll>& tree, int step, int l, int r) {
    //cout << "Fill " << step << " from " << l << " to " << r << endl;
    if (!step) {
        return;
    }
    for (int i = l; counter && i < r; i += step) {
        tree[i] = 1;
        --counter;
    }
    if (!counter) {
        return;
    }
    fill(tree, step / 2, l + 1, l + step);
    fill(tree, step / 2, l + step + 1, r);
}

void print(vector<ll>& tree) {
    ll maxp = tree.size();
    ll p = 1;
    while (p < maxp) {
        for (int i = 0; i < p; ++i) {
            cout << tree[p + i] << ' ';
        }
        cout << endl;
        p *= 2;
    }
}

ll countOffset(vector<ll>& tree, ll from, ll pos) {
    int offset = 0;
    for (int i = from; i < pos; ++i) {
        if (!tree[i]) {
            ++offset;
        }
    }
    return offset;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
     freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#else
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif // _DEBUG

    ll a, b;
    cin >> a >> b;
    ll A = a;
    ll B = b;

    ll treeSize = 1;
    while (treeSize <= a + b) {
        treeSize *= 2;
    }
    vector<ll> tree(treeSize);
    
    ll b2 = treeSize;

    ll bmax = 1;
    while (bmax <= b) {
        bmax *= 2;
    }

    while (b2) {
        while (b2 > b) {
            b2 /= 2;
        }
        for (ll i = b2; b && i < b2 * 2; ++i) {
            tree[i] = 2;
            --b;
        }
    }

    ll step = bmax / 2;
    for (ll i = 1; i < bmax; ++i) {
        if (!tree[i]) {
            tree[i] = 1;
            --a;
        }
    }

    if (a < 0) {
        cout << -1;
        return 0;
    }
    counter = a;
    while (counter) {
        fill(tree, step, bmax, bmax * 2);
        bmax *= 2;
    }
    bmax /= 2;
    for (int i = 1; i < treeSize; ++i) {
        if (tree[i]) {
            cout << tree[i] << ' ';
            int l = i * 2;
            int r = i * 2 + 1;
            int offset = 0;
            if (l < treeSize) {
                offset = countOffset(tree, bmax, l);
            }
            if (l < treeSize && tree[l]) {
                cout << l - offset << ' ';
            }
            else {
                cout << "0 ";
            }
            if (r < treeSize && tree[r]) {
                cout << r - offset << ' ';
            }
            else {
                cout << "0 ";
            }
            cout << endl;
        }
    }

    //print(tree);

    return 0;
}