// chrono::system_clock::now().time_since_epoch().count()
#include <bits/stdc++.h>

#define pb push_back
#define eb emplace_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define rep(i, a, b) for (int i = (a); i < (b); ++i)
#define debug(x) cerr << #x << " = " << x << endl

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int MAXN = (int)2e5 + 5;

array<int, 3> ans[MAXN];
map<pii, array<int, 3>> mem;
map<pii, int> dp;
int n;

int ok(int a, int b, int c, int d) {
    if (a < 0 || b < 0 || c < 0 || d < 0) {
        return 0;
    }
    
    int X = a + 2 * b;
    int Y = c + 2 * d;
    
    return abs(X - Y) <= 1;
}

int calc(int a, int b) {
    if (a < 0 || b < 0) {
        return 0;
    }
    
    auto it = dp.find(mp(a, b));
    
    if (it != dp.end()) {
        return it -> se;
    }
    
    if (b == 0) {
        mem[mp(a, b)] = {1, (a - 1) / 2, 0};
        return dp[mp(a, b)] = 1;
    }
    
    int y1 = (b - 1) / 2, y2 = b / 2;
    
    for (int off = -2; off <= 2; ++off) {
        int x1 = a / 2 + off;
        int x2 = a - x1;
        
        if (x1 < 0 || x1 > a) {
            continue;
        }
        
        if (ok(x1, y1, x2, y2) && calc(x1, y1) && calc(x2, y2)) {
            mem[mp(a, b)] = {2, x1, y1};
            return dp[mp(a, b)] = 1;
        }
    }
    
    return dp[mp(a, b)] = 0;
}

void go(int v, int a, int b) {
    calc(a, b);
    auto it = mem[mp(a, b)];  
    //cerr << a << ' ' << b << ": " << it[0] << ' ' << it[1] << ' ' << it[2] << endl;  
    ans[v][0] = it[0];
    
    if (it[0] == 1) {
        --a;
    }
    else {
        --b;
    }
    
    int x1 = it[1], y1 = it[2];
    int x2 = a - x1, y2 = b - y1;
    
    if (x1 + y1) {
        int c1 = ++n;
        ans[v][1] = c1;
        go(c1, x1, y1);
    }
    else {
        ans[v][1] = 0;
    }
    
    if (x2 + y2) {
        int c2 = ++n;
        ans[v][2] = c2;
        go(c2, x2, y2);
    }
    else {
        ans[v][2] = 0;
    }
}

void solve() {
    int a, b;
    cin >> a >> b;
    dp.clear();
    
    if (!calc(a, b)) {
        cout << -1 << endl;
        return;
    }
    
    n = 1;
    go(1, a, b);
    
    rep (i, 1, n + 1) {
        cout << ans[i][0] << ' ' << ans[i][1] << ' ' << ans[i][2] << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int tt = 1;
    
    while (tt--) {
        solve();
    }

    return 0;
}
