// by paradox
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define y1 y1234567890

#define NAME ""
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define file_io freopen(NAME".in", "r", stdin); freopen(NAME".out", "w", stdout)

const int N = 5e5;
const int M = N + 7;
const double EPS = 1e-10;

const int MOD = 1e9 + 7;
const ll INF = 1e18 + 17;

int sz[M];
bool us[M];

void dfsNew(int v = 1) {
    if (!sz[v]) {
        sz[v] = 1;
        return;
    }
    int le = sz[v << 1], ri = sz[v << 1 | 1];
    if (le > ri) {
        dfsNew(v << 1 | 1);
    } else {
        dfsNew(v << 1);
    }
    sz[v]++;
}

bool tryAdd(int v = 1) {
    if (!sz[v]) {
        return false;
    }
    if (!us[v]) {
        sz[v]++;
        us[v] = 1;
        return true;
    }
    int le = sz[v << 1], ri = sz[v << 1 | 1];
    if (le > ri) {
        bool res = tryAdd(v << 1 | 1);
        if (!res)
            return false;
    } else {
        bool res = tryAdd(v << 1);
        if (!res)
            return false;
    }
    sz[v]++;
    return true;
}

int timer = 0;
int ver[M];
int l[M], r[M], an[M];

void dfs(int v = 1) {
    ver[v] = ++timer;
    if (sz[v << 1])
        dfs(v << 1);
    if (sz[v << 1 | 1])
        dfs(v << 1 | 1);
    l[ver[v]] = ver[v << 1];
    r[ver[v]] = ver[v << 1 | 1];
    an[ver[v]] = us[v] + 1;
}

void solve() {
    int a, b;
    scanf("%d %d", &a, &b);
    int n = a + b;
    for (int i = 1; i <= n; ++i)
        dfsNew();
    
    for (int i = 1; i <= b; ++i) {
        bool res = tryAdd();
        if (!res) {
            printf("-1\n");
            return;
        }
    }
    dfs();
    for (int i = 1; i <= n; ++i) {
        printf("%d %d %d\n", an[i], l[i], r[i]);
    }
}

int main() {
    int tt = 1;
    // scanf("%d", &tt);
    while (tt--) {
        solve();
    }
    return 0;
}