#include <bits/stdc++.h>

#define pb push_back
#define ll long long
#define f first
#define s second
#define mp make_pair
#define pii pair < int, int >

using namespace std;

const int N = 2e6 + 11;
int n, dist[N], from[N], mx;
bool u[N];
vector < int > g[22];
vector < int > cur , ans;

int cnt_temp[22], color_temp[22];
bool correct_temp;

bool cor[N];

void dfs(int v, int p = -1){
	for (auto to : g[v]){
		if (to != p){
			dfs(to, v);
			cnt_temp[v] += cnt_temp[to];
		}
	}
	if (!color_temp[v] && cnt_temp[v])
		correct_temp = false;
	cnt_temp[v] += color_temp[v];
}

bool is_correct(int mask){
	if (mask % 2 == 0)
		return false;
	for (int i = 1; i <= n; i++)
		cnt_temp[i] = color_temp[i] = 0;
	correct_temp = true;
	for (int i = 0; i < n; i++)
		if ((mask & (1 << i)))
			color_temp[i + 1] = 1;
	dfs(1);
	return correct_temp;
}

bool used[N];
int op=0;

void dfs2(int x,int depth=0){
	if(op>1e7){
		return;
	}
	//cerr << x << ' ' << depth << endl;
	op++;
	used[x]=1;
	for (int i = n - 1; i >= 0; i--){
		int to = (x ^ (1 << i));
		if (cor[to] && !used[to]){
			cur.pb(i+1);
			dfs2(to, depth + 1);
			cur.pop_back();
		}
	}
	if(mx<depth){
		mx=depth;
		ans.clear();
		for(auto it: cur)ans.pb(it);
	}
	used[x]=0;
}

void dfs3(int x,int depth=0){
	if(op>5e6){
		return;
	}
	//cerr << x << ' ' << depth << endl;
	op++;
	used[x]=1;
	for (int i = 0; i < n; i++){
		int to = (x ^ (1 << i));
		if (cor[to] && !used[to]){
			cur.pb(i+1);
			dfs3(to, depth + 1);
			cur.pop_back();
		}
	}
	if(mx<depth){
		mx=depth;
		ans.clear();
		for(auto it: cur)ans.pb(it);
	}
	used[x]=0;
}

void dfs4(int x,int depth=0){
	if(op>5e6){
		return;
	}
	//cerr << x << ' ' << depth << endl;
	op++;
	used[x]=1;
	for (int i = 0; i < n; i++){
		int X = rand()%n;
		int to = (x ^ (1 << X));
		if (cor[to] && !used[to]){
			cur.pb(X+1);
			dfs4(to, depth + 1);
			cur.pop_back();
		}
	}
	if(mx<depth){
		mx=depth;
		ans.clear();
		for(auto it: cur)ans.pb(it);
	}
	used[x]=0;
}

int main(){
	#ifdef LOCAL
		freopen("in", "r", stdin);
		freopen("out", "w", stdout);
	#endif
	srand(time(NULL));
	cin >> n;
	int p;
	for (int i = 2; i <= n; i++){
		cin >> p;
		g[i].pb(p);
		g[p].pb(i);
	}
	int t = (1 << n);
	for (int i = 0; i < t; i++)
		cor[i] = is_correct(i);
	/*
	queue < int > q;
	q.push(1);
	u[1] = true;
	while (!q.empty()){
		int v = q.front();
		q.pop();
		for (int i = 0; i < n; i++){
			int to = (v ^ (1 << i));
			//if (is_correct(to))
				//cerr << v << ' ' << to << endl;
			if (is_correct(to) && !u[to]){
				q.push(to);
				u[to] = true;
				dist[to] = dist[v] + 1;
				from[to] = v;
			}
		}
	}
	int mx = 0, ind;
	int t = (1 << n);
	for (int i = 0; i < t; i++)
		if (mx < dist[i]){
			mx = dist[i];
			ind = i;
		}
	cout << mx;
	*/
	dfs2(1);
	/*
	op=0;
	cur.clear();
	dfs3(1);
	op=0;
	cur.clear();
	dfs4(1);*/
	cout << mx << endl;
	for(auto it: ans){
		cout << it << ' ';
	}
	cout << endl;
	return 0;
}