#include <stack>
#include <string>
#include <bitset>
#include <unordered_map>
#include <cstdio>
#include <limits>
#include <vector>
#include <climits>
#include <cstring>
#include <cstdlib>
#include <fstream>
#include <numeric>
#include <sstream>
#include <cassert>
#include <iomanip>
#include <random>
#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <map>
#include <set>
#include <list>
#include <cmath>
#include <ctime>
#include <deque>
#include <queue>
#include <chrono>

#define all(x) (x).begin(),(x).end()
#define sz(x) (int)(x.size())
#define endl "\n"
#define int long long

using namespace std;

typedef long long ll;

const int N = (int)(5e5) + 322;
const int mod = (int)(1e9) + 7;
const int inf = (int)(1e18);

bool check(string s) {
    unordered_map <char, int> cnt;
    for(auto c : s) cnt[c]++;
    return cnt['0'] >= 1 && cnt['1'] >= 1 && cnt['2'] >= 2;
}

void solve() {
    int n; cin >> n;
    int mn = inf;
    int id = 0;
    for(int i  = 1; i <= n; ++i) {
        int p; cin >> p;
        string s; cin >> s;
        if (!check(s)) continue;
        if (mn > p) {
            mn = p;
            id = i;
        }
    }
    cout << id;
}

signed main () {
    ios_base::sync_with_stdio(false);cin.tie(0);
    int t = 1;
//    cin >> t;
    for(int tt = 0; tt < t; ++tt) {
        solve();
    }
    return 0;
}