#include <iostream>
#include <vector>
using namespace std;


int count(vector<string>& vec, int i, int j) {
    int count = 0;
    for (int k = 0; k < 8; k++) {
        count += vec[i][k] == vec[j][k];
    }
    // for (int k = 0; k < 8; k++) {
    //     bool t = true;
    //     for (int d = i + 1; d <= j; d++) {
    //         if (vec[d][k] != vec[d - 1][k]) {
    //             t = false;
    //             break;
    //         }
    //     }
    //     if (t) {
    //         count += 1;
    //     }
    // }
    return count;
}


int main () {
    int n;
    cin >> n;
    vector<string> vec(n);
    
    for (int i = 0; i < n; i++) {
        cin >> vec[i];
    }

    vector<int> dp(n, 0);

    for (int i = n - 1; i >= 0; i--) {
        int best = 0;
        for (int j = i + 1; j < min(i + 8, n); j++) {
            int c = count(vec, i, j);
            if (c >= j - i) {
                // can move
                int moves = dp[j] + 1;
                if (best == 0) {
                    best = moves;
                }
                if (moves % 2 == 1 && best % 2 == 0) {
                    best = moves;
                }
                if (moves % 2 == 1) {
                    best = min(best, moves);
                }
            }
        }
        dp[i] = best;
    }

    reverse(dp.begin(), dp.end());

    // for (int i = 0; i < n; i++) {
    //     cout << dp[i] << endl;
    // }

    for (int i = 0; i < n; i++) {
        if (dp[i] % 2 == 1) {
            cout << 1;
        } else {
            cout << 2;
        }
    }
    cout << endl;


    return 0;
}