#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    int result = 0;
    map<int, int> lastDays;
    for (int i = 0; i < n; i++) {
        vector<int> users;
        int k;
        cin >> k;
        int maxDay = 0;
        for (int j = 0; j < k; j++) {
            int user;
            cin >> user;
            int userMaxDay = 0;
            users.push_back(user);
            if (lastDays.find(user) != lastDays.end()) {
                userMaxDay = lastDays[user];
            }
            if (userMaxDay > maxDay) {
                maxDay = userMaxDay;
            }
        }

        for (int user : users) {
            lastDays[user] = maxDay + 1;
        }
        
        if (maxDay + 1 > result) {
            result = maxDay + 1;
        }
    }

    cout << result << endl;
}