#pragma comment(linker, "/STACK:128777216")
#pragma GCC optimize("fast-maths")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("no-stack-protector")
#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <cstring>
#include <vector>
#include <queue>
#include <bitset>
#include <stack>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <climits>
#include <ctime>
#include <random>
#include <complex>
using namespace std;

#define forx(_name, _from, _to, _value) for (int _name = _from; _name < _to; _name += _value)
#define rforx(_name, _from, _to, _value) for (int _name = _from; _name > _to; _name -= _value)
#define all(_STL_NAME) _STL_NAME.begin(), _STL_NAME.end()
#define rall(_STL_NAME) _STL_NAME.rbegin(), _STL_NAME.rend()
#define mp(_FIRST,_SECOND) make_pair(_FIRST, _SECOND)

typedef long long ll;
typedef unsigned long long llu;
typedef long double ld;
const ld eps = 1e-8;
mt19937_64 rndm;

void start() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.precision(10); cout.setf(ios::fixed);
	string FILENAME = "incredible";
	rndm.seed(time(0));
#ifdef _DEBUG
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	//freopen((FILENAME + ".in").c_str(), "rt", stdin);
	//freopen((FILENAME + ".out").c_str(), "wt", stdout);
#endif
}

inline bool FastIn(int& val, FILE* streamin = stdin) {
	val = 0;
	char c = ' ';
	while (!isdigit(c)) {
		c = _getchar_nolock();
		if (c == EOF)
			return false;
	}
	while (isdigit(c)) {
		val *= 10;
		val += c - '0';
		c = _getchar_nolock();
	}
	return true;
}

inline void FastOut(ll val, FILE* streamout = stdout) {
	bool fst = true;
	//const int degree = 1000000000;
	const ll degree = 1000000000000000000ll;
	for (ll i = degree; i > 0; i /= 10) {
		ll dl = val / i;
		if (dl || !fst) {
			_putchar_nolock('0' + dl);
			fst = false;
		}
		val %= i;
	}
	if (fst)
		_putchar_nolock('0');
	_putchar_nolock(' ');
}

ll gcd(ll a, ll b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

int main() {
	start();
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		ll b, d;
		cin >> b >> d;
		ll g = gcd(b, d);
		d /= g;
		cout << b / d - !(b % d) << '\n';
	}
#ifdef _DEBUG
	cout << "\nTime: " << 1.0 * clock() / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}