	#define _CRT_SECURE_NO_WARNINGS
	#include<iostream>
	#include <vector>
	#include <map>
	#include <string>
	#include<unordered_map>
	#include <unordered_set>
	#include<set>
	#include<queue>
	#include<iomanip>
	#include <bitset>
	typedef long long ll;
	using namespace std;
	const int MAXN = 1e5 + 100;
	int numbers[MAXN];


	vector<int> merge_vertices(vector<int> vertexes1, vector<int> vertexes2)
	{
		vector<int> result;
		for (int i = 0; i < vertexes2.size(); ++i)
		{
			result.push_back(vertexes2[i]);
		}
		for (int i = 0; i < vertexes1.size(); ++i)
		{
			result.push_back(vertexes1[i]);
			if (i % 2 == 0)
			{
				for (int j = 0; j < vertexes2.size(); ++j)
				{
					result.push_back(vertexes2[vertexes2.size() - 1 - j]);
				}
			}
			else
			{
				for (int j = 0; j < vertexes2.size(); ++j)
				{
					result.push_back(vertexes2[j]);
				}

			}
		}
		return result;
	}



	vector<int> g[MAXN];
	vector<int> vertexes[MAXN];

	void dfs(int v)
	{
		vertexes[v].push_back(v + 1);

		if (g[v].size() == 0)
		{
			return;
		}

		for (int i = 0; i < g[v].size(); ++i)
		{
			dfs(g[v][i]);
		}
		vector<int> result = vertexes[g[v][0]];
		for (int i = 1; i < g[v].size(); ++i)
		{
			result = merge_vertices(result, vertexes[g[v][i]]);
		}
		for (auto u : result)
		{
			vertexes[v].push_back(u);
		}
	}

	void solve()
	{
		int n;
		cin >> n;
		for (int i = 1; i < n; ++i)
		{
			int v;
			cin >> v;
			v--;
			g[v].push_back(i);
		}
		dfs(0);
		cout << vertexes[0].size() - 1 << '\n';
		for (int i = 1; i < vertexes[0].size(); ++i)
		{
			int u = vertexes[0][i];
			cout << u << ' ';
		}
	}


	int main()
	{
//		freopen("input.in", "r", stdin);
//		freopen("output.out", "w", stdout);

		solve();
		return 0;
	}