#include <bits/stdc++.h>
#include <ext/rope>
#pragma GCC optimize("O3")
using namespace std;
using namespace __gnu_cxx;
#define fs first
#define sc second
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
#define at mutable_reference_at
#define dbg(x) cerr<<#x<<": "<<x<<'\n';
mt19937_64 rnd(time(0));
const int maxn = 3e5 + 100;
const int mod = 1e9 + 7;
// const int mod =  998244353;
const int inf = 1e9;
const ld eps = 1e-9;

int n;

struct let {
    char x;
    bool b;

    bool operator<(const let &v) const {
        if (x == v.x) return b < v.b;
        return x < v.x;
    }
};



string ts(vector<let> &a) {
    string s;
    for (auto i : a) s += i.x;
        return s;
}

struct node {
    node *p[26] = {};
    bool end = 0;
    int cnt = 0;
} trie[maxn * 20];
int cnt_trie = 1;

void add(string s) {
    node *ptr = trie;
    for (auto ch : s) {
        if (ptr->p[ch - 'A'] == nullptr) {
            ptr->p[ch - 'A'] = trie + cnt_trie++;
        }
        ptr = ptr->p[ch - 'A'];
    }
    ptr->end = 1;
}

void update_cnt(vector<let> &t) {
    vector<pair<string, node*> > cur = {{"          ", trie}}, cur1;
    for (int i = 0; i < t.size(); ++i) {
        // dbg(cur.size());
        // dbg(t[i].x);
        cur1.clear();
        for (auto j : cur) {
            if (t[i].b) {
                if (j.sc->p[t[i].x - 'A'] != nullptr) {
                    cur1.push_back({j.fs, j.sc->p[t[i].x - 'A']});
                }
            }
            else {
                int index = t[i].x - '0';
                if (j.fs[index] == ' ') {
                    for (int k = 0; k < 26; ++k) {
                        if (j.sc->p[k] != nullptr) {
                            cur1.push_back({j.fs, j.sc->p[k]});
                            cur1.back().fs[index] = '0' + k;
                        }
                    }
                } 
                else {
                    if (j.sc->p[j.fs[index]-'0'] != nullptr) {
                        cur1.push_back({j.fs, j.sc->p[j.fs[index]-'A']});
                    }
                }
            }
        }
        swap(cur, cur1);
    }
    for (auto i : cur) {
        if (i.sc->end) i.sc->cnt++;
    }
}

vector<string> ans;
void dfs(node *ptr, string cur) {
    if (ptr->end && ptr->cnt > 0) ans.push_back(cur);
    for (int i = 0; i < 26; ++i) {
        if (ptr->p[i] != nullptr) {
            cur += 'A' + i;
            dfs(ptr->p[i], cur);
            cur.pop_back();
        }
    }
}

void get_last(string &a, string &b, vector<let> &lets, vector<int> &p) {
    map<char, int> c2i;
    vector<let> i2l(10, {' ', 0});
    for (int i = 0; i < lets.size(); ++i) {
        c2i[lets[i].x] = p[i];
        i2l[p[i]] = lets[i];
    }
    if (c2i[a[0]] == 0 || c2i[b[0]] == 0) return;
    // for (char i : a) cout<<c2i[i];cout<<endl;
    //     for (char i : b) cout<<c2i[i];cout<<endl;
    vector<int> last;
    int add = 0;
    for (int i = 0; i < max(a.size(), b.size()); ++i) {
        if (i < a.size()) add += c2i[a[a.size()-i-1]];
        if (i < b.size()) add += c2i[b[b.size()-i-1]];
        last.push_back(add % 10);
        add /= 10;
    }
    if (add) last.push_back(add);
    vector<let> res;
    char cnt = '0';
    for (int i = 0; i < last.size(); ++i) {
        // cout<<ts(res)<<endl;
        if (i2l[last[i]].x == ' ') {
            i2l[last[i]] = {cnt++, 0};
            if (int(cnt-'0') + lets.size() > 10) return;
        }
        res.push_back(i2l[last[i]]);
    }
    cout << ts(res) << endl;
    update_cnt(res);
}

int gray_code (int n) {
    return n ^ (n >> 1);
}

int count_bits (int n) {
    int res = 0;
    for (; n; n>>=1)
        res += n & 1;
    return res;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    // freopen("collect.in", "r", stdin);
    // freopen("collect.out", "w", stdout);
#endif

    string a, b, s;
    cin>>a>>b>>n;
    for (int i = 0; i < n; ++i) {
        cin>>s;
        reverse(s.begin(), s.end());
        add(s);
    }

    
    vector<let> letters;
    for (int i = 0; i < a.size(); ++i) {
        bool flag = 1;
        for (let j : letters) {
            if (j.b && j.x == a[i]) {
                flag = 0;
                break;
            }
        }
        if (flag) {
            letters.push_back({a[i], 1});
        }
    }
    for (int i = 0; i < b.size(); ++i) {
        bool flag = 1;
        for (let j : letters) {
            if (j.b && j.x == b[i]) {
                flag = 0;
                break;
            }
        }
        if (flag) {
            letters.push_back({b[i], 1});
        }
    } 

    if (letters.size() > 10) return cout << 0, 0;


    vector<int> f(11);
    f[0] = f[1] = 1;
    for (int i = 1; i <= 10; ++i) f[i] = f[i-1] * i;
    for (int i=0; i<(1<<10); ++i) {
        int cur = gray_code (i);
        if (count_bits (cur) == letters.size()) {
            vector<int> p;
            for (int j=0; j<10; ++j)
                if (cur & (1<<j))
                    p.push_back(j);

            for (int j = 0; j < f[p.size()]; ++j) {
                get_last(a, b, letters, p);
                next_permutation(p.begin(), p.end());
            }
        }
    }

    dfs(trie, "");
    cout<<ans.size()<<'\n';
    for (auto i : ans) {
        reverse(i.begin(), i.end());
        cout<<i<<'\n';
    }
}
