import sys

try:
    import local
    sys.stdin = open('input.txt', 'r')
    sys.stdout = open('output.txt', 'w')
except ImportError:
    # sys.stdin = open('angry.in', 'r')
    # sys.stdout = open('angry.out', 'w')
    pass

import math

    
def extgcd(a, b):
    if a == 0:
        return b, 0, 1
    d, y, x = extgcd(b % a, a)
    return d, x - (b // a) * y, y


def main():
    n = int(input())
    for i in range(n):
        a, b = map(int, input().split())
        d = a * a
        gcd, x0, y0 = extgcd(a, b)
        if d % gcd != 0:
            print(0)
            continue
        d //= gcd
        a //= gcd
        b //= gcd
        x0 *= d
        y0 *= d
        if x0 < 0:
            x0, y0 = y0, x0
            a, b = b, a
        l = -x0 // b
        r = (y0 + a - 1) // a
        # print(l, r)
        print(r - l - 1)




if __name__ == '__main__':
    main()
