#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <random>

#define z std
#define q z::cin
#define w z::cout
#define st z::string

typedef long long int ll;

int nod(ll a, ll b) {
	while (b > 0)
	{
		int r = a % b;
		a = b;
		b = r;
	}
	return a;
}

int main()
{
	z::ios::sync_with_stdio(false);
	q.tie(0); w.tie(0);
	std::random_device rd;  //Will be used to obtain a seed for the random number engine
	std::mt19937 gen(rd()); //Standard mersenne_twister_engine seeded with rd()
	std::uniform_int_distribution<> distrib(1, 1e9);
	int n;
	q >> n;
	srand(time(nullptr));
	for (int i = 0; i < n; i++)
	{
		ll o = 0;
		ll b, d;
		q >> b >> d;
		//d = 1e8 - i;
		//b = d * 3;
		//b = distrib(gen);
		//d = distrib(gen);
		ll g = nod(b, d);
		ll y = 1;
		ll a = b / g;
		if (g == b) {
			w << (b - 1) / 2 << z::endl;
			continue;
		}
		if (g == d) {
			w << (b - 1) << z::endl;
			continue;
		}
		do 
		{
			y = b - (d / g * (a / (b / g)));
			a += b / g;
			o++;
		} while (y > 0);
		o--;
		/*for (int j = 1; j < b; j++)
		{
			if (b * (b - j) % d == 0) {
				//w << j << " " << b * (b - j) / d << z::endl;
				o++;
			}
		}*/
		ll t = d / g;
		ll ans = b / t;
		if (b * (b - 0) % d == 0) {
			ans--;
		}
		/*
		if (ans != o) {
			w << "NO MATCH ON " << b << " " << d << z::endl;
			w << "right: " << o << " my: " << ans << z::endl;
		}
		else {
			//w << b << " " << d << " right: " << o << " my: " << ans << z::endl;
			
		}*/
		w << o << z::endl;
		//w << ans << " " << o  << z::endl;
	}


	return 0;
}