import kotlin.math.min
import kotlin.text.StringBuilder

fun main() {
    val n = readInt()
    val isWinningPosition = BooleanArray(n)
    val steps = ArrayList<String>(n)
    val res = StringBuilder(n)
    for (i in 0 until n) {
        steps.add(readLn())
        val maxSteps = min(8, i)
        for (step in 1..maxSteps) {
            if(step <= diff(steps.last(), steps[i - step])){
                isWinningPosition[i] = !isWinningPosition[i -step] or isWinningPosition[i]
            }
        }
        res.append(if (isWinningPosition[i]) 1 else 2)
    }
    println(res)
}

fun diff(a: String, b: String) : Int{
    var res = 0
    for (i in 0 until 8){
        if(a[i] == b[i]){
            res++
        }
    }
    return res
}

/**
 * IO functions
 */
private fun readLn() = readLine()!!
private fun readInt() = readLn().toInt()
private fun readLong() = readLn().toLong()
private fun readStrings() = readLn().split(" ")
private fun readInts() = readStrings().map { it.toInt() }
private fun readLongs() = readStrings().map { it.toLong() }
private fun readDoubles() = readStrings().map { it.toDouble() }