﻿#include <iostream>
#include <vector>
#include <cmath>
#include <iomanip>
#include <string>
#include <algorithm>
#include <set>
#include <queue>
using namespace std;

bool flag = false;
int lastlevel = 0;
void print(vector<int> tree) {
	int cnt = 1;
	vector<int> name(tree.size());
	for (int i = 0; i < tree.size(); i++) {
		if (tree[i] > 0) {
			name[i] = cnt;
			cnt++;
		}
	}
	for (int i = 0; i < tree.size(); i++) {
		if (tree[i] > 0) {
			cout << tree[i]<<" ";
			if (tree[i * 2 + 1] > 0) cout << name[i * 2 + 1] << " ";
			else cout << "0 ";
			if (tree[i * 2 + 2] > 0) cout << name[i * 2 + 2] << " ";
			else cout << "0 ";
			cout << endl;
		}
	}
}

int sum(vector<int> tree, int v) {
	if (v >= tree.size() || tree[v] == -1)return 0;
	return tree[v] + sum(tree, v * 2 + 1) + sum(tree, v * 2 + 2);
}
bool check(vector<int> tree) {
	for (int i = 0; i < tree.size(); i++) {
		if (abs(sum(tree, i * 2 + 1) - sum(tree, i * 2 + 2)) > 1) {
			return false;
		}
	}
	return true;
}

void fix(vector<int>& tree) {
	tree[pow(2, lastlevel + 1) - 2] = tree[pow(2, lastlevel) - 1];
	tree[pow(2, lastlevel) - 1] = 0;
}
const int S = 17;
int main()
{
	int a, b;
	cin >> a >> b;
	if (a == 0) {
		cout << -1 << endl;
		return 0;
	}
	a--;
	vector<int> tree(pow(2,S), -1);
	tree[0] = 1;
	for (int i = 1; i <= S; i++) {
		int j = pow(2, i) - 1;

		vector<int> q;
		q.push_back(pow(2, i) - 1);
		for (int j = i - 1; j >= 0; j--) {
			int t = q.size();
			for (int p = 0; p < t; p++) {
				q.push_back(q[p] + pow(2,j));
			}
		}
		for (int j = 0; j < q.size(); j++) {
			if (b > 0) {
				tree[q[j]] = 2;
				b--;
				lastlevel = i;
			}
			else if (a > 0) {
				tree[q[j]] = 1;
				a--;
				lastlevel = i;
			}
		}
	}

	if (check(tree))print(tree);
	else {
		
		fix(tree);
		if (check(tree))print(tree);
		else cout << "-1" << endl;
	}
	return 0;
}

