#include <bits/stdc++.h>
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
using namespace std;
using ull = unsigned long long;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;

int ax, ay, bx, by, cx, cy;

optional<ld> intersect(int dx, int dy, int ex, int ey, int y) {
    if ((dy > y && ey > y) || (dy < y && ey < y))
        return {};
    if (dy == y && ey == y)
        return {};
    return dx + (ex - dx) * ((y - dy) / ld(ey - dy));
}

const int mod = 1000000007;
inline int add(int x, int y) {
    int z = x + y;
    if (z >= mod) {
        z -= mod;
    }
    return z;
}
inline int sub(int x, int y) {
    int z = x + mod - y;
    if (z >= mod) {
        z -= mod;
    }
    return z;
}
inline int mul(int x, int y) {
    return (x * (ll)y) % mod;
}
inline int binpow(int x, int p) {
    int ans = 1;
    while (p) {
        if (p & 1) {
            ans = mul(ans, x);
        }
        x = mul(x, x);
        p >>= 1;
    }
    return ans;
}
inline int inv(int x) {
    return binpow(x, mod - 2);
}
int f[4003003];
int fi[4003003];

int ce(int n, int k) {
    if (n < 0 || k < 0 || k > n)
        return 0;
    return mul(f[n], mul(fi[k], fi[n - k]));
}

//int sum2(int col, int mnrow, int mxrow) {
//    int ans = 0;
//    for (int i = mnrow; i <= mxrow; ++i) {
//        ans = add(ans, ce(i, col));
//    }
//    return ans;
//}

int sum(int col, int mnrow, int mxrow) {
    auto z = sub(ce(mxrow + 1, col + 1), ce(mnrow, col + 1));
//    cerr << "! " << mxrow + 1 << " " << col + 1 << " " << ce(mxrow + 1, col + 1) << endl;
//    assert(mxrow + 1 == 42);
    return z;
}

const ld eps = 1e-9;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    f[0] = fi[0] = 1;
    for (int i = 1; i < 4003003; ++i) {
        f[i] = mul(f[i - 1], i);
        fi[i] = inv(f[i]);
    }



    int t;
    cin >> t;
//    int iter = 39;
    while (t--) {
//        ++iter;
        int a, b, c, d, e, z;
//        a = b = 0;
//        c = -iter;
//        d = e = z = iter;
        cin >> a >> b >> c >> d >> e >> z;
        ax = b + a;
        ay = b - a;
        bx = d + c;
        by = d - c;
        cx = z + e;
        cy = z - e;
        int ans = 0;
        for (int i = 0; i <= 2000000; ++i) {
            int y = 2 * i;
            vector<ld> v;
            auto xab = intersect(ax, ay, bx, by, y);
            auto xac = intersect(ax, ay, cx, cy, y);
            auto xcb = intersect(cx, cy, bx, by, y);
            if (xab.has_value()) {
                v.push_back(xab.value());
            }
            if (xac.has_value()) {
                v.push_back(xac.value());
            }
            if (xcb.has_value()) {
                v.push_back(xcb.value());
            }
            if (v.empty())
                continue;
            ld mn = v[0];
            ld mx = v[0];
            for (int j = 1; j < v.size(); ++j) {
                mn = min(mn, v[j]);
                mx = max(mx, v[j]);
            }
            mn /= 2.;
            mx /= 2.;
            int mnint = (int)ceil(mn - eps);
            int mxint = (int)floor(mx + eps);
//            mnint = max(mnint, 0);
            if (mnint > mxint)
                continue;
            int cur = sum(i, mnint + i, mxint + i);
//            int cur2 = sum2(i, mnint + i, mxint + i);
//            if (cur != cur2)
//                assert(false);
//            cerr << i;
//            cerr << " " << mn << " " << mx;
//            cerr << " " << mnint << " " << mxint << " " << cur << endl;
            ans = add(ans, cur);
        }
        cout << ans << "\n";
//        if (ans != sub(binpow(2, iter + 1), 1)) {
//            cerr << iter << endl;
//            return 1;
//        }
    }



}
