#include <bits/stdc++.h>
using namespace std;

using ld = long double;
const int MOD = 1e9 + 7;
const ld eps = 1e-9;
int t, xa, ya, xb, yb, xc, yc;
const int rr = 2 * 1000000 + 100;
long long fact[rr + 5], inv[rr + 5];
std::vector<ld> inters(int xa, int ya, int xb, int yb, int x) {
    if (xb < xa) {
        swap(xa, xb);
        swap(ya, yb);
    }
    if (xa == xb && xa == x) {
        return {ld(min(ya, yb)) - eps, ld(max(ya, yb)) + eps};
    }
    if (xa == xb) {
        return {};
    }
    if (x < xa || x > xb) {
        return {};
    }
    ld scale = (ld(x) - xa) / (xb - xa);
    return {ya + scale * (yb - ya) - eps, ya + scale * (yb - ya) + eps};
}

void rot(int& x, int& y) {
    int tx = x;
    x = x - y;
    y = tx + y;
}

long long bpow(long long x, long long p) {
    if (p == 0) {
        return 1;
    }
    long long res = bpow(x, p / 2);
    res = (res * res) % MOD;
    if (p & 1)
        res = (res * x) % MOD;
    return res;
}

int cnk(int n, int k) {
    if (k > n) {
        return 0;
    }
    return (fact[n] * inv[k] % MOD * inv[n - k] % MOD);
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin >> t;
    fact[0] = 1;
    inv[0] = 1;
    for (int i = 1; i <= rr; i++) {
        fact[i] = (fact[i - 1] * i) % MOD;
    }
    inv[rr] = bpow(fact[rr], MOD - 2);
    for (int i = rr - 1; i >= 1; i--) {
        inv[i] = inv[i + 1] * (i + 1) % MOD;
    }
    while (t--) {
        cin >> xa >> ya >> xb >> yb >> xc >> yc;
        rot(xa, ya);
        rot(xb, yb);
        rot(xc, yc);
        int xmn = min(xa, xb);
        xmn = min(xmn, xc);
        int xmx = max(xa, xb);
        xmx = max(xmx, xc);
        int ans = 0;
        if (xmn % 2 == -1 || xmn % 2 == 1) {
            xmn++;
        }
        for (int x = xmn; x <= 0; x += 2) {
            auto pts = inters(xa, ya, xb, yb, x);
            auto pts2 = inters(xa, ya, xc, yc, x);
            auto pts3 = inters(xc, yc, xb, yb, x);
            for (auto item : pts2) {
                pts.emplace_back(item);
            }
            for (auto item : pts3) {
                pts.emplace_back(item);
            }
            int k = -x;
            k /= 2;
            ld mn = 1e18;
            ld mx = -1e18;
            for (auto item : pts) {
                mn = min(item, mn);
                mx = max(item, mx);
            }
            // cout << mn << "\n";
            int nmin = (int)std::ceil(mn);
            int nmax = (int)std::floor(mx);
            if (nmin % 2 == 1) {
                nmin++;
            }
            if (nmax % 2 == 1) {
                nmax--;
            }
            if (nmax < nmin) {
                continue;
            }
            nmin = max(nmin, 0);
            nmin /= 2;
            nmax /= 2;
            nmin += k;
            nmax += k;
            int res1 = cnk(nmax + 1, k + 1);
            int res2 = cnk(nmin, k + 1);
            int res = (res1 - res2 + MOD) % MOD;
            ans = (ans + res) % MOD;
            // cout << ans << "\n";
        }
        cout << ans << "\n";
    }
    return 0;
}