#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif
//#pragma GCC optimize("O3")
#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

//const ll p = 1e9 + 7;

//ll Mul(ll &x, ll y) {
//    return (x *= y) %= p;
//}
//
//ll Add(ll &x, ll y) {
//    return (x += y) %= p;
//}
//
//ll Pow(ll x, ll pw) {
//    if (pw == 0) {
//        return 0;
//    }
//    ll res = 1;
//    if (x % 2 == 1) {
//        Mul(res, x);
//    }
//    Mul(x, x);
//    Mul(res, Pow(x, pw / 2));
//    return res;
//}
//ll Inv(ll x) {
//    return Pow(x, p - 2);
//}


void Move(int idx,
          vector<int> &pos,
          vector<int> &ans,
          vector<vector<int>> &c,
          vector<vector<int>> &d) {
    vector<pair<int, int>> state;
    int sum = 0;
    for (int j = 0; j < c[idx].size(); ++j) {
        state.emplace_back(pos[j], c[idx][j]);
        sum += c[idx][j];
    }
    for (int j = 0; j < d[idx].size(); ++j) {
        state.emplace_back(ans[j], d[idx][j]);
        sum += d[idx][j];
    }
    sort(state.begin(), state.end());
    int cur = 0;
    for (auto[posj, cost]: state) {
        cur += cost;
        if (cur * 2 >= sum) {
            ans[idx] = posj;
            break;
        }
    }
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#else
    //    freopen("lupa.in","r",stdin);
    //    freopen("pupa.out","w",stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << setprecision(10);
    cout << fixed;
//    vector<int>
    int n, m;
    cin >> n >> m;
    vector<int> pos(m);
    for (int i = 0; i < m; ++i) {
        cin >> pos[i];
    }
    vector<int> ans(n, 0);
    vector<vector<int>> c(n);
    for (int i = 0; i < n; ++i) {
//        vector<int> a(m);
        c[i].resize(m);
        for (int j = 0; j < m; ++j) {
            cin >> c[i][j];
        }
    }

    vector<vector<int>> d(n);
    for (int i = 0; i < n; ++i) {
//        vector<int> a(m);
        d[i].resize(n);
        for (int j = 0; j < n; ++j) {
            cin >> d[i][j];
        }
    }
    vector<vector<int>> init(n, vector<int>(n, 0));
    for (int i = 0; i < n; ++i) {
        Move(i, pos, ans, c, init);
    }
//    return 0;
    for (int time_ = 0; time_ < 1e5; ++time_) {
        for (int i = 0; i < n; ++i) {
            Move(i, pos, ans, c, d);
        }
    }
//    return 0;
    ll res = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            res += abs(pos[j] - ans[i]) * c[i][j];
        }
        for (int j = 0; j < n; ++j) {
            res += abs(ans[j] - ans[i]) * d[i][j];
        }
    }
    cout <<  res;
    cout << '\n';
    for (int i = 0; i < n; ++i) {
        cout << ans[i] << " ";
    }
    return 0;
}