#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define ll long long
#define ld long double
#define F first
#define S second
#define pb push_back
#define sqr(x) (x) * (x)

using namespace std;
using namespace __gnu_pbds;

//mt19937_64 gen(time(0));

// typedef tree<
// pair <int, int>,
// null_type,
// less<int>,
// rb_tree_tag,
// tree_order_statistics_node_update>
// ordered_set;

//const ll mod = 1e9 + 7;
// const int inf = 1e9;
const int maxn = 3e5;
// const int k = 25;

int ans[maxn];

cc_hash_table<string, int> templ;

int CountOfUnique(const string& str1) {
  static bool used[26];
  fill(used, used + 26, false);
  for (char c : str1) {
    used[c - 'A'] = true;
  }
  int cnt_unique = 0;
  for (int i = 0; i < 26; ++i) {
    if (used[i]) {
      ++cnt_unique;
    }
  }
  return cnt_unique;
}

bool un[26];

string str1, str2;

vector<char> un_let;
int num_char[26];

bool used_dig[10];
int per[11];

// res, cnt new chars
pair<string, int> GetSum() {
  static char dig_to_char[26];

  fill(dig_to_char, dig_to_char + 26, '.');

  int a = 0;
  for (char c : str1) {
    a *= 10;
    int digit = per[num_char[c - 'A']];
    a += digit;
    dig_to_char[digit] = c;
  }

  int b = 0;
  for (char c : str2) {
    b *= 10;
    int digit = per[num_char[c - 'A']];
    b += digit;
    dig_to_char[digit] = c;
  }

  int c = a + b;
  string res;

  char lst_unused = 'a';

  do {
    int digit = c % 10;

    // Если цифра есть, то соотв A..Z, иначе a..z
    if (dig_to_char[digit] == '.') {
      dig_to_char[digit] = lst_unused++;
    }
    res += dig_to_char[digit];

    c /= 10;
  } while (c > 0);

  reverse(res.begin(), res.end());

  return {res, lst_unused - 'a'};
}

bool leading[26];

void GenPer(int num) {
  if (num == un_let.size()) {
    auto pp = GetSum();
    string res = pp.F;
    if (un_let.size() + pp.S > 10) {
      return;
    }
    ++templ[pp.F];  // шаблон
    return;
  }
  for (int i = 0; i < 10; ++i) {
    if (!used_dig[i] && !(leading[un_let[num] - 'A'] && i == 0)) {
      per[num] = i;
      used_dig[i] = true;
      GenPer(num + 1);
      used_dig[i] = false;
    }
  }
}

vector<char> GetUniqueVec(const string& str) {
  static bool used[26];
  fill(used, used + 26, false);

  vector<char> uniques;

  for (char c : str) {
    used[c - 'A'] = true;
  }

  for (int i = 0; i < 26; ++i) {
    if (used[i]) {
      uniques.pb('A' + i);
    }
  }
  return uniques;
}

char new_char[26];

signed main() {
  cin.tie(0);
  cout.tie(0);
  ios_base::sync_with_stdio(false);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else

#endif
  cin >> str1 >> str2;

  leading[str1[0] - 'A'] = true;
  leading[str2[0] - 'A'] = true;

  for (char c : str1) {
    un[c - 'A'] = true;
  }
  for (char c : str2) {
    un[c - 'A'] = true;
  }

  for (int i = 0; i < 26; ++i) {
    if (un[i]) {
      num_char[i] = un_let.size();
      un_let.push_back('A' + i);
    }
  }

  if (un_let.size() > 10) {
    cout << 0;
    return 0;
  }
  GenPer(0);

  vector<string> ans_str;

  int n;
  cin >> n;
  for (int i = 0; i < n; ++i) {
    string word;
    cin >> word;
    // точно нет
    auto unique_let = GetUniqueVec(word);
    if (unique_let.size() > 10) {
      continue;
    }

    int cnt_tmpl = 0;


    for (int msk = 0; msk < (1 << unique_let.size()) && cnt_tmpl < 2; ++msk) {
      fill(new_char, new_char + 26, '.');
      for (int j = 0; j < unique_let.size(); ++j) {
        if ((msk >> j) & 1) {
          new_char[unique_let[j] - 'A'] = unique_let[j];
        }
      }

      char least_unused = 'a';

      string templt;
      templt.reserve(unique_let.size());

      for (char c : word) {
        if (new_char[c - 'A'] == '.') {
          new_char[c - 'A'] = least_unused++;
        }
        templt += new_char[c - 'A'];
      }
      cnt_tmpl += templ[templt];
    }
    if (cnt_tmpl == 1) {
      ans_str.push_back(word);
    }
  }
  cout << ans_str.size() << '\n';
  for (auto& str : ans_str) {
    cout << str << '\n';
  }
  return 0;
}
