memory = dict()
banned = set()
found = False
bad = False


def solve(a, b, s, start=0, canary=0, force=False):
    if force:
        memory[s[-1]] = 1
        banned.add(1)

    global found, bad
    mx = max(len(a), max(len(b), len(s)))
    if start == mx:
        if found:
            bad = True
        found = True
        #print(s)
        #for key, value in memory.items():
        #    print(key, ':', value)
        return

    index = start
    for _ in range(1):
        if index >= len(a):
            numbers_a = [0]
        else:
            if a[index] not in memory:
                numbers_a = [1, 2, 3, 4, 5, 6, 7, 8, 9]
                if index + 1 != len(a):
                    numbers_a.append(0)
                numbers_a = set(numbers_a)
                numbers_a.difference_update(banned)
            else:
                numbers_a = [memory[a[index]]]

        if index >= len(b):
            numbers_b = [0]
        else:
            if b[index] not in memory:
                numbers_b = [1, 2, 3, 4, 5, 6, 7, 8, 9]
                if index + 1 != len(b):
                    numbers_b.append(0)
                numbers_b = set(numbers_b)
                numbers_b.difference_update(banned)
            else:
                numbers_b = [memory[b[index]]]

        if (a[index] in memory) and (b[index] in memory):
            x = numbers_b[0] + numbers_a[0] + canary

            if x > 9:
                xx = x - 10
                nw = 1
            else:
                xx = x
                nw = 0

            if s[index] in memory:
                if memory[s[index]] == xx:
                    solve(a, b, s, canary=nw, start=index + 1)
                    if bad:
                        return
                else:
                    return  # wrong answer
                return
            else:
                if xx in banned:
                    return
                else:
                    memory[s[index]] = xx
                    banned.add(xx)
                    solve(a, b, s, start=index + 1, canary=nw)
                    if bad:
                        return
                    banned.remove(xx)
                    del memory[s[index]]
                    return

        for possible_a in numbers_a:
            for possible_b in numbers_b:

                x = possible_b + possible_a + canary
                s_inserted = False
                a_inserted = False
                b_inserted = False

                if x > 9:
                    xx = x - 10
                    nw = 1
                else:
                    xx = x
                    nw = 0

                if s[index] in memory and memory[s[index]] != xx:
                    continue  # wrong answer

                if s[index] not in memory and xx in banned:
                    continue  # wrong answer

                if s[index] not in memory and xx not in banned:
                    s_inserted = True
                    banned.add(xx)
                    memory[s[index]] = xx

                if a[index] in memory and memory[a[index]] != possible_a:
                    if s_inserted:
                        banned.remove(xx)
                        del memory[s[index]]
                    continue

                if a[index] not in memory and possible_a in banned:
                    if s_inserted:
                        banned.remove(xx)
                        del memory[s[index]]
                    continue

                if a[index] not in memory and possible_a not in banned:
                    a_inserted = True
                    banned.add(possible_a)
                    memory[a[index]] = possible_a

                if b[index] in memory and memory[b[index]] != possible_b:
                    if s_inserted:
                        banned.remove(xx)
                        del memory[s[index]]
                    if a_inserted:
                        banned.remove(possible_a)
                        del memory[a[index]]
                    continue

                if b[index] not in memory and  possible_b in banned:
                    if s_inserted:
                        banned.remove(xx)
                        del memory[s[index]]
                    if a_inserted:
                        banned.remove(possible_a)
                        del memory[a[index]]
                    continue

                if b[index] not in memory and possible_b not in banned:
                    b_inserted = True
                    banned.add(possible_b)
                    memory[b[index]] = possible_b

                solve(a, b, s, canary=nw, start=index + 1)
                if bad:
                    return

                if s_inserted:
                    banned.remove(xx)
                    del memory[s[index]]
                if a_inserted:
                    banned.remove(possible_a)
                    del memory[a[index]]
                if b_inserted:
                    banned.remove(possible_b)
                    del memory[b[index]]


def main():
    first = input()
    second = input()

    memory['#'] = 0

    mx_len = max(len(first), len(second))
    
    n = int(input())
    
    answers = list()
    
    first = first[::-1]
    second = second[::-1]
    force = False
    for _ in range(n):
        global found, bad
        found = False
        bad = False
        temp = input()
        memory.clear()
        memory['#'] = 0
        banned.clear()
        if len(temp) < mx_len or len(temp) > mx_len + 1:
            continue

        if mx_len + 1 == len(temp):
            force = 1
        nnn = max(mx_len, len(temp))

        solve(first + '#' * (nnn - len(first)), second + '#' * (nnn - len(second)), temp[::-1], start=0, canary=0, force=force)
        if found and not bad:
            answers.append(temp)

    print(len(answers))
    for e in answers:
        print(e)


if __name__ == "__main__":
    main()
