def gcd(a, b):
    if a == 0:
        return b, 0, 1

    d, x1, y1 = gcd(b % a, a)
    x = y1 - (b // a) * x1
    y = x1
    return d, x, y

def find_any(a, b, c, x0, y0, g):
    g, x0, y0 = gcd(abs(a), abs(b))
    if c % g != 0:
        return False, x0, y0, g
    x0 *= c // g
    y0 *= c // g
    if a < 0:
        x0 *= -1
    if b < 0:
        y0 *= -1
    return True, x0, y0, g

def shift(x, y, a, b, cnt):
    x += cnt * b
    y -= cnt * a
    return x, y

def find_all(a, b, c, minx, maxx, miny, maxy):
    x = 0
    y = 0
    g = 0
    flg, x, y, g = find_any(a, b, c, x, y, g)
    if not flg:
        return 0

    a //= g
    b //= g

    sign_a = 0
    if a > 0:
        sign_a = 1
    else:
        sign_a = -1

    if b > 0:
        sign_b = 1
    else:
        sign_b = -1

    x, y = shift(x, y, a, b, (minx - x) // b)
    if x < minx:
        x, y = shift(x, y, a, b, sign_b)
    if x > maxx:
       return 0

    lx1 = x

    x, y = shift(x, y, a, b, (maxx - x) // b)
    if x > maxx:
        x, y = shift(x, y, a, b, -sign_b)

    rx1 = x

    x, y = shift(x, y, a, b, - (miny - y) // a)
    if y < miny:
        x, y = shift(x, y, a, b, -sign_a)
    if y > maxy:
        return 0
    lx2 = x

    x, y = shift(x, y, a, b, - (maxy - y) // a)
    if y > maxy:
        x, y = shift(x, y, a, b, sign_a)
    rx2 = x

    if lx2 > rx2:
        lx2, rx2 = rx2, lx2

    lx = max(lx1, lx2)
    rx = min(rx1, rx2)

    return (rx - lx) // abs(b) + 1


n = int(input())

for _ in range(n):
    b, d = map(int, input().split())
    print(find_all(d, b, b * b, 1, int(1e20), 1, int(1e20)))









