﻿#include <iostream>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <list>
#include <iomanip>
#include <fstream>
#include <queue>
#include <sstream>
#include <cctype>
#include <unordered_map>
#include <numeric>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair <ll, ll> pll;

deque<ll> goDeep(vector<vector<ll>>& A, ll cur, deque<ll>& lastRes)
{
    deque<ll> inC = { lastRes.begin(), lastRes.end() };
    inC.push_back(cur);
    reverse(lastRes.begin(), lastRes.end());
    for (auto& way : A[cur])
    {
        deque<ll> newVec = goDeep(A, way, lastRes);
        lastRes = newVec;
        /*deque<ll> inCCopy(inC.size());
        reverse_copy(inC.begin(), inC.end(), begin(inCCopy));
        inC.insert(inC.end(), newVec.begin(), newVec.end());
        inC.insert(inC.end(), inCCopy.begin(), inCCopy.end());*/
    }
    inC.insert(inC.end(), lastRes.begin(), lastRes.end());
    return inC;
}

int main()
{
    ios_base::sync_with_stdio(0);
    //ifstream cin("filter.in");
    //ofstream cout("filter.out");
    ll n;
    cin >> n;
    vector<vector<ll>> A(n + 1, vector<ll>());
    for (ll i = 2; i <= n; ++i)
    {
        ll a;
        cin >> a;
        A[a].push_back(i);
    }
    deque<ll> t;
    deque<ll> res = goDeep(A, 1, t);
    cout << res.size() - 1 << '\n';
    for (ll i = 1; i < res.size(); ++i)
        cout << res[i] << ' ';
}
