#define _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_DEPRECATE
#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<string>
#include<cstring>
#include<algorithm>
#include<cmath>
#include <set>
#include <queue>
#include <map>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <assert.h>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef double db;
typedef long double ldb;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef int Int;
#define mp make_pair
const int nmax = 1e+6 + 3;
const int mod = 1e+9 + 7;
const int p = 1e+6 + 3;

int cnt[3] = { 1, 1, 2 }; 
int minPr = 1e+6;
int packNumber = 0;
ll A, B, C, D;


long long gcd(long long a, long long b, long long& x, long long& y) {
	if (a == 0) {
		x = 0; y = 1;
		return b;
	}
	long long x1, y1;
	long long d = gcd(b % a, a, x1, y1);
	x = y1 - (b / a) * x1;
	y = x1;
	return d;
}

bool find_any_solution(long long a, long long b, long long c,
	long long& x0, long long& y0, long long& g) {
	g = gcd(abs(a), abs(b), x0, y0);
	if (c % g != 0)
		return false;
	x0 *= c / g;
	y0 *= c / g;
	if (a < 0)   x0 *= -1;
	if (b < 0)   y0 *= -1;
	return true;
}


void shift_solution(long long& x, long long& y, long long a, int b, long long cnt) {
	x += cnt * b;
	y -= cnt * a;
}

long long find_all_solutions(long long a, long long b, long long c,
	long long minx, long long maxx, long long miny, long long maxy) {
	long long x, y, g;
	if (!find_any_solution(a, b, c, x, y, g))
		return 0;
	a /= g;  b /= g;

	int sign_a = a > 0 ? +1 : -1;
	int sign_b = b > 0 ? +1 : -1;

	shift_solution(x, y, a, b, (minx - x) / b);
	if (x < minx)
		shift_solution(x, y, a, b, sign_b);
	if (x > maxx)
		return 0;
	ll lx1 = x;

	shift_solution(x, y, a, b, (maxx - x) / b);
	if (x > maxx)
		shift_solution(x, y, a, b, -sign_b);
	ll rx1 = x;

	shift_solution(x, y, a, b, -(miny - y) / a);
	if (y < miny)
		shift_solution(x, y, a, b, -sign_a);
	if (y > maxy)
		return 0;
	ll lx2 = x;

	shift_solution(x, y, a, b, -(maxy - y) / a);
	if (y > maxy)
		shift_solution(x, y, a, b, sign_a);
	ll rx2 = x;

	if (lx2 > rx2)
		swap(lx2, rx2);
	ll lx = max(lx1, lx2);
	ll rx = min(rx1, rx2);

	return (rx - lx) / abs(b) + 1;
}


void solve() {
	cin >> B >> D;

	ll a, b, c, x0, y0, g;
	a = D;
	b = B;
	c = B * B;

	cout << find_all_solutions(a, b, c, 1, B * B, 1, B * B) << endl;
}


int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	ios::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		solve();
	}
	return 0;
}