def gcd(a, b, x, y):
    if a == 0:
        x[0] = 0
        y[0] = 1
        return b
    x1 = [0]
    y1 = [0]
    d = gcd(b % a, a, x1, y1)
    x[0] = y1[0] - int(b / a) * x1[0]
    y[0] = x1[0]
    return d


def find_any_solution(a, b, c, x0, y0, g):
    g[0] = gcd(abs(a), abs(b), x0, y0)
    if c % g[0] != 0:
        return False
    
    x0[0] *= int(c / g[0])
    y0[0] *= int(c / g[0])
    if a < 0:
        x0[0] *= -1
    if b < 0:
        y0[0] *= -1
    return True


def shift_solution(x, y, a, b, cnt):
    x[0] += cnt * b
    y[0] -= cnt * a


def find_all_solutions(a, b, c, minx, maxx, miny, maxy):
    x = [0]
    y = [0]
    g = [0]
    if not find_any_solution (a, b, c, x, y, g):
        return 0
    
    a = int(a / g[0])
    b = int(b / g[0])

    sing_a = -1
    if a > 0:
        sign_a = 1
    sing_b = -1
    if b > 0:
        sign_b = 1
    
    shift_solution(x, y, a, b, int((minx - x[0]) / b))
    if x[0] < minx:
        shift_solution (x, y, a, b, sign_b)
    if x[0] > maxx:
        return 0
    lx1 = x[0]

    shift_solution (x, y, a, b, int((maxx - x[0]) / b))
    if x[0] > maxx:
        shift_solution (x, y, a, b, -sign_b)
    rx1 = x[0]

    shift_solution (x, y, a, b, - int((miny - y[0]) / a))
    if y[0] < miny:
        shift_solution (x, y, a, b, -sign_a)
    if y[0] > maxy:
        return 0
    lx2 = x[0]
 
    shift_solution (x, y, a, b, - int((maxy - y[0]) / a))
    if y[0] > maxy:
        shift_solution (x, y, a, b, sign_a)
    rx2 = x[0]

    if (lx2 > rx2):
        lx2, rx2 = rx2, lx2

    lx = max(lx1, lx2)
    rx = min(rx1, rx2)

    return int((rx - lx) / abs(b)) + 1


def solve():
    A = list(map(int, input().split()))
    B, D = A[0], A[1]

    a = D
    b = B
    c = B * B

    print(find_all_solutions(a, b, c, 1, 1000000000000000000, 1, 1000000000000000000))


n = int(input())
for _ in range(n):
    solve()
