#define _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_DEPRECATE
#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<string>
#include<cstring>
#include<algorithm>
#include<cmath>
#include <set>
#include <queue>
#include <map>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <assert.h>
 
using namespace std;
struct node {
    int value;
    int lc;
    int rc;
    int vmax;
    int vmin;
    node(int v, int l, int r, int c = 0)
    {
        value = v, lc = l, rc = r;
        vmax = -2e+9;
        vmin = 2e+9;
    }
    node() {
 
    }
};
 
node tree[200500];
int a;


int count_clilds(int v)
{
    if (tree[v].lc == 0 && tree[v].rc == 0)
    {
        tree[v].vmax = tree[v].value;
        tree[v].vmin = tree[v].value;
        return 1;
    }
    if (tree[v].lc) {
        count_clilds(tree[v].lc);
        tree[v].vmin = min(tree[tree[v].lc].vmin, tree[v].value);
    }    
    else {
        tree[v].vmin = tree[v].value;
    }
    if (tree[v].rc) {
        count_clilds(tree[v].rc);
        tree[v].vmax = max(tree[tree[v].rc].vmax, tree[v].value);
    }
    else {
        tree[v].vmax = tree[v].value;
    }
 
    return 0;
}
 
int count_lookups2(int v, int lb, int rb)
{
    int ans = 0;
    if (v == 0)
        return 0;
    if (lb <= tree[v].vmin && tree[v].vmax <= rb)
        return 0;
    if (tree[v].vmax < lb || rb < tree[v].vmin)
        return 0;
 
    if (tree[v].lc)
        ans += count_lookups2(tree[v].lc, lb, rb) + 1;
    else
        ans += 1;
 
    if (tree[v].rc) {
        ans += count_lookups2(tree[v].rc, lb, rb) + 1;
    }
    else {
        ans += 1;
    }
    return ans;
}
int main()
{
    //freopen("input.txt", "r", stdin); //freopen("output.txt", "w", stdout);
    //ios::sync_with_stdio(0);
    //cin.tie(0);
    node asd(0, 0, 0);
    tree[0] = asd;
 
    scanf("%d", &a);
    for (int i = 0; i < a; ++i)
    {
        int tml, tmr, tmv;
        scanf("%d%d%d", &tml, &tmr, &tmv);
        node tmp(tmv, tml, tmr);
        tree[i + 1] = tmp;
    }
    count_clilds(1);
    int n_tests;
    scanf("%d", &n_tests);
    int maxans = count_lookups2(1, tree[1].vmax, tree[1].vmax) + 1;
    int minans = count_lookups2(1, tree[1].vmin, tree[1].vmin) + 1;
    for (int i = 0; i < n_tests; ++i)
    {
        int tlb, trb;
        scanf("%d%d", &tlb, &trb);
        if (tlb >= tree[1].vmax)
            printf("%d\n", maxans);
        else if (trb >= tree[1].vmax)
            printf("%d\n", minans);
        else
        {
        int result = count_lookups2(1, tlb, trb) + 1;
        printf("%d\n", result);
        }
    }
    return 0;
}