#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>

#define E1 10
#define E2 100
#define E3 1000
#define E4 10000
#define E5 100000
#define E6 1000000
#define E7 10000000

using namespace std;

void solve();

int main() {
#ifdef MYDEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(0);
    cin.sync_with_stdio(false);
    cout.precision(12);
    solve();
}

void solve() {
    int n;
    cin >> n;
    int ans = 1;
    set<int> s;
    while (n--) {
        int k;
        cin >> k;
        vector<int> v;
        while (k--) {
            int x;
            cin >> x;
            v.push_back(x);
        }
        bool has = false;
        for (auto x : v) {
            if (s.find(x) != s.end()) {
                has = true;
                break;
            }
        }
        if (has) {
            ans++;
            s.clear();
        }
        for (auto x : v) {
            s.insert(x);
        }
    }
    cout << ans;
}