#include <iostream>
#include <cstdlib>
#include <sstream>
#include "set"
#include "map"
#include "vector"
#include "string"
using namespace std;
#define cheat ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr)
#define int long long


int ind = 1;
vector<int> answer;
void add(int a,int b,int c) {
    answer.emplace_back(a);
    answer.emplace_back(b);
    answer.emplace_back(c);
}

int* shuffle(int a, int b) {
    int *result = (int *)malloc(4*sizeof(int));
    if(b%2==0) {
        result[0] = a/2+a%2;
        result[1] = b/2;
        result[2] = a/2;
        result[3] = b/2;
    }
    else {
        result[0] = a/2+a%2+1;
        result[1] = b/2;
        result[2] = a/2 - 1;
        result[3] = b/2 + 1;
    }
    return result;
}
bool build(int a, int b) {
    if(a<0 || b<0) {
        return false;
    }
    if(a+b==0) return true;
    if((a+b%2)==0) {
        return false;
    }
    if(b!=0) {
        if(a+b==1) {
            add(2,0,0);
            ind++;
            return true;
        }
        else if(a+b==2) {
            add(2, ind+1, 0);
            ind++;
            int *shuffled = shuffle(a,b-1);
            return build(shuffled[0], shuffled[1]) && build(shuffled[2], shuffled[3]);
        }
        else {
            int *shuffled = shuffle(a,b-1);
            add(2, ind+1, ind+1+shuffled[0]+shuffled[1]);
            ind++;
            return build(shuffled[0], shuffled[1]) && build(shuffled[2], shuffled[3]);
        }
    }
    else {
        if(a+b==1) {
            add(1,0,0);
            ind++;
            return true;
        }
        else if(a+b==2) {
            add(1, ind+1, 0);
            ind++;
            int *shuffled = shuffle(a-1,b);
            return build(shuffled[0], shuffled[1]) && build(shuffled[2], shuffled[3]);
        }
        else {
            int *shuffled = shuffle(a-1,b);
            add(1, ind+1, ind+1+shuffled[0]+shuffled[1]);
            ind++;
            return build(shuffled[0], shuffled[1]) && build(shuffled[2], shuffled[3]);
        }
    }
}

signed main() {
    cheat;
    int a,b;
    cin >> a >> b;
    if(build(a,b)) {
        for (int i = 0; i < answer.size(); ++i) {
            cout << answer[i];
            if(i%3==2) cout << endl;
            else cout << ' ';
        }
    }
    else cout << -1 << endl;
    return 0;
}