#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <cstddef>
#include <cstring>
#include <bitset>
#include <random>
#include <memory>
#include <iomanip>

typedef long long ll;
typedef long double ld;

using namespace std;

const int BIT = 8;
const int MX = 3e5 + 7;
int cnt[1 << BIT];
vector<int> masks;
int n;

int dp[MX][BIT];
int g[MX];


int val[1 << BIT];
int p[MX * (1 << BIT)];
int col[MX];

int main() {

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);

    cin >> n;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        int mask = 0;
        for (int j = 0; j < BIT; j++) {
            if (s[j] == 'W') mask |= (1 << j);
        }
        masks.push_back(mask);
    }
    for (int i = 0; i < (1 << BIT); i++) {
        for (int j = 0; j < BIT; j++) {
            if (i & (1 << j)) cnt[i]++;
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 1; j <= 8 && i + j < n; j++) {
            if (BIT - cnt[masks[i] ^ masks[i + j]] >= j) {
                g[i] |= (1 << (BIT - j));
            }
        }
    }

    for (int i = n - 1; i >= 0; i--) {
        col[i] = ((i + 1) * (1 << BIT));
        for (int mask = 0; mask < (1 << BIT); mask++) {
            int n_mask = (mask >> 1);
            if ((g[i] & mask) == 0) n_mask |= (1 << (BIT - 1));
            p[mask + (i + 1) * (1 << BIT)] = n_mask + i * (1 << BIT);
        }
    }


    vector<int> ans(n);
    for (int i = 2; i <= n; i++) {
        for (int j = 0; j < (1 << BIT); j++) {
            int val = j + i * (1 << BIT);
            p[val] = p[p[val]];
        }
    }
    for (int i = 0; i < n; i++) {
        if (p[col[i]] & (1 << (BIT - 1))) {
            cout << 2;
        } else {
            cout << 1;
        }
    }
    cout << '\n';




    return 0;
}
