#ifdef ONPC
    #define _GLIBCXX_DEBUG
    #define deb(a) cerr << "========" << #a << " = " << a << endl;
#else
    #define deb(a)
#endif
#define sz(a) ((int)((a).size()))
#include <bits/stdc++.h>
#define char unsigned char

using namespace std;
mt19937 rnd(239);
// mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;
const int INF = 1e9 + 7;
int bst[2][2][3];
int X = 2 * 2 * 3 + 1;

pair<pair<int, int>, pair<int, int>> get_cost(int a) {
    if (a == X - 1) {
        return {{0, 0}, {0, 0}};
    }
    int t = a % 3;
    a /= 3;
    int o = a % 2;
    a /= 2;
    int z = a % 2;
    return {{z, o}, {t, bst[z][o][t]}};
}

int solve()
{
    int n;
    if (!(cin >> n))
        return 1;
    int bst = -1, cst = INF;
    for (int i = 0; i < n; i++) {
        int co;
        cin >> co;
        string s;
        cin >> s;
        int o = 0, z = 0, t = 0;
        for (int j = 0; j < sz(s); j++) {
            char c = s[j];
            if (c == '0') {
                z++;
            } else if (c == '1') {
                o++;
            } else if (c == '2') {
                t++;
            }
        }
        if (z >= 1 && o >= 1 && t >= 2 && cst > co) {
            bst = i;
            cst = co;
        }
    }
    cout << bst + 1 << endl;
    return 0;
}

int32_t main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int TET = 1e9;
    //cin >> TET;
    for (int i = 1; i <= TET; i++)
    {
        if (solve())
            break;
        cout << '\n';
        #ifdef ONPC
            cout << "\n__________________________" << endl;
        #endif
    }
    #ifdef ONPC
        cerr << endl << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
    #endif
}
