#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <unordered_set>
#include <string>
#include <map>
#include <unordered_map>
#include <queue>
#include <assert.h>
#include <cmath>
#include <sstream>

using namespace std;
typedef long long ll;
typedef long double ld;

const ll linf = (ll)1e18 + 10;
const int iinf = (int)1e9 + 10;
const int mod = 998244353;
const int modd = 1000000007;
const ld PI = acos(-1);
#define all(x) x.begin(), x.end()

const int maxn = 5e5 + 10;
int tr[maxn], w[maxn];
int used[maxn];

void gen_tree(int root, int sz, int ww){
    if (sz == 0) return;
    used[root] = ww;
    tr[root] = root / 2; w[root] = ww;
    gen_tree(2*root, sz / 2, ww);
    gen_tree(2*root + 1, (sz - 1) / 2, ww);
}

void gen_tree_x(int root, int sz, int ww){
    gen_tree(2*root, (sz+1) / 2, ww);
    gen_tree(2*root + 1, sz / 2, ww);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int a, b;
    cin >> a >> b;

    if (b != 0) {

        gen_tree(1, b, 2);
        vector<int> cnt(maxn, 0);
        for (int i = 0; i < maxn; i++) {
            if (used[i]) cnt[tr[i]]++;
        }
        int c0 = 0, c1 = 0;
        for (int i = 0; i < maxn; i++) {
            if (used[i]) {
                if (cnt[i] == 1) c1++;
                if (cnt[i] == 0) c0++;
            }
        }
        if (a < c1) {
            cout << -1;
            return 0;
        }
        a -= c1;
        int left = a % (c0 + c1);
        for (int i = 0; i < maxn; i++) {
            if (used[i] == 2 && cnt[i] == 1) {
                if (left > 0) {
                    left--;
                    gen_tree(2 * i + 1, a / (c0 + c1) + 2, 1);
                } else {
                    gen_tree(2 * i + 1, a / (c0 + c1) + 1, 1);
                }
            }
        }
        for (int i = 0; i < maxn; i++) {
            if (used[i] == 2 && cnt[i] == 0) {
                if (left > 0) {
                    left--;
                    gen_tree_x(i, a / (c0 + c1) + 1, 1);
                } else {
                    gen_tree_x(i, a / (c0 + c1), 1);
                }
            }
        }
    }
    else{
        gen_tree(1, a, 1);
    }

    int ii = 1;
    vector <int> newnum(maxn);
    vector <vector <int>> gr(maxn);
    for (int i = 0; i < maxn; i++){
        if (used[i]){
            newnum[i] = ii; ii++;
            gr[newnum[tr[i]]].push_back(newnum[i]);
        }
    }
    for (int i = 0; i < maxn; i++){
        if (used[i]){
            int ii = newnum[i];
            while (gr[ii].size() < 2) gr[ii].push_back(0);
            cout << w[i] << " " << gr[ii][0] << " " << gr[ii][1] << "\n";
        }
    }

    return 0;
}