#include <bits/stdc++.h>

using namespace std;

const int maxN = 300020;

string arr[maxN];
int go[maxN][9];
int dp[maxN][256];

int cmp(const string& s1, const string& s2) {
    int cnt = 0;
    for (int i = 0; i < 8; i++) {
        cnt += (s1[i] == s2[i]);
    }
    return cnt;
}

void build_go(int n) {
    for (int i = 0; i < n; i++) {
        for (int k = 1; k <= 8 && i + k < n; k++) {
            go[i][k] = (k <= cmp(arr[i], arr[i + k]));
        }
    }
}

int main() {
    //freopen("in.in", "r", stdin);
    //freopen("in.out", "w", stdout);

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n;
    cin >> n;

    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }

    build_go(n);

    for (int mask = 0; mask < 256; mask++) {
        dp[0][mask] = (mask & 1);
    }

    for (int i = 0; i < n; i++) {
        for (int mask = 0; mask < 256; mask++) {
            int was = 0;
            for (int k = 0; k < 8; k++) {
                if (!go[i][k + 1]) continue;
                if (!((mask >> k) & 1)) was = 1;
            }
            int mask2 = (mask << 1) & 255;
            mask2 |= was;
            dp[i + 1][mask] = dp[i][mask2];
        }
        cout << (dp[i + 1][255] ? "1" : "2");
       // return 0;
    }

    return 0;
}
