#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
using namespace std;
#define F first
#define S second
#define pb push_back  
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)(x).size()
#define int ll
 
const int N = 2e5 + 10;
int mn[N], mx[N], l[N], r[N], k[N], par[N];

void dfs(int v) {
  mn[v] = mx[v] = k[v];
  if (l[v]) {
    dfs(l[v]);
    par[l[v]] = v;
    mn[v] = min(mn[v], mn[l[v]]);
    mx[v] = max(mx[v], mx[l[v]]);
  }
  if (r[v]) {
    dfs(r[v]);
    par[r[v]] = v;
    mn[v] = min(mn[v], mn[r[v]]);
    mx[v] = max(mx[v], mx[r[v]]);
  }
}

const int M = 3 * N;

int t[4 * M], f[4 * M];

void push(int v) {
  if (f[v]) {
    f[2 * v] += f[v];
    f[2 * v + 1] += f[v];
    t[2 * v] += f[v];
    t[2 * v + 1] += f[v];
    f[v] = 0;
  }
}

void update(int v, int l, int r, int a, int b, int delta) {
  if (l > b || r < a) {
    return;
  }
  if (l >= a && r <= b) {
    t[v] += delta;
    f[v] += delta;
    return;
  }
  push(v);
  int mid = (l + r) / 2;
  update(2 * v, l, mid, a, b, delta);
  update(2 * v + 1, mid + 1, r, a, b, delta);
  /*for (int i = a; i <= b; i++) {
    t[i] += delta;
  }*/
}

int get(int v, int l, int r, int need) {
  if (l == r) {
    return t[v];
  }
  push(v);
  int mid = (l + r) / 2;
  if (need <= mid) {
    return get(2 * v, l, mid, need);
  }
  return get(2 * v + 1, mid + 1, r, need);
  //return t[need];
}

vector<pair<int, pair<int, int>>> to_upd[M];
vector<pair<int, int>> check[M];

signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0); 
  cout.tie(0);
  int n;
  cin >> n;
  vector<int> srt;
  for (int i = 1; i <= n; i++) {
    cin >> l[i] >> r[i] >> k[i];
    srt.pb(k[i]);
  }
  int q;
  cin >> q;
  vector<int> ql(q + 1), qr(q + 1);
  for (int i = 1; i <= q; i++) {
    cin >> ql[i] >> qr[i];
    srt.pb(ql[i]);
    srt.pb(qr[i]); 
  }
  sort(all(srt));
  srt.resize(unique(all(srt)) - srt.begin());
  for (int i = 1; i <= n; i++) {
    k[i] = upper_bound(all(srt), k[i]) - srt.begin();
    //cout << i << ' ' << k[i] << '\n';
  }
  for (int i = 1; i <= q; i++) {
    ql[i] = upper_bound(all(srt), ql[i]) - srt.begin();
    qr[i] = upper_bound(all(srt), qr[i]) - srt.begin();
    check[ql[i]].pb({qr[i], i});
  }
  dfs(1);
  auto add_rect = [&](int l, int r, int l2, int r2, int coef) {
    to_upd[l].pb(make_pair(coef, make_pair(r, r2)));
    to_upd[l2 + 1].pb(make_pair(-coef, make_pair(r, r2)));
    /*if (coef == -1) {
      cout << r << ' ' << r2 << '\n';
    }*/
  };
  add_rect(1, 1, SZ(srt), SZ(srt), 1);
  /*cout << '\n';
  for (int i = 1; i <= n; i++) {
    cout << i << ' ' << mn[i] << ' ' << mx[i] << '\n';
  }*/
  for (int i = 1; i <= n; i++) {
    int cl = mn[i], cr = mx[i];
    add_rect(1, cl, cr - 1, cr - 1, 2);
    add_rect(cl + 1, cl + 1, cr, SZ(srt), 2);
    add_rect(cl + 1, cl + 1, cr - 1, cr - 1, -2);
    /*cout << i << "-th vertex rectangles:\n";
    cout << "+ " << 1 << ' ' << cl << ' ' << cr << ' ' << cr << '\n';
    cout << "+ " << cl << ' ' << cl << ' ' << cr << ' ' << SZ(srt) << '\n';
    cout << "- " << cl << ' ' << cl << ' ' << cr << ' ' << cr << '\n';*/
  }
  vector<int> ans(q + 1);
  for (int i = 1; i <= SZ(srt); i++) {
    for (auto it : to_upd[i]) {
      update(1, 1, SZ(srt), it.S.F, it.S.S, it.F);
      /*if (i <= 2 && it.F == -1) {
        cout << "DEL " << it.S.F << ' ' << it.S.S << '\n';
      }
      if (i <= 2 && it.F == 1) {
        cout << "ADD " << it.S.F << ' ' << it.S.S << '\n';
      }*/
    } 
    for (auto it : check[i]) {
      ans[it.S] = get(1, 1, SZ(srt), it.F);
    }
  }
  for (int i = 1; i <= q; i++) {
    cout << ans[i] << '\n';
  }
}     