#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
using namespace std;
#define F first
#define S second
#define pb push_back  
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)(x).size()
#define int ll

const int N = 75;
 
int n, m;
int ans = 1e18;
int pos[N], cp[N];
int c[N][N], d[N][N];

void go(int cur) {
  if (cur == n + 1) {
    int csum = 0;
    for (int i = 1; i <= n; i++) {
      for (int j = i + 1; j <= n; j++) {
        csum += d[i][j] * abs(cp[i] - cp[j]);
      }
      for (int j = 1; j <= m; j++) {
        csum += c[i][j] * abs(cp[i] - pos[j]);
      }
    }
    ans = min(ans, csum);
    return;
  }
  for (int i = 1; i <= m; i++) {
    cp[cur] = pos[i];
    go(cur + 1);
  }
}

vector<pair<pair<int, int>, int>> srt, best_srt;

int ans2 = 1e9;

void go2(int cur, int last_pos) {
  if (cur == n + 1) {
    int csum = 0;
    for (int i = 1; i <= n; i++) {
      for (int j = i + 1; j <= n; j++) {
        csum += d[i][j] * abs(cp[i] - cp[j]);
      }
      for (int j = 1; j <= m; j++) {
        csum += c[i][j] * abs(cp[i] - pos[j]);
      }
    }
    ans2 = min(ans2, csum);
    return;  
  }
  for (int i = last_pos; i <= m; i++) {
    cp[srt[cur - 1].S] = pos[i];
    go2(cur + 1, i);
  }
}

mt19937 rnd(time(0));

int dp[N][N], to_pos[N], fake_pos[N];
pair<int, int> from[N][N];
int opt[N], calc[N][N], pl[N], vc[N];

signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0); 
  cout.tie(0);
  cin >> n >> m;
  //n = 5, m = 5;
  vector<pair<int, int>> kk;
  for (int i = 1; i <= m; i++) {
    //cin >> pos[i];
    cin >> fake_pos[i];
    //fake_pos[i] = rnd() % 100;
    kk.pb({fake_pos[i], i});
    //pos[i] = rnd() % 100;
  }
  sort(all(kk));
  for (int i = 1; i <= m; i++) {
    to_pos[kk[i - 1].S] = i;
    pos[i] = fake_pos[i];
  }
  sort(pos + 1, pos + m + 1);
  for (int i = 1; i <= n; i++) {
    for (int j = 1; j <= m; j++) {
      cin >> c[i][to_pos[j]];
    }
  }
  for (int i = 1; i <= n; i++) {
    for (int j = 1; j <= n; j++) {
      cin >> d[i][j];
    }
  }
  for (int i = 1; i <= n; i++) {
    pair<int, int> best = {1e18, 0};
    for (int to = 1; to <= m; to++) {
      int cpos = pos[to];
      int sum = 0;
      for (int j = 1; j <= m; j++) {
        sum += abs(cpos - pos[j]) * c[i][j];
      }
      calc[i][to] = sum;
      best = min(best, make_pair(sum, to));
    }
    opt[i] = best.S;
  }
  int best_ans = 1e18;
  while (clock() * 1.0 / CLOCKS_PER_SEC < 1.95) {
    srt = {};
    for (int i = 1; i <= n; i++) {
      srt.pb({make_pair(opt[i], rnd()), i});
    }
    sort(all(srt));
    for (int i = 0; i <= m; i++) {
      for (int j = 0; j <= n; j++) {
        dp[i][j] = 1e18;
      }
    }
    for (int i = 1; i <= n; i++) {
      pl[i] = vc[i] = 0;
      for (int j = 1; j < i; j++) {
        pl[i] += d[srt[i - 1].S][srt[j - 1].S];
      }
      for (int j = i + 1; j <= n; j++) {
        vc[i] += d[srt[i - 1].S][srt[j - 1].S];
      }
    }
    dp[1][0] = 0;
    for (int station_pos = 1; station_pos <= m; station_pos++) {
      for (int take = 0; take <= n; take++) {
        if (station_pos < m) {
          if (dp[station_pos][take] < dp[station_pos + 1][take]) {
            dp[station_pos + 1][take] = dp[station_pos][take];
            from[station_pos + 1][take] = {station_pos, take};
          }
        }
        if (take < n) {
          int val = dp[station_pos][take] + pos[station_pos] * (pl[take + 1] - vc[take + 1]) + calc[srt[take].S][station_pos];
          if (val < dp[station_pos][take + 1]) {
            dp[station_pos][take + 1] = val;
            from[station_pos][take + 1] = {station_pos, take};
          }
        }
      }
    }
    if (dp[m][n] < best_ans) {
      best_ans = dp[m][n];
      best_srt = srt;
    }
    //best_ans = min(best_ans, dp[m][n]);  
  }
  srt = best_srt;
  for (int i = 0; i <= m; i++) {
    for (int j = 0; j <= n; j++) {
      dp[i][j] = 1e18;
    }
  }
  dp[1][0] = 0;
  for (int station_pos = 1; station_pos <= m; station_pos++) {
    for (int take = 0; take <= n; take++) {
      if (station_pos < m) {
        if (dp[station_pos][take] < dp[station_pos + 1][take]) {
          dp[station_pos + 1][take] = dp[station_pos][take];
          from[station_pos + 1][take] = {station_pos, take};
        }
      }
      if (take < n) {
        int val = dp[station_pos][take];
        for (int prv = 1; prv <= take; prv++) {
          val += pos[station_pos] * d[srt[prv - 1].S][srt[take].S];
        }
        for (int nxt = take + 2; nxt <= n; nxt++) {
          val -= pos[station_pos] * d[srt[take].S][srt[nxt - 1].S];
        }
        for (int stat = 1; stat <= m; stat++) {
          val += abs(pos[stat] - pos[station_pos]) * c[srt[take].S][stat];
        }
        if (val < dp[station_pos][take + 1]) {
          dp[station_pos][take + 1] = val;
          from[station_pos][take + 1] = {station_pos, take};
        }
      }
    }
  }
  cout << dp[m][n] << '\n';
  pair<int, int> now = {m, n};
  vector<int> answer(n + 1);
  while (now.S > 0) {
    if (from[now.F][now.S].S != now.S) {
      answer[srt[now.S - 1].S] = pos[now.F];
    }
    now = {from[now.F][now.S].F, from[now.F][now.S].S};
  }
  for (int i = 1; i <= n; i++) {
    cout << answer[i] << ' ';
  }
  cout << '\n';
}     