#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<ll> vll;

#define printvi(arr) for (int x : arr) cout << x << ' '; cout << '\n';
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)

const int maxn = 1e5 + 1;

ll gcd(ll a, ll b, ll &x, ll &y) {
    if (a == 0) {
        x = 0, y = 1;
        return b;
    }
    ll x1, y1;
    ll g = gcd(b % a, a, x1, y1);
    x = y1 - (b / a) * x1;
    y = x1;
    return g;
}

int main() {
    int n;
    cin >> n;
    forn(i0, n) {
        ll b, d;
        cin >> b >> d;
        ll sq = b * b;
        bool sw = false;
        if (b < d) {
            swap(b, d);
            sw = true;
        }
        ll a, c;
        ll g = gcd(d, b, a, c);
        if (sw){
            swap(b, d);
            swap(a, c);
        }
        if (sq % g > 0) {
            cout << "0\n";
            continue;
        }
        ll k = sq / g;
        a *= k, c *= k;
        b /= g, d /= g;
        if (a <= 0) {
            ll x = -a + 1;
            x = (x + b - 1) / b;
            a += x * b;
            c -= x * d;
        }
        ll x = (a - 1) / b;
        a -= x * b;
        c += x * d;
        if (c <= 0) {
            cout << "0\n";
            continue;
        }
        cout << 1 + (c - 1) / d << '\n';
    }
}
