//  Copyright 2020 Nikita Golikov

#include <bits/stdc++.h>

using namespace std;

using i64 = int64_t;
using ui64 = uint64_t;

template <class A, class B>
bool smin(A &x, B &&y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A &x, B &&y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif

  int n;
  scanf("%d", &n);
  vector<int> p(n);
  for (int i = 1; i < n; ++i) {
    int who;
    scanf("%d", &who);
    p[i] = who - 1;
  }
  vector<vector<int>> ans(n);
  for (auto& vec : ans) {
    vec.reserve(1 << n);
  }
  for (int i = n - 1; i > 0; --i) {
    auto who = p[i];
    int R = (int) ans[who].size() - 1;
    {
      auto toggle = i;
      ans[who].push_back(toggle);
      for (int j = R; j >= 0; --j) {
        ans[who].push_back(ans[who][j]);
      }
    }
    bool rev = false;
    for (auto toggle : ans[i]) {
      ans[who].push_back(toggle);
      if (rev) {
        for (int j = R; j >= 0; --j) {
          ans[who].push_back(ans[who][j]);
        }
      } else {
        for (int j = 0; j <= R; ++j) {
          ans[who].push_back(ans[who][j]);
        }
      }
      rev = !rev;
    }
  }
  printf("%d\n", (int) ans[0].size());
  for (auto x : ans[0]) {
    printf("%d ", x + 1);
  }
  puts("");

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
