#include <algorithm>
#include <bitset>
#include <iostream>
#include <iterator>
#include <random>
#include <set>
#include <vector>

// #define FAST_ALLOCATOR_MEMORY 256000000
// #include "optimization.h"
#include <bits/stdc++.h>

using namespace std;

// #define USE_INT128
// #define int int64_t

// #undef _DEBUG

#define all(x) begin(x), end(x)
#define rall(x) (x).rbegin(), (x).rend()

#ifdef USE_INT128
#define lint __int128
#define ulint __int128
#else
#define lint int64_t
#define ulint int64_t
#endif

typedef long double ld;
// #define f first
// #define s second
typedef pair<int, int> pint;

const int inf = 1 << 30;

template <class T>
T mineq(T& a, const T& b) {
    return a = min(a, b);
}

template <class T>
T maxeq(T& a, const T& b) {
    return a = max(a, b);
}

mt19937 rd(533);
// end of default file

int32_t
main() {
    srand(5332017);
    ios::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    cout << fixed;
    cout.precision(1); // !!

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
#endif

    int n;
    cin >> n;

    int m = -1;
    vector<vector<int>> peeps(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int p;
            cin >> p;
            --p;
            maxeq(m, p + 1);
            peeps[i].push_back(p);
        }
    }

    vector<int> pseen(m);
    int max_num = 0;
    for (int i = 0; i < n; i++) {
        int use_num = 0;
        for (int p : peeps[i])
            maxeq(use_num, pseen[p] + 1);

        for (int p : peeps[i])
            pseen[p] = use_num;

        maxeq(max_num, use_num);
    }

    cout << max_num << endl;
}
