#include <bits/stdc++.h>

using namespace std;

const int MAXN = 200001;

int l[MAXN];
int r[MAXN];
int k[MAXN];
int mn[MAXN];
int mx[MAXN];

void fix_tree(int node) {
    if (l[node] != 0) {
        fix_tree(l[node]);
    }
    if (r[node] != 0) {
        fix_tree(r[node]);
    }

    mn[node] = l[node] != 0 ? mn[l[node]] : k[node];
    mx[node] = r[node] != 0 ? mx[r[node]] : k[node];
}

int get_count(int node, int L, int R) {
    if (node == 0) {
        return 1;
    }
    if (L <= mn[node] && mx[node] <= R) {
        return 1;
    }
    if (mx[node] < L || R < mn[node]) {
        return 1;
    }
    int res = 1;
    res += get_count(l[node], L, R);
    res += get_count(r[node], L, R);
    return res;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n;
    cin >> n;

    for (int i = 0; i < n; i++) {
        int l1, r1, k1;
        cin >> l1 >> r1 >> k1;
        l[i + 1] = l1;
        r[i + 1] = r1;
        k[i + 1] = k1;
    }

    fix_tree(1);

    int q;
    cin >> q;

    while (q--) {
        int L, R;
        cin >> L >> R;
        cout << get_count(1, L, R) << '\n';
    }

    return 0;
}