#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <sstream>
#include <random>
#include <climits>
#include <iomanip>
#include <queue>
#include <bitset>
#include <cctype>
#include <functional>
#include <complex>
#include <fstream>
#include <unordered_set>
#include <unordered_map>
#include <ctime>
#include <deque>
#include <numeric>
#include <assert.h>
using namespace std;

typedef long long li;

#define forn(i,n) for (li i = 0;i < li(n);i++)
#define ford(i,n) for (li i = li(n)-1;i >=0;i--)
#define fore(i,l,r) for (li i = li(l);i < li(r);i++)
#define forv(v,arr) for (auto& v : (arr))
#define correct(x,n) (((x) >= 0) && ((x) < n))
#define all(a) (a).begin(),(a).end()
#define rnd() (rand() + (RAND_MAX+1)*rand())

//#define x first
//#define y second

using vi = vector<li>;
using vptvi = vector<vi*>;
using pi = pair<li, li>;
using vpi = vector<pi>;
using vvi = vector<vector<li>>;
using vvpi = vector<vpi>;
using ld = long double;
//using Point = pair<li, li>;
//using Point = complex<li>;
using Point = complex<ld>;

li gcd(li a, li b)
{
	return b ? gcd(b, a % b) : a;
}

int build(int a, int b,vector<tuple<int,int,int>> &res)
{
	if (a == 0 && b == 0)
		return 2;
	if (a == 0 && (b & (b + 1)))
		return 0;

	int node;
	if (b > 0)
		node = 2, b--;
	else
		node = 1, a--;

	int a1 = a / 2 + a % 2;
	int b1 = b / 2;
	int a2 = a / 2;
	int b2 = b / 2 + b % 2;
	if (a2 + 2 * b2 - a1 - 2 * b1 >= 2)
	{
		a1++;
		a2--;
	}
	int p = build(a1, b1, res);
	if (!p)
		return 0;
	int l = p == 2 ? 0 : res.size();

	int q = build(a2, b2, res);
	if (!q)
		return 0;
	int r = q == 2 ? 0 : res.size();

	res.emplace_back(node, l, r);
	return 1;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int a, b;
	cin >> a >> b;
	vector<tuple<int, int, int>> res;
	int ans = build(a, b, res);
	if (!ans)
	{
		cout << -1 << endl;
		return 0;
	}

	reverse(all(res));
	forv(t, res)
	{
		int node, l, r;
		tie(node, l, r) = t;
		l = l ? a + b + 1 - l : 0;
		r = r ? a + b + 1 - r : 0;
		cout << node << " " << l << " " << r << endl;
	}
}