#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

bool good(set<int> a, set<int> b){

	if(a.size() > b.size()){
		swap(a, b);
	}

	for(auto at: a){
		if(b.find(at) != b.end()){
			return false;
		}
	}
	return true;
}

int main(){

	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	vector<set<int>> days(n);

	for(int i = 0; i < n; i++){
		int k;
		cin >> k;

		for(int j = 0; j < k; j++){
			int student;
			cin >> student;
			days[i].insert(student);
		}

		for(int j = i - 1; j >= 0; j--){
			if(days[j].size() > 0){
				if(good(days[i], days[j])){
					days[j].merge(days[i]);
					days[i].clear();
					cerr << "good" << endl;
				}
				break;
			}
		}
	}

	int answer = 0;
	for(int i = 0; i < n; i++){
		if(days[i].size() > 0){
			answer ++;
		}
	}

	cout << answer << endl;

return 0;
}
