#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define sp(n) fixed << setprecision(n)
#define _  << " " <<
#define pb push_back
#define eb emplace_back
#define ff first
#define ss second

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

ll gcd (ll a, ll b, ll & x, ll & y) {
    if (a == 0) {
        x = 0; y = 1;
        return b;
    }
    ll x1, y1;
    ll d = gcd (b % a, a, x1, y1);
    x = y1 - (b / a) * x1;
    y = x1;
    return d;
}

bool find_any_solution (ll a, ll b, ll c, ll & x0, ll & y0, ll & g) {
    g = gcd (abs(a), abs(b), x0, y0);
    if (c % g != 0)
        return false;
    x0 *= c / g;
    y0 *= c / g;
    if (a < 0)   x0 *= -1;
    if (b < 0)   y0 *= -1;
    return true;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout << sp(10);

#ifdef LOCAL_DEBUG
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif

    int n;
    cin >> n;

    while (n--) {
        ll b, d;
        cin >> b >> d;

        ll ans = 0;
        ll x0, y0, g, a = d, c = b * b;
        if (find_any_solution(a, b, c, x0, y0, g)) {
//            if (x0 <= 0) {
//                ll k = (-x0 + b / g) / (b / g);
//                x0 += k * b / g;
//                y0 -= k * a / g;
//            }
//            if (x0 > b / g) {
//                ll k = (x0) / (b / g);
//                if (x0 % (b / g) == 0)
//                    k--;
//                x0 -= k * b / g;
//                y0 += k * a / g;
//            }
//            if (y0 > 0) {
//                ans = 1;
//
//                if (y0 > a / g) {
//                    ll k = (y0) / (a / g);
//                    if (y0 % (a / g) == 0)
//                        k--;
//                    ans += k;
//                }
//            }
            while (x0 <= 0) {
                x0 += b / g;
                y0 -= a / g;
            }
            while (x0 - b / g > 0) {
                x0 -= b / g;
                y0 += a / g;
            }
            while (y0 > 0) {
                x0 += b / g;
                y0 -= a / g;
                ans++;
            }
        }

        cout << ans << endl;
    }



#ifdef LOCAL_DEBUG
    cerr << "Execution time: " << 1.0 * clock() / CLOCKS_PER_SEC << "s.\n";
#endif

    return 0;
}
