﻿#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
#include <random>
#include <chrono>
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>

#define _ << " " <<
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define sp(n) fixed << setprecision(n)
#define ff first
#define ss second
#define pb push_back

using namespace std;
//using namespace __gnu_pbds;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
//using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
//using ordered_multiset = tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = 1e9 + 7;
const double eps = 1e-12;
const ll INF = 1e18;

int l[201000], r[201000];
int cnt[201000], minv[201000], maxv[201000];
int val[201000];

int ans = 0;

void lookup(int v, int L, int R) {
    ans++;
    if (v == 0) return;
    if (L <= minv[v] && maxv[v] <= R) return;
    if (maxv[v] < L || minv[v] > R) return;
    lookup(l[v], L, R);
    lookup(r[v], L, R);
}

void dfs(int v = 1) {
    cnt[v] = 0;
    minv[v] = val[v];
    maxv[v] = val[v];
    if (l[v] == 0 && r[v] == 0) {
        cnt[v] = 1;
        minv[v] = maxv[v] = val[v];
        return;
    }
    if (l[v] != 0) {
        dfs(l[v]);
        minv[v] = min(minv[v], minv[l[v]]);
        maxv[v] = max(maxv[v], maxv[l[v]]);
        cnt[v] += cnt[l[v]];
    }
    if (r[v] != 0) {
        dfs(r[v]);
        minv[v] = min(minv[v], minv[r[v]]);
        maxv[v] = max(maxv[v], maxv[r[v]]);
        cnt[v] += cnt[r[v]];
    }
}

int main() {
    srand(time(0));
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL_DEBUG
    freopen("input.txt", "r", stdin);
    //freopen("output_false.txt", "w", stdout); //outs
#endif
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> l[i] >> r[i] >> val[i];
    }
    dfs();
    int q;
    cin >> q;
    while (q--) {
        int L, R;
        cin >> L >> R;
        ans = 0;
        lookup(1, L, R);
        cout << ans << "\n";
    }
    return 0;
}