#include <iostream>
#include <bits/stdc++.h> 
using namespace std;
typedef long long ull;

int gcd (ull a, ull b, ull & x, ull & y) {
	if (a == 0) {
		x = 0; y = 1;
		return b;
	}
	ull x1, y1;
	ull d = gcd (b%a, a, x1, y1);
	x = y1 - (b / a) * x1;
	y = x1;
	return d;
}
 
bool find_any_solution (ull a, ull b, ull c, ull & x0, ull & y0, ull & g) {
	g = gcd (abs(a), abs(b), x0, y0);
	if (c % g != 0)
		return false;
	x0 *= c / g;
	y0 *= c / g;
	if (a < 0)   x0 *= -1;
	if (b < 0)   y0 *= -1;
	return true;
}

void shift_solution (ull & x, ull & y, ull a, ull b, ull cnt) {
	x += cnt * b;
	y -= cnt * a;
}
 
int find_all_solutions (ull a, ull b, ull c, ull minx, ull maxx, ull miny, ull maxy) {
	ull x, y, g;
	if (!find_any_solution (a, b, c, x, y, g))
		return 0;
	a /= g;  b /= g;
 
	int sign_a = a>0 ? +1 : -1;
	int sign_b = b>0 ? +1 : -1;
 
	shift_solution (x, y, a, b, (minx - x) / b);
	if (x < minx)
		shift_solution (x, y, a, b, sign_b);
	if (x > maxx)
		return 0;
	ull lx1 = x;
 
	shift_solution (x, y, a, b, (maxx - x) / b);
	if (x > maxx)
		shift_solution (x, y, a, b, -sign_b);
	ull rx1 = x;
 
	shift_solution (x, y, a, b, - (miny - y) / a);
	if (y < miny)
		shift_solution (x, y, a, b, -sign_a);
	if (y > maxy)
		return 0;
	ull lx2 = x;
 
	shift_solution (x, y, a, b, - (maxy - y) / a);
	if (y > maxy)
		shift_solution (x, y, a, b, sign_a);
	ull rx2 = x;
 
	if (lx2 > rx2)
		swap (lx2, rx2);
	ull lx = max (lx1, lx2);
	ull rx = min (rx1, rx2);
 
	return (rx - lx) / abs(b) + 1;
}

int main() {
    int n;
    ull b, d, mx;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> b >> d;
        cout << find_all_solutions(d, b, b*b, 1, b*d, 1, b*d) << endl;
    }
    return 0;
}

