#include<bits/stdc++.h>

#define all(x) (x).begin(), (x).end()

using namespace std;
using ll = long long;

constexpr int inf = 1e9 + 7;
const char *yes = "YES", *no = "NO";

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    T el;
    if(v.size() == 0) {
        while(in >> el) {
            v.push_back(el);
        }
    } else {
        for(auto& x : v) {
            in >> x;
        }
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T> v) {
    for(const auto& x : v) out << x << ' ';
    return out;
}

int mod(const int& num, const int& module) {
    return ((num % module) + module) % module;
}

inline void solve() {
    int n; cin >> n;
    map<int, int> mp;
    int ans = -100;
    for(int i = 0; i < n; ++i) {
        int k; cin >> k;
        while(k--) {
            int a; cin >> a;
            if(!mp[a]) {
                for(auto& x : mp) {
                    x.second++;
                }
            } else mp[a]++;
        }
    }
    for(const auto [k, v] : mp) ans = max(ans, v);
    cout << ans;
}   

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t = 1;// cin >> t;
    while(t--) {
        solve();
        cout << '\n';
    }
}