#include <bits/stdc++.h>

#define f first
#define s second

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int N = int(1e5 + 5);

int t[N], l[N], r[N], s[N];
int cnt = 1;

void push(int x, int v = 1) {
	s[v] += x;
	if (!t[v]) {
		t[v] = x;
	} else if (s[r[v]] >= s[l[v]]) {
		if (!l[v]) {
			l[v] = ++cnt;
		}
		push(x, l[v]);
	} else {
		if (!r[v]) {
			r[v] = ++cnt;
		}
		push(x, r[v]);
	}
}

bool broken(int v = 1) {
	return abs(s[l[v]] - s[r[v]]) > 1 || (l[v] && broken(l[v])) || (r[v] && broken(r[v]));
}

void solve() {
	int a, b; cin >> a >> b;
	if (b) {
		t[1] = 2; b--; 
	} else {
		t[1] = 1; a--;
	}
	for (int i = 0; i < b; i++) {
		push(2);
	}
	for (int i = 0; i < a; i++) {
		push(1);
	}
	if (broken()) {
		cout << "-1\n";
	} else {
		for (int i = 1; i <= cnt; i++) {
			cout << t[i] << " " << l[i] << " " << r[i] << "\n";
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int tests = 1; 
	//cin >> tests;
	while (tests--) {
		solve();
	}
	return 0;
}