#include<bits/stdc++.h>

#include <memory>
using namespace std;

template<typename T> std::string toString(T val){std::ostringstream oss; oss << val; return oss.str();}
template<typename T, typename U> inline ostream &operator<< (ostream &_out, const pair<T, U> &_p) { _out << _p.first << ' ' << _p.second << '\n'; return _out; }
template<typename T, typename U> inline istream &operator>> (istream &_in, pair<T, U> &_p) { _in >> _p.first >> _p.second; return _in; }
template<typename T> inline ostream &operator<< (ostream &_out, const vector<T> &_v) { if (_v.empty()) { return _out; } _out << _v.front() << ' '; for (auto _it = ++_v.begin(); _it != _v.end(); ++_it) { _out << *_it <<' '; } return _out; }
template<typename T> inline istream &operator>> (istream &_in, vector<T> &_v) { for (auto &_i : _v) { _in >> _i; } return _in; }
template<typename T> inline ostream &operator<< (ostream &_out, const set<T> &_s) { if (_s.empty()) { return _out; } _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; } return _out; }
template<typename T> inline ostream &operator<< (ostream &_out, const multiset<T> &_s) { if (_s.empty()) { return _out; } _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; } return _out; }
template<typename T> inline ostream &operator<< (ostream &_out, const unordered_set<T> &_s) { if (_s.empty()) { return _out; } _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; } return _out; }
template<typename T> inline ostream &operator<< (ostream &_out, const unordered_multiset<T> &_s) { if (_s.empty()) { return _out; } _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; } return _out; }
template<typename T, typename U> inline ostream &operator<< (ostream &_out, const map<T, U> &_m) { if (_m.empty()) { return _out; }for (auto _it:_m) { _out << _it.first << ": " << _it.second << '\n'; } return _out; }

#define pb push_back
#define int long long
#define X first
#define Y second
#define pog long double
#define all(x) x.begin(),(x).end()


//vector<int> dx = {2, 2, 1, 1, -1, -1, -2, -2};
//vector<int> dy = {1, -1, 2, -2, 2, -2, 1, -1};

struct cord{
    int x, y, z;
};

vector<int> zfun(string s){
    int n = s.size();
    vector<int> z(n,0);
    for(int i = 1, l = 0, r = 0;i < n;i++){
        if(i <= r)
            z[i] = min(r - i + 1, z[i - l]);
        while(i + z[i] < n && s[z[i]] == s[i + z[i]])
            z[i]++;
        if(i + z[i] - 1 > r)
            l = i, r = i + z[i] - 1;
    }
    return z;
}

int mod = 1e9 + 7;
long long bin_pow(long long base, long long p) {
    int res = 1;
    while(p){
        if(p & 1)
            res = (res * base) % mod;
        base = (base * base) % mod;
        p /= 2;
    }
    return res;
}

long long inverse_element(long long x) {
    return bin_pow(x, mod - 2);
}

long long divide(long long a, long long b) {
    return a * inverse_element(b) % mod;
}
bool in = false;
int& tests(){
    static int tests;
    if (!in) {
        cin >> tests;
        in = true;
    }
    return tests;
}

void en(int num){
    cout <<  (num == 1 ? "Yes" : "No");
    exit(0);
}
int n = 17;
vector<int > mul(vector<int > &a, vector<int>& b) {
    vector<int> c(n, 0);
    for(int i = 0;i < n; i++) {
        c[i] = b[a[i]];
    }
    return c;
}

vector<int>  bin_pow(vector<int> base, long long p) {
    vector<int> res(n);
    iota(all(res), 0);
    while(p){
        if(p & 1)
            res = mul(res, base);
        base = mul(base, base);
        p /= 2;
    }
    return res;
}
void imp() {
    cout << "Impossible";
    exit(0);
}

void ask(int a) {
    cout << "? " << a << endl;
}

void yes_no(int can) {
    cout << (can ? "YES\n" : "NO\n");
}
#define sqr(x) (x) * (x)

int  l;
vector < vector<int> > g;
vector<int> tin, tout;
int timer;
vector < vector<int> > up;

void dfs (int v, int p = 0) {
    tin[v] = ++timer;
    up[v][0] = p;
    for (int i=1; i<=l; ++i)
        up[v][i] = up[up[v][i-1]][i-1];
    for (size_t i=0; i<g[v].size(); ++i) {
        int to = g[v][i];
        if (to != p)
            dfs (to, v);
    }
    tout[v] = ++timer;
}

bool upper (int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int lca (int a, int b) {
    if (upper (a, b))  return a;
    if (upper (b, a))  return b;
    for (int i=l; i>=0; --i)
        if (! upper (up[a][i], b))
            a = up[a][i];
    return up[a][0];
}

struct Node {
    std::shared_ptr<Node> left, right;
    int min, max, key, count;
    int it;
};

vector<std::shared_ptr<Node>> nodes;

void process_tree(const std::shared_ptr<Node>& root) {
    if (!root) {
        return;
    }
    root->count = 1;
    root->max = root->key;
    root->min = root->key;
    if (root->left) {
        process_tree(root->left);
        root->count += root->left->count;
        root->max = max(root->max, root->left->max);
        root->min = min(root->min, root->left->min);
    }
    if (root->right) {
        process_tree(root->right);
        root->count += root->right->count;
        root->max = max(root->max, root->right->max);
        root->min = min(root->min, root->right->min);
    }
}

int lookup(const std::shared_ptr<Node>& root, int L, int R, int &count) {
    if (!root) {
        return 0;
    }
    if (L <= root->min && root->max <= R) {
        return root->count;
    }
    if (L > root->max || root->min > R) {
        return 0;
    }

    int res = 0;
    if (L <= root->key && root->key <= R) {
        res++;
    }
    count += 2;
    res += lookup(root->left, L, R, count);
    res += lookup(root->right, L, R, count);
    return res;
}
vector<int> counts;

int childs(const std::shared_ptr<Node>& root) {
    int count = 0;
    if (root->left) count++;
    if (root->right) count++;
    return count;
}

void calc_count(const std::shared_ptr<Node>& root, std::shared_ptr<Node> from) {
    if (from) {
        counts[root->it] = counts[from->it] + childs(from);
    }
    if (root->left)
        calc_count(root->left, root);
    if (root->right)
        calc_count(root->right, root);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    counts.resize(n, 0);
    nodes.resize(n);

    for (int i = 0; i < n; i++) {
        nodes[i] = std::make_shared<Node>();
    }

    g.resize(n);
    for (int i = 0; i < n; i++) {
        int x, y, c;
        cin >> x >> y>> c;
        --x, --y;
        nodes[i]->key = c;
        nodes[i]->it = i;
        if (x != -1) {
            g[i].push_back(x);
            nodes[i]->left = nodes[x];
        }
        if (y != -1) {
            g[i].push_back(y);
            nodes[i]->right = nodes[y];
        }
    }
    vector<std::shared_ptr<Node>> saved = nodes;
    sort(all(saved), [](const std::shared_ptr<Node>& l, const std::shared_ptr<Node>& r) {
        return l->key < r->key;
    });
    auto find_l = [&](int val) {
        auto nd= std::make_shared<Node>();
        nd->key = val;
        auto jt = lower_bound(all(saved), nd, [](const std::shared_ptr<Node>& l, const std::shared_ptr<Node>& r) {
            return l->key < r->key;
        });
        return jt - saved.begin() - 1;
    };
    auto find_r = [&](int val) {
       auto nd= std::make_shared<Node>();
       nd->key = val;
        auto jt = upper_bound(all(saved), nd, [](const std::shared_ptr<Node>& l, const std::shared_ptr<Node>& r) {
            return l->key < r->key;
        });
        return jt - saved.begin();
    };
    calc_count(nodes[0], nullptr);
    tin.resize (n),  tout.resize (n),  up.resize (n);
    l = 1;
    while ((1<<l) <= n)  ++l;
    for (int i=0; i<n; ++i)  up[i].resize (l+1);
    dfs (0);
    process_tree(nodes[0]);
    while (tests()--) {
        int l, r;
        cin >> l >> r;
        int ll = saved[max(find_l(l), 0)]->it, rr = saved[min(n - 1, (int)find_r(r))]->it;
        int lc = lca(ll, rr);
        int count = 1;
        lookup(nodes[lc], l, r, count);
        std::cout << count + counts[lc] << '\n';
    }
    return 0;
}