#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <iomanip>
#include <string>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

const int INF = 1e9;

int main() {

	//fstream cin("input.txt");
	//ofstream cout("output.txt");

	int n, ans = 1; cin >> n;
	vector <vector <int> > tab(n);
	map <int, vector <int> > m;
	vector <bool> Event(n);
	Event[0] = true;

	for (int i = 0; i < n; i++) {
		int k; cin >> k;
		if (k == 0) while (true);
		tab[i].resize(k);
		for (int j = 0; j < k; j++)
			cin >> tab[i][j];
	}

	for (int i = 0; i < n; i++)
		sort(tab[i].begin(), tab[i].end());

	for (int i = 0; i < n; i++)
		for (int j = 0; j < tab[i].size(); j++)
			m[tab[i][j]].push_back(i);

	int next = 0;
	set <int> t;

	for (int i = 0; i < n; i++) {
		bool change = false;
		for (int j = 0; j < tab[i].size(); j++) 
			if (t.find(tab[i][j]) != t.end()) {
				change = true;
				t.clear();
			}
	
		for (int j = 0; j < tab[i].size(); j++)
			t.insert(tab[i][j]);

		if (change) ans++;

	}

	cout << ans;

}