//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2,tune=native")
#include <bits/stdc++.h>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define sz(a) ((long long)(a).size())
#define X first
#define Y second

using ll = long long;
using ull = unsigned long long;
using dbl = long double;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll mod) {
    return (ull)rng() % mod;
}

const int m = 8;
const int maxn = 3e5 + 555;
const int inf = 1e9;

int n;
int a[maxn][m], mask[maxn];
int d[maxn][(1 << m)];
 // last0[(1 << m)];

int calc(int i, int cmask) {
    for (int j = i + 1; j < min(i + m + 1, n); ++j) {
        if (cmask & (1 << (j - i - 1))) {
            continue;
        }
        int same_cnt = (m - __builtin_popcount(mask[i] ^ mask[j]));
        if (abs(i - j) <= same_cnt) {
            return 1;
        }
    }
    return 0;
}

const int DEBUG = 0;

void solve() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        string st;
        if (!DEBUG) {
            cin >> st;
        }
        mask[i] = 0;
        for (int j = 0; j < m; ++j) {
            if (!DEBUG) {
                a[i][j] = (st[j] == 'R');
            } else {
                a[i][j] = myRand(2);
            }
            if (a[i][j]) {
                mask[i] |= (1 << j);
            }
        }
    }
    memset(d, 0, sizeof d);
    for (int mask = 0; mask < (1 << m); ++mask) {
        int ok = calc(0, mask);
        d[0][mask] = ok;
        // plus[0][mask] += ok;
        // plus[0][mask + 1] -= ok;
    }
    for (int i = 0; i < n; ++i) {
        for (int mask = 0; mask < (1 << m); ++mask) {
            if (!d[i][mask]) {
                continue;
            }
            // cout << i << " " << mask << endl;
            for (int tmask : {(mask >> 1), (mask >> 1) + (1 << (m - 1))}) {
                if (calc(i + 1, tmask) == (mask & 1)) {
                    d[i + 1][tmask] = 1;
                }
            }
        }
    }

    // for (int i = n - 1; i >= 0; --i) {
    //     int cmask = mask[i];
    //     int res = 0;
    //     for (int j = i + 1; j < min(n, i + 10); ++j) {
    //         int tmask = mask[j];
    //         if ((j - i) <= (m - __builtin_popcount(cmask ^ tmask))) {
    //             res = max(res, !d[j]);
    //         }
    //     }
    //     d[i] = res;
    // }
    for (int i = 0; i < n; ++i) {
        if (d[i][(1 << m) - 1]) {
            cout << '1';
        } else {
            cout << '2';
        }
    }
    cout << "\n";
}

signed main() {
#ifdef LOCAL
    assert(freopen("input.txt", "r", stdin));
    // assert(freopen("output.txt", "w", stdout));
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(20);

    int T = 1;
    // cin >> T;
    for (int numt = 0; numt < T; ++numt) {
        solve();
    }

#ifdef LOCAL
    cout << endl << endl << "time = " << clock() / (double)CLOCKS_PER_SEC << endl;
#endif
}


