#include <bits/stdc++.h>
using namespace std;

set<char> was;

unordered_map<string, pair<vector<string>, int>> groups;
// group_sz, cnt

inline
pair<string, bool> normalize_s(string s)
{
        map<char, char> used;
        char new_c = 'A';
        for (char& c : s) {
                if (was.count(c))
                        continue;
                if (!used.count(c)) {
                        while (was.count(new_c))
                                ++new_c;
                        used[c] = new_c++;
                }
                c = used[c];
        }
        return {s, was.size() + used.size() <= 10};
}

string a, b;

uint64_t to_int(const string& s, const map<char, int>& mapping) {
        uint64_t x{0};
        for (char c : s)
                x = x * 10 + mapping.at(c);
        return x;
}

inline void calc(const string& s)
{
        map<char, int> mapping;
        map<int, char> rev_mapping;
        auto it{was.begin()};
        for (char c : s) {
                mapping[*it] = c - '0';
                rev_mapping[c - '0'] = *it;
                ++it;
        }
        auto ia{to_int(a, mapping)};
        auto ib{to_int(b, mapping)};
        string res = to_string(ia + ib);
        int new_c{'A'};
        for (char& c : res) {
                if (!rev_mapping.count(c - '0')) {
                        while (mapping.count(new_c))
                                ++new_c;
                        mapping[new_c] = c - '0';
                        rev_mapping[c - '0'] = new_c++;
                }
                c = rev_mapping[c - '0'];
        }
        ++groups[res].second;
}

int main()
{
        //freopen("brainteaser2.in", "r", stdin);
        ios_base::sync_with_stdio(false);
        string s;
        cin >> a >> b;
        was.insert(a.begin(), a.end());
        was.insert(b.begin(), b.end());
        int n;
        cin >> n;
        while (n--) {
                cin >> s;
                auto [nn, ok] = normalize_s(s);
                if (ok)
                        groups[nn].first.push_back(s);
        }
        set<string> subst;
        string cur;
        for (int i{0}; i < 10; ++i)
                cur.push_back('0' + i);
        int D = was.size();
        do {
                auto tmp{cur};
                tmp.resize(D);
                if (!subst.count(tmp)) {
                        subst.insert(tmp);
                        calc(tmp);
                }
        } while (next_permutation(cur.begin(), cur.end()));
        vector<string> ans;
        for (const auto& [key, group] : groups) {
                if (1 != group.second)
                        continue;
                ans.insert(ans.end(), group.first.begin(), group.first.end());
        }
        sort(ans.begin(), ans.end());
        cout << ans.size() << '\n';
        for (const auto& word : ans)
                cout << word << '\n';
}
