#pragma GCC optimize("O3")
#include <iostream>
#include <set>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
#include <ctime>
#include <cassert>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <cstring>

using namespace std;

void doRoutine() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

#define fi first
#define se second
#define endl '\n'

//const int MAX_MEM = 2e9;
//char mem[MAX_MEM];
//int mpos = 0;
//
//inline void* operator new(size_t n) {
//    char *res = mem + mpos;
//    mpos += n;
//    return (void*) res;
//}
//
//inline void operator delete(void*) {}

string first;
string second;
map<string, size_t> counts;
vector<char> all_letters;
int cur_digits[500];
char cur_chars[500];
set<int> possible_digits = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9};
set<char> all_letters_s;

int64_t str_to_int(const string& str) {
    int64_t result = 0;
    for (auto c : str) {
        result *= 10;
        result += cur_digits[c];
    }
    return result;
}

string int_to_str(int64_t value) {
    string result;
    while (value > 0) {
        int val = value % 10;
        if (cur_chars[val] == '\0') {
            result.push_back('0' + val);
        } else {
            result.push_back(cur_chars[val]);
        }
        value /= 10;
    }
    reverse(result.begin(), result.end());
    return result;
}

string process_string(string str) {
    int id = 0;
    map<int, char> for_digits;
    for (auto& c : str) {
        if (all_letters_s.count(c)) {
            continue;
        }
        auto it = for_digits.find(c);
        if (it == for_digits.end()) {
            auto [it2, _] = for_digits.emplace(c, '0' + id++);
            it = it2;
        }
        c = it->second;
    }
    return str;
}

void brootforce(int k = 0) {
    if (k == all_letters.size()) {
        if (cur_digits[first[0]] == 0 || cur_digits[second[0]] == 0) {
            return;
        }
        counts[process_string(int_to_str(str_to_int(first) + str_to_int(second)))]++;
    } else {
        auto copy = possible_digits;
        for (auto digit : copy) {
            possible_digits.erase(digit);
            cur_digits[all_letters[k]] = digit;
            cur_chars[digit] = all_letters[k];
            brootforce(k + 1);
            cur_chars[digit] = '\0';
            possible_digits.insert(digit);
        }
    }
}

signed main() {
    for (int i = 0; i < 500; ++i) {
        cur_digits[i] = 0;
        cur_chars[i] = '\0';
    }
    doRoutine();
    cin >> first >> second;
    for (auto c : first) {
        all_letters_s.insert(c);
    }
    for (auto c : second) {
        all_letters_s.insert(c);
    }
    if (all_letters.size() > 10) {
        cout << 0 << endl;
        return 0;
    }
    for (auto c : all_letters_s) {
        all_letters.push_back(c);
    }
    brootforce();
    int m;
    cin >> m;
    vector<string> ans;
    int mx = std::max(first.size(), second.size());
    for (int i = 0; i < m; ++i) {
        string s;
        cin >> s;
        if (s.size() > mx + 1 || s.size() < mx) {
            continue;
        }
        auto it = counts.find(process_string(s));
        if (it != counts.end() && it->second == 1) {
            ans.push_back(std::move(s));
        }
    }
    cout << ans.size() << endl;
    for (const auto& s : ans) {
        cout << s << endl;
    }
    return 0;
}