#include <iostream>

using namespace std;

using ll = long long;


ll gcd (ll a, ll b, ll & x, ll & y) {
    if (a == 0) {
        x = 0; y = 1;
        return b;
    }
    ll x1, y1;
    ll d = gcd (b%a, a, x1, y1);
    x = y1 - (b / a) * x1;
    y = x1;
    return d;
}

bool find_any_solution (ll a, ll b, ll c, ll & x0, ll & y0, ll & g) {
    g = gcd (abs(a), abs(b), x0, y0);
    if (c % g != 0)
        return false;
    x0 *= c / g;
    y0 *= c / g;
    if (a < 0)   x0 *= -1;
    if (b < 0)   y0 *= -1;
    return true;
}


int main()
{
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        //cerr << endl;

        ll b, d;
        cin >> b >> d;

        ll a, c, g;
        find_any_solution(d, b, b * b, a, c, g);

        //cerr << a << ' ' << c << ' ' << g << endl;

        //cerr << (b / g) << ' ' << (d / g) << endl;


        if (a > 0) {
            ll k = (a + (b / g) - 1) / (b / g);
            c += k * (d / g);
            a -= k * (b / g);
        }

        //cerr << a << ' ' << c << ' ' << g << endl;

//        k = (c + (d / g) - 1) / (d / g);
//        c += k * (d / g);
//        a -= k * (b / g);
//
//        cout << a << ' ' << c << ' ' << g << endl;


        if (a <= 0) {
            ll k = (1 - a + (b / g) - 1) / (b / g);
            c -= k * (d / g);
            a += k * (b / g);
        }

        if (a <= 0) {
            c -= (d / g);
            a += (b / g);
        }

        //cerr << a << ' ' << c << ' ' << g << endl;

//        if (c <= 0) {
//            ll k = (1 - c + (d / g) - 1) / (d / g);
//            c += k * (d / g);
//            a -= k * (b / g);
//        }
//
//        //cerr << a << ' ' << c << ' ' << g << endl;
        //cerr << boolalpha << (a <= 0 || c <= 0) << endl;

        if (a <= 0 || c <= 0) {
            cout << 0 << endl;
            continue;
        }
        ll k1 = (a - 1) / (b / g);
        ll k2 = (c - 1) / (d / g);

        //cerr << k1 << ' ' << k2 << endl;

        cout << k1 + k2 + 1 << endl;

    }
}
