#include<bits/stdc++.h>
#define all(x) begin(x),end(x)
 
using namespace std;
 
using ll = long long;
using ld = long double;

const int N = 200200;

vector<int> g[N];
int w[N];

int itr = 0;
int CreateV() {
    return itr++;
}

bool Generate(int& a, int& b, int sum, int par = -1) {
    if (sum == 0) {
        return true;
    } else if (sum == 1) {
        int v = CreateV();
        if (a) {
            a--;
            if (par != -1) {
                g[par].push_back(v);
            }
            w[v] = 1;
            sum -= 1;
            return true;
        } else {
            return false;
        }
    } else {
        int v = CreateV();
        if (b) {
            w[v] = 2;
            b--;
            sum -= 2;
            if (par != -1) {
                g[par].push_back(v);
            }
        } else if(a) {
            w[v] = 1;
            a--;
            sum -= 1;
            if (par != -1) {
                g[par].push_back(v);
            }
        } else {
            return false;
        }
        int l = sum / 2;
        int r = sum - l;
        bool res_l = Generate(a, b, l, v);
        bool res_r = Generate(a, b, r, v);
        if (!res_l || !res_r) {
            return false;
        } else {
            return true;
        }
    }
}

vector<tuple<int,int,int,int>> ans;

void Dfs(int from) {
    vector<int> ch = g[from];
    while (ch.size() < 2) ch.push_back(-1);
    ans.push_back({from, w[from], ch[0], ch[1]});
    for (int to : g[from]) {
        Dfs(to);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);  
    int a, b;
    cin >> a >> b;
    bool res = Generate(a, b, a + b * 2, -1);
    if (!res) {
        cout << -1 << '\n';
        return 0;
    }
    Dfs(0);
    sort(all(ans));
    for (auto& [index, w, l, r] : ans) {
        cout << w << ' ' << l + 1 << ' ' << r + 1 << '\n';
    }
    
    
}
