﻿#include <vector>
#include <iostream>
#include <string>
#include <algorithm>
using namespace std;

int main()
{
	vector<pair<int,string>> packs;
	int pack_num;
	vector<pair<int, string>> corr_packs;
	cin >> pack_num;

	for (int i = 0; i < pack_num; ++i) {
		int num;
		string input;
		cin >> num >> input;

		packs.push_back(make_pair(num, input));
	}
	for (auto& pack : packs) {
		int two_count = 0;
		int zero_count = 0;
		int one_count = 0;
		for (auto& chr : pack.second) {
			if (chr == '0')
				++zero_count;
			if (chr == '1')
				++one_count;
			if (chr == '2')
				++two_count;
		}
		if (zero_count > 0 && one_count > 0 && two_count > 1)
			corr_packs.push_back(pack);
	}
	if (corr_packs.empty())
		cout << 0;
	else {
		pair<int, string> smallest = corr_packs[0];
		int index = 0, i = 1;
		for (auto& pack : corr_packs) {
			if (pack.first < smallest.first) {
				smallest = pack;
			}
		}
		for (auto& pack : packs) {
			if (pack.first == smallest.first && pack.second == smallest.second) {
				index = i;
			}
			++i;
		}
		cout << index;
	}
	return 0;
}