#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <deque>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <cmath>
#include <string>
#include <vector>
#include <bitset>
#include <iomanip>

#define sp << " "
#define sps << " " <<
#define ln << "\n"
#define vi vector<int>
#define pii pair<int, int>
#define all(a) (a).begin(), (a).end()
#define rall(a) a.rbegin(), a.rend()
#define optimise cin.sync_with_stdio(false); cout.sync_with_stdio(false); cin.tie(NULL);

typedef long long ll;
typedef unsigned long long ull;
using namespace std;

template<class T>
istream& operator>> (istream& is, vector<T>& vec) { for (int i = 0; i < (int)vec.size(); ++i)is >> vec[i]; return is; }
template<class T>
ostream& operator<< (ostream& os, vector<T>& vec) { for (int i = 0; i < (int)vec.size(); ++i)os << vec[i] sp; return os; }
template<class T>
istream& operator>> (istream& is, pair<T, T>& a) { is >> a.first >> a.second; return is; }

const double pi = acos(-1.0);
const ll mod = (1ll << 30); //(int)1e9 + 7;
const ll INF = 2e18;
const int inf = 1e9;
const int maxlen = (int)1e5 + 10;
const double eps = 1e-4;
//--------------------------

bool ans[maxlen * 3];
string s[maxlen * 3];
bool can[9];

int cnt(int i, int j) {
    int res = 0;
    for (int k = 0; k < 8; ++k) {
        res += (s[i][k] == s[j][k]);
    }
    return res;
}

void solve() {
    int n; cin >> n;

    for (int i = 0; i < n; ++i) {
        cin >> s[i];

        for (int j = 1; j <= 8 && i - j >= 0; ++j) {
            if (cnt(i, i - j) >= j) can[j] = 1;
            else can[j] = 0;

            if (can[j] && !ans[i - j]) ans[i] = 1;
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << 2 - ans[i];
    }
}

int main() {
    optimise
#ifdef _DEBUG
        freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#else
        //freopen("output.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}