def eratosthenes(n):
    sieve = list(range(n + 1))
    sieve[1] = 0
    for i in sieve:
        if i > 1:
            for j in range(i + i, len(sieve), i):
                sieve[j] = 0
    return sieve

prime = list(filter(lambda x: x != 0, eratosthenes(600100)))
dprime = dict((k, 0) for k in prime)

def p(a, b, c, x):
    return a * x * x + b * x + c

def find_primes(n):
    for key in prime:
        while n % key == 0:
            dprime[key]+=1
            n //= key
        if n == 1:
            break

def find_square(pdict):
    big_num = 1000*1000*1000+7
    ans = 1
    for key in pdict:
        if pdict[key] > 1:
            if pdict[key] % 2 == 0:
                ans = (ans * (key ** pdict[key])) % big_num
            else:
                ans = (ans * (key ** (pdict[key] - 1))) % big_num
                
    return ans

a, b, c, n = map(int, input().split())

prod = 1

for number in range(n):
    pnum = p(a, b, c, number)
    prod *= pnum
    
find_primes(prod)

res = find_square(dprime)

print(res)