#include <iostream>
#include <cmath>

#define pb push_back
#define ll long long
#define f first
#define s second
#define mp make_pair
#define pii pair < int, int >

using namespace std;

const int N = 1e5 + 11;
int n;

ll gcd(ll a, ll b, ll & x, ll & y){
	if (a == 0){
		x = 0;
		y = 1;
		return b;
	}
	ll x1, y1;
	ll d = gcd(b % a, a, x1, y1);
	x = y1 - (b / a) * x1;
	y = x1;
	return d;
}

int main(){
	#ifdef LOCAL
		freopen("in", "r", stdin);
		freopen("out", "w", stdout);
	#endif
	cin >> n;
	while (n--){
		ll bb, dd, a, b, c;
		cin >> bb >> dd;
		a = dd;
		b = bb;
		c = bb * bb;
		ll g, x0 = 0, y0 = 0;
		g = gcd(a, b, x0, y0);
		if (c % g != 0){
			cout << 0 << endl;
			continue;
		}
		//cerr << g << ' ' << x0 << ' ' << y0 << ' ' << c / g << endl;
		x0 *= c / g;
		y0 *= c / g;
		if (x0 <= 0){
			ll k = (abs(x0)) / (b / g) + 1;
			x0 += k * (b / g);
			y0 -= k * (a / g);
		}
		else{
			ll k = x0 / (b / g);
			x0 -= k * (b / g);
			if (x0 == 0){
				k--;
				x0 += b / g;
			}
			y0 += k * (a / g);
		}
		if (y0 <= 0){
			cout << 0 << endl;
			continue;
		}
		ll cnt = (y0 + (a / g) - 1) / (a / g);
		cout << cnt << endl;
	}
	return 0;
}