#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cstring>
#include <cstdlib>
#include <fstream>
#include <string>
#include <cstdio>
#include <vector>          
#include <assert.h>
#include <unordered_set>
#include <cmath>
#include <ctime>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <numeric>
#include <set>
using namespace std;

#define ex exit(0)
#define F first
#define size(x) int(x.size())
#define S second
#define MOD 1000000007
#define pb push_back
#define deb(x)  cerr << #x << " = " << x << " | "
#define debe(x) cerr << #x << " = " << x << endl

typedef long long ll;

const int N = (int)3e5;
const int INF = int(1e9) + 1;

int sz = 0;

int weight[N];
pair <int, int> g[N];

void dfs(int a, int b, int pred = -1, bool isleft = 0) {
    int sum = a + b * 2;
    if (sum == 0) return;
    int v = ++sz;
    if (pred != -1) {
      if (isleft) g[pred].F = v;
      else g[pred].S = v;
    }
    if (b > 0) { 
      sum -= 2;
      weight[v] = 2;
      b--;
    } else {
      a--;
      sum -= 1;
      weight[v] = 1;
    }
    if (sum == 0) return;
    if (b == 0) {
      if (a == 0) return;
      if (a == 1) {
        dfs(a, b, v, true);
        return;
      } else {
        dfs(a / 2, b, v, true);
        dfs(a / 2 + (a % 2), b, v, false);
        return;
      }
    } 
    if (a == 0) {
      if (b == 0) return;
      if (b == 1) {
        cout << -1;
        ex;
      } else {
        if (b % 2 == 1)  {
          cout << -1;
          ex;
        }
        dfs(a, b / 2, v, true);
        dfs(a, b / 2 + (b % 2), v, false);
        return;
      }
    }
    if (a % 2 == 1) {
      if (b % 2 == 1) {
        dfs(a / 2 + 1, b / 2, v, true);
        dfs(a / 2, b / 2 + 1, v, false);
      } else {
        dfs(a / 2 + 1, b / 2, v, true);
        dfs(a / 2, b / 2, v, false);
      }
    } else {
      if (b % 2 == 1) {
        dfs(a / 2 + 2, b / 2, v, true);
        dfs(a / 2 - 2, b / 2 + 1, v, false);
      } else {
        dfs(a / 2, b / 2, v, true);
        dfs(a / 2, b / 2, v, false);
      }
    }
}

int main() {
  // freopen(".in", "r", stdin);
  // freopen(".out", "w", stdout);
  int a, b;
  cin >> a >> b;
  dfs(a, b);
  for (int i = 1; i <= sz; i++) {
    //if (weight[i] == 0) continue;
    cout << weight[i] << " " << g[i].F << " " << g[i].S << endl;
  }
  return 0;
}
