#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cstring>
#include <cstdlib>
#include <fstream>
#include <string>
#include <cstdio>
#include <vector>          
#include <assert.h>
#include <unordered_set>
#include <cmath>
#include <ctime>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <numeric>
#include <set>
 
#define pb push_back
#define pii pair <int, int> 
#define F first
#define S second
 
using namespace std;
 
typedef long long ll;
 
const int N = 2e5 + 5;
const ll mod = 1e9 + 7;
const ll inf = ll(8e18);  

int s[22];

int n, was[N*10], p[22], was2[N*10],was3[N*10], was4[N*10];

vector <int> g[22], ans, ans2, ans3, ans4;
vector <pii> g1[N*10];
int mx = 0;
bool check(int u) {
    if (s[p[u]] == 0 && s[u] == 1) return false;
    if (s[u] == 0) {
        for (auto j : g[u])
            if (s[j] == 1) 
                return false;
    }
    return true;
}

void dfs(int v) {
    was[v] = 1;
    int mn = 1e9;
    pii go;
    //cerr << v << endl;
    for (auto i : g1[v]) {
        if (mn > i.F && !was[i.F]) {
            mn = i.F;
            go = i;
        }
    }
    if (mn != 1e9) {
        ans.pb(go.S);
        dfs(go.F);
    }
    return;
}

void dfs2(int v) {
    was2[v] = 1;
    int mn = 1e9;
    pii go;
    //cerr << v << endl;
    for (auto i : g1[v]) {
        if (mn > g1[i.F].size() && !was2[i.F]) {
            mn = g1[i.F].size();
            go = i;
        }
    }
    if (mn != 1e9) {
        ans2.pb(go.S);
        dfs2(go.F);
    }
    return;
}
void dfs3(int v) {
    was3[v] = 1;
    int mn = 1e9;
    pii go;
    //cerr << v << endl;
    random_shuffle(g1[v].begin(), g1[v].end());
    for (auto i : g1[v]) {
        if (!was3[i.F]) {
        ans3.pb(i.S);
        dfs3(i.F);
        }
    }
    return;
}

void dfs4(int v) {
    was4[v] = 1;
    int mn = 1e9;
    pii go;
    //cerr << v << endl;
    random_shuffle(g1[v].begin(), g1[v].end());
    for (auto i : g1[v]) {
        if (!was4[i.F]) {
        ans4.pb(i.S);
        dfs4(i.F);
        }

    }
    return;
}




void solve() {
    cin >> n;
    s[0] = 1;       
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);     
    }
    for (int mask = 1; mask < (1<<n); mask++) {
     for (int i = 0; i < n; i++) {
            if ((1 << i) & mask) {
                s[i] = 1;
            } else {
                s[i] = 0;
            }
            //cerr << s[i] << " ";
        }
        bool w = true;
      for (int i = 0; i < n; i++) {
        if (!check(i)) {
          w = false;
          break;
        } 
      }
      if (!w) continue;
      for (int i = 1; i < n; i++) {
          int w = 0;
          if (s[i] == 0) w = mask + (1 << i);
          else w = mask - (1 << i);
          s[i] ^= 1;
        if (check(i)) {
            g1[mask].push_back({w, i});
          }
          s[i] ^= 1;
        }
    }
    dfs(1);
    dfs2(1);
    dfs3(1);
    dfs4(1);
    if (ans2.size() > ans.size()) {
        ans = ans2;
    }
    if (ans3.size() > ans.size()) {
        ans = ans3;
    }
    if (ans4.size() > ans.size()) {
        ans = ans4;
    }
    cout << ans.size() << endl;
    for (auto i : ans) {
        cout << i + 1 << " ";
    }

    // queue <pii> q;
    // q.push({1, 0});
    // was[1] = 1;
    // d[1] = 0;
    // while (!q.empty()) {
    //     pii v = q.front();
    //     q.pop();
    //     for (int i = 0; i < n; i++) {
    //         if ((1 << i) & v.F) {
    //             s[i] = 1;
    //         } else {
    //             s[i] = 0;
    //         }
    //         //cerr << s[i] << " ";
    //     }
    //     //cerr << endl;
    //     for (int i = 1; i < n; i++) {
    //         s[i] ^= 1;
    //         int w = 0;
    //         for (int j = 0; j < n; j++) {
    //             if (s[j]) {
    //                 w += (1 << j);
    //              }
    //              //cerr << s[i] << " ";
    //         }
    //         cout << v.F << " " << w << endl;
    //         if (check(i) && w != v.S && !was[w]) {
    //             was[w] = 1;
    //             q.push({w, v.F});
    //             d[w] = d[v.F] + 1;
    //             mx = max(d[w], mx);
    //         }
    //         s[i] ^= 1;
    //     }
    // }
    // cout << mx;
}
 
int main () {
  int t = 1;
  //cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}
