#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define ld long double
#define pii pair<int, int>
#define pll pair<ll, ll>
#define F first
#define S second
#define pb push_back
#define all(x) x.begin(), x.end()

const ll inf = 1e9 + 9;
const ll maxn = 2e5+100;
const ll mod = 998244353;
const ld eps = 1e-5;

//----------------------------------------------------------------------------------------
struct node {
    int l, r;
    int k, mn, mx, cnt;
} t[maxn];

void dfs(int v) {
    if (t[v].l != 0) dfs(t[v].l);
    if (t[v].r != 0) dfs(t[v].r);
    t[v].mn = min(t[v].k, t[t[v].l].mn);
    t[v].mx = max(t[v].k, t[t[v].r].mx);
}

int ans;
int lookup(int v, int x, int y) {
    ans++;
    if (v == 0) return 0;
    if (x <= t[v].mn && t[v].mx <= y) return t[v].cnt;
    if (t[v].mx < x || y < t[v].mn) return 0;

    int res = 0;
    if (x <= t[v].k && t[v].k <= y ) res++;
    res += lookup(t[v].l ,x , y);
    res += lookup(t[v].r , x , y);
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> t[i].l >> t[i].r >> t[i].k;
    }
    t[0].mn = inf; t[0].mx = -inf;
    int root = 1;
    dfs(root);

    cin >> q;
    while (q--) {
        int x, y;
        ans = 0;
        cin >> x >> y;
        int o = lookup(1,x,y);
        cout << ans << endl;

    }
}
