#pragma region template
#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:65536000")
#include <iostream>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <algorithm>
#include <functional>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <cmath>
using namespace std;

const double eps = 1e-9;
const double pi = 3.141592653589793238462643383279502884;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef pair<double, double> pdd;
typedef pair<string, string> pss;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;

#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair
#define ff first
#define ss second

#define fi(n) for (int i = 0; i < (int)(n); ++i)
#define fir(l, r) for (int i = (int)(l); i < (int)(r); ++i)
#define fj(n) for (int j = 0; j < (int)(n); ++j)
#define fjr(l, r) for (int j = (int)(l); j < (int)(r); ++j)

#pragma endregion

bool DEBUG = false;

vector<int> dfs(int v, vector<vector<int>> & g, int pre = -1);

vector<int> iterate(int v, vector<vector<int>> & g, vector<int> tos) {
    vector<int> ans;
    vector<int> tos_new;
    for (int i = 0; i < tos.size(); ++i) {
        bool iterate_enabled = false;
        for (auto x : dfs(tos[i], g, v)) {
            ans.push_back(x);
            auto iter = iterate(v, g, tos_new);
            if (!iterate_enabled)
                reverse(all(iter));
            iterate_enabled = !iterate_enabled;
            for (auto y : iter)
                ans.push_back(y);
        }
        tos_new.push_back(tos[i]);
    }
    return ans;
}

vector<int> dfs(int v, vector<vector<int>>& g, int pre) {
    vector<int> ans;
    ans.push_back(v);
    vector<int> tos;
    tos.reserve(g[v].size());
    for (int to : g[v]) {
        if (to == pre)
            continue;
        tos.push_back(to);
    }
    /*vector<char> enabled(tos.size());*/
    for (auto x : iterate(v, g, tos))
        ans.push_back(x);
    if (DEBUG) {
        cout << "Node: " << v << '\n';
        cout << ans.size() << '\n';
        for (auto x : ans) {
            cout << x << ' ';
        }
        cout << '\n';
    }
    /*for (auto x : dfs(tos[0], g, !enabled[0], v))
        ans.push_back(x);
    for (auto x : dfs(tos[1], g, !enabled[1], v))
        for*/

    //if (!enable)
    //    reverse(all(ans));
    return ans;
    /*vector<int> poses;
    for (int i = 0; i < (1 << tos.size()); ++i) {
        int pos = -1;
        for (int j = 0; j < tos.size(); ++j)
            if ((i & (1 << j)) == 0) {
                pos = j;
                break;
            }
        poses.push_back(pos);
    }
    poses.pop_back();
    if (!enable) {
        reverse(all(poses));
    }
    for (auto pos : poses) {
        dfs(tos[pos], g, !enabled[pos], v);
        enabled[pos] = (!enabled[pos]);
    }*/

}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    for (int i = 1; i < n; ++i) {
        int x;
        cin >> x;
        --x;
        g[i].push_back(x);
        g[x].push_back(i);
    }
    auto ans = dfs(0, g);
    cout << ans.size() - 1 << '\n';
    for (auto x : ans) {
        if (x != 0)
            cout << x + 1 << ' ';
    }
}


int main()
{
    cin.sync_with_stdio(0);
    solve();
    return 0;
}
/*


*/