#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <assert.h>
#include <fstream>
#include <tuple>
#include <queue>
#include <unordered_set>
#include <cstdlib>
#include <random>
#include <iomanip>

using namespace std;

#define sqr(a) ((a)*(a))
#define all(a) (a).begin(), (a).end()

const long long MOD = (int) 1e9 + 7;

long long binPow(long long a, long long b) {
    if (b == 0)
        return 1;

    long long ans = binPow(a, b / 2);
    ans = ans * ans % MOD;

    if (b % 2)
        ans = ans * a % MOD;

    return ans;
}

vector<string> a;
vector<int> dp;
vector<bool> used;

int dist(int i, int j) {
    int sum = 0;
    for (int t = 0; t < 8; ++t) {
        sum += (a[i][t] == a[j][t]);
    }
    return sum;
}
 
bool go(int i) {
    if (used[i])
        return dp[i];

    for (int to = i + 1; to <= min((int) a.size() - 1, to + 10); ++to) {
        if (dist(i, to) >= to - i)
            dp[i] |= !go(to);
    }

    used[i] = true;
}

int main() {
    // freopen("input.txt", "r", stdin);
    // freopen("iq.in", "r", stdin);
    // freopen("iq.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    srand(228);

    string A, B;
    cin >> A >> B;

    int n;
    cin >> n;

    set<char> lol;
    for (char i : A)
        lol.insert(i);
    for (char i : B) 
        lol.insert(i);

    if (lol.size() > 10) {
        cout << "0\n";
        return 0;
    }

    vector<char> kek;
    for (auto i : lol)
        kek.push_back(i);

    map<string, int> q;
    map<string, vector<string> > orge;
    // vector<int> w(26, 0);
    vector<vector<long long> > sum(16, vector<long long>(11, 0));
    int mx = 0;
    map<string, int> id;
    for (int i = 0; i < n; ++i) {
        string a;
        cin >> a;
        // sum += (1 << a.size());

        // sum += (w.size() > 10);

        set<char> w;
        for (auto j : a)
            w.insert(j);

        if (w.size() <= 10) {
            string org = a;
            string MDA = "??????????????????????????";
            for (auto j : kek)
                MDA[j - 'A'] = j;
            char last = 'a';

            for (int j = a.size() - 1; j >= 0; --j) {
                if (MDA[a[j] - 'A'] == '?') {
                    MDA[a[j] - 'A'] = last;
                    a[j] = last;
                    ++last; 
                }
            }

            // if (org == "UPMAKER" || org == "UPTAKEN") {
            //     cout << "! " << a << "\n";
            // }

            id[org] = i;
            orge[a].push_back(org);
            // ++q[a];


            // if (a.size() == 15) {
                // cout << a << "\n";
                // cout << w.size() << "\n";
                // return 0;
            // }
            // mx = max(mx, (int) a.size());

            // ++sum[a.size()][w.size()];
            // mx = max(mx, (int) sum[a.size()][w.size()]);
        }
    }

    // for (int i = 2; i <= 15; ++i) {
    //     for (int j = 1; j <= 10; ++j) {
    //         cout << sum[i][j] << " ";
    //     }
    //     cout << "\n";
    // }

    // for (auto i : sum)
    //     cout << i << " ";
    // cout << "\n";

    // sort(all(w));

    // for (int i = 0; i < 26; ++i)
    //     cout << w[i] << " ";
    // cout << "\n";

    vector<int> p;
    for (int i = 0; i < 10; ++i)
        p.push_back(i);

    // for (auto i : kek)
    //     cout << i;
    // cout << "\n";

    int mda[26] = {0};
    string MDA = "??????????";
    int it = 0;
    set<string> qqq;
    map<string, int> h;
    map<string, string> H;
    do {
        MDA = "??????????";
        for (int i = 0; i < kek.size(); ++i) {
            mda[kek[i] - 'A'] = p[i];
            MDA[p[i]] = kek[i];
        }

        if (qqq.find(MDA) != qqq.end())
            continue;
        qqq.insert(MDA);

        long long a = 0;
        long long b = 0;

        if (mda[A[0] - 'A'] == 0 || mda[B[0] - 'A'] == 0)
            continue;

        for (auto i : A) {
            a = a * 10 + mda[i - 'A'];
        }
        for (auto i : B) {
            b = b * 10 + mda[i - 'A'];
        }

        long long sum = a + b;

        // cout << a << " " << b << "\n";

        // cout << sum << " ";

        string t = "";
        long long tm = sum;
        char last = 'a';
        while (tm) {
            t += MDA[tm % 10];
            if (t[t.size() - 1] == '?') {
                t[t.size() - 1] = last;
                MDA[tm % 10] = last;
                ++last;
            }

            tm /= 10;
        }

        reverse(all(t));

        // cout << t << "\n";
        ++it;

        // if (it > 100)
        //     break;

        // if (t == "UPbAKEa") {
        //     cout << tm << " " << t << "\n";
        // }

        // if (q[t] >= 1) {
        for (auto org : orge[t]) {
            ++h[org];
            // H[t] = orge[t][0];
            // cout << t << " " << q[t] << " " << orge[t] << "\n";
            // break;
        }

        // break;
    } while (next_permutation(all(p)));

    vector<pair<int, string> > ans;
    for (auto i : h) {
        // cout << i.first << " " << i.second << "\n";
        // if (i.first == )
        if (i.second == 1) {
            ans.push_back({id[i.first], i.first});
        }
    }

    sort(all(ans));
    
    cout << ans.size() << "\n";
    for (auto i : ans)
        cout << i.second << "\n";
}