

def exgcd(a, b):
    x = yp = 1
    y = xp = 0
    while b != 0:
        q = a // b
        c = a - q * b
        a = b
        b = c
        c = x - q * xp
        x = xp
        xp = c
        c = y - q * yp
        y = yp
        yp = c
    return a, x, y


def solve():
    b, d = map(int, input().split())
    g, x0, y0 = exgcd(b, d)
    x0 *= b * b // g
    y0 *= b * b // g
    xd = d // g
    yd = b // g
    if x0 < 0:
        k = ((-x0) + xd - 1) // xd
        x0 += k * xd
        y0 -= k * yd
    if x0 > 0:
        k = x0 // xd
        x0 -= k * xd
        y0 += k * yd
    if x0 == 0:
        x0 += xd
        y0 -= yd
    if y0 <= 0:
        print(0)
        return
    print(1 + (y0 - 1) // yd)


def main():
    n = int(input())
    for i in range(n):
        solve()


if __name__ == "__main__":
    main()
