#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif
//#pragma GCC optimize("O3")
#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int maxmask = (1 << 8);
const int maxn = 3e5;
int dp[maxn][maxmask];

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#else
    //    freopen("lupa.in","r",stdin);
    //    freopen("pupa.out","w",stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << setprecision(10);
    cout << fixed;
    int n;
    cin >> n;
    vector<string> strs(n);
    vector<int> nxt(n);
    for (int i = 0; i < n; ++i) {
        cin >> strs[i];
    }
    for (int i = 0; i < n; ++i) {
        int nxts = 0;
        for (int j = 1; j < 9; ++j) {
            int cur = 0;
            if (i + j < n) {
                int cnt = 0;
                for (int k = 0; k < 8; ++k) {
                    if (strs[i][k] == strs[i + j][k]) {
                        cnt++;
                    }
                }
                if (cnt >= j) {
                    cur = 1;
                }
            }
            nxts *= 2;
            nxts += cur;
        }
        nxt[i] = nxts;

//        return 0;
    }

    for (int mask = 0; mask < maxmask; ++mask) {
        if ((mask & nxt[0]) == 0) {
            dp[0][mask] = 1;
        } else {
            dp[0][mask] = 0;
        }
    }
    cout << dp[0][0] + 1;
    for (int i = 1; i < n; ++i) {
        for (int mask = 0; mask < maxmask; ++mask) {
            int prev = (mask >> 1);
            if ((mask & nxt[i]) == 0) {
                prev += (1 << 7);
            }
            dp[i][mask] = dp[i - 1][prev];
        }
        cout << dp[i][0] + 1;
    }

    return 0;
}