#include <iostream>
#include <fstream>
#include <map>
#include <vector>
#include <algorithm>
#include <time.h>
typedef long long ll;
#define FR(i,n) for (ll i = 0; i < n; i++)
#define FRB(i,n) for (ll i = n; i >= 0; i--)

#define PI 3.141592653589793

using namespace std;

vector<int> views(100001);

int n;

int run() {
    fill(views.begin(), views.end(), 0);
    int res = 0;
    FR(i, n) {
        int k;
        cin >> k;
        vector<int> p(k + 1);
        int max = 0;
        FR(i, k) {
            cin >> p[i];
            views[p[i]]++;
            if(max < views[p[i]])
                max = views[p[i]];
        }
        if(res < max)
            res = max;
        FR(i, k) 
            views[p[i]] = max;
    }

    return res;
}

int main() {
    cin.sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    cout << run();
}