#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <random>
#include <algorithm>
#include <functional>

typedef long long int int64;
typedef unsigned long long int uint64;

using namespace std;

vector<vector<int>> visitors;
unordered_map<int, int> min_required;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    visitors.resize(n);
    vector<int> ids;
    unordered_set<int> used;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        ids.clear();
        ids.reserve(k);
        int min = 0;
        for (int j = 0; j < k; ++j) {
            int id;
            cin >> id;
            ids.push_back(id);
            auto it = min_required.find(id);
            if (it != min_required.end()) {
                if (it->second > min)
                    min = it->second;
            }
            for (auto cid : ids)
                min_required[cid] = min + 1;
            used.insert(min + 1);
        }
    }

    cout << used.size() << endl;

    return 0;
}