#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <random>
#include <algorithm>
#include <functional>

typedef long long int int64;
typedef unsigned long long int uint64;

using namespace std;

vector<int> days;
unordered_map<int, int> min_required;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    days.reserve(n);
    vector<int> ids;
    int max_used = 0;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        ids.clear();
        ids.reserve(k);
        int min = 0;
        for (int j = 0; j < k; ++j) {
            int id;
            cin >> id;
            ids.push_back(id);
            auto it = min_required.find(id);
            if (it != min_required.end()) {
                if (it->second > min)
                    min = it->second;
            }
            days.push_back(min + 1);
            for (auto cid : ids)
                min_required[cid] = min + 1;
            if (max_used < min + 1)
                max_used = min + 1;
        }
    }

    cout << max_used << endl;

    return 0;
}