#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <stack>
#include <iomanip>
#include <cmath>
#include <functional>
#include <random>
#include <unordered_map>
#include <unordered_set>
#include <ctime>
#include <chrono>
#include <climits>
#include <assert.h>
#define pii pair<int,int>
#define all(x) x.begin(),x.end()
using namespace std;
typedef long long ll;

#define MOD 998244353  //(1000*1000*1000+7)
#define inf1 2e9
#define inf2 2e18

ll gcd(ll a, ll b) {
	if (a == 0)return b;
	return gcd(b % a, a);
}


vector<int>used;
vector<vector<int>>tree;
int free_v = 0;
map<int, int>match;
void dfs(int v) {
	used[v] = 1;
	match[v] = free_v++;
	for (int i = 0; i < tree[v].size(); i++) {
		if (!used[tree[v][i]]) {
			dfs(tree[v][i]);
		}
	}
}

int main() {

	int a;
	int b;
	cin >> a >> b;
	int a1 = a;
	int b1 = b;
	int n = a + b;

	used.resize(n);
	
	int deg = 0;
	for (int i = 0; i < 30; i++) {
		int cnt = 1 << i;
		cnt--;
		deg = i;
		if (cnt >= n) {
			break;
		}
	}
	deg++;
	int bin = (1 << deg) - 1;

	map<int, int>color;
	tree.resize(bin, vector<int>());

	if (n % 2 == 0 && a == 0) {
		cout << -1;
		return 0;
	}
	int ok = 0;
	{
		a = a1;
		b = b1;
		int last = 0;
		map<int, int>pr;
		if (b > 0) {
			b--;
			color[0] = 2;
		}
		else {
			a--;
			color[0] = 1;
		}
		int low = 1;
		int up = 2;
		int root = 0;
		for (int i = 1; i <= 10000; i++) {
			int range = (up - low + 1);
			for (int j = up; j >= low; j -= 2) {

				if (a == 0 && b == 0)break;
				if (color[j] != 0)continue;
				// right
				if (a > 0) {
					root = (j - 2) / 2;
					pr[j] = last++;
					tree[root].push_back(j);
					color[j] = 1;
					a--;
				}
				else {
					root = (j - 2) / 2;
					tree[root].push_back(j);
					color[j] = 2;
					b--;
				}
			}


			for (int j = up - 1; j >= low; j -= 2) {
				if (a == 0 && b == 0)break;
				// right
				if (color[j] != 0)continue;
				root = (j - 1) / 2;
				tree[root].push_back(j);
				if (b > 0) {
					color[j] = 2;
					b--;
				}
				else {
					color[j] = 1;
					a--;
					/*if (a > 0) {
						tree[j].push_back(j * 2 + 1);
						color[j * 2 + 1] = 1;
						a--;
					}*/
				}

			}



			up = up * 2 + 2;
			low = low * 2 + 1;
			if (a == 0 && b == 0) {
				ok = 1;
				break;
			}
		}
		
		
		

	}
	if (!ok) {
		a = a1;
		b = b1;
		int last = 0;
		map<int, int>pr;
		if (a > 0) {
			a--;
			color[0] = 1;
		}
		else {
			b--;
			color[0] = 2;
		}
		int low = 1;
		int up = 2;
		int root = 0;
		for (int i = 1; i <= 10000; i++) {
			int range = (up - low + 1);
			for (int j = up; j >= low; j-=2) {
				
				if (a == 0 && b == 0)break;
				if (color[j] != 0)continue;
				// right
				if (a > 0) {
					root = (j - 2) / 2;
					pr[j] = last++;
					tree[root].push_back(j);
					color[j] = 1;
					a--;
				}
				else {
					root = (j - 2) / 2;
					tree[root].push_back(j);
					color[j] = 2;
					b--;
				}
			}


			for (int j = up -1; j >= low; j-=2) {
				if (a == 0 && b == 0)break;
				// right
				if (color[j] != 0)continue;
				root = (j - 1) / 2;
				tree[root].push_back(j);
				if (b > 0) {
					color[j] = 2;
					b--;
				}
				else {
					color[j] = 1;
					a--;
					if (a > 0) {
						tree[j].push_back(j * 2 + 1);
						color[j * 2 + 1] = 1;
						a--;
					}
				}
				
			}



			up = up * 2 + 2;
			low = low * 2 + 1;
			if (a == 0 && b == 0) {
				ok = 1;
				break;
			}
		}
	
	}
	
	if (!ok) {
		cout << -1;
		return 0;
	}
	//dfs(0);
	
	map<int, int>match;
	int free_v = 0;
	for (int i = 0; i < tree.size(); i++) {
		if (color[i] != 0) {
			match[i] = free_v++;
		}
	}
	
	int v = 0;

	for (int i = 0; i < tree.size(); i++) {
		if (color[i] != 0) {
			int ch1 = -1;
			int ch2 = -1;
			for (int j = 0; j < tree[i].size(); j++) {
				if (j == 0)ch1 = match[tree[i][j]];
				if (j == 1)ch2 = match[tree[i][j]];
			}
			
			cout << color[i] << " " << ch1+1 << " " << ch2+1 << endl;
		}
	}
	
	

	return 0;
}
