

import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class MainF {

  private static final long MOD = (long) (1e9 + 7);

  private static final Set<Long> set = new HashSet<>(); // множество неспаренных множителей

  private static long globalAnswer = 1;

  public static void main(String[] args) {
    Scanner in = new Scanner(System.in);
    long a = in.nextLong();
    long b = in.nextLong();
    long c = in.nextLong();
    final long n = in.nextLong();

    for (long i = 1; i < n; i++) {
      long answer = a * i * i + b * i + c;
      answer %= MOD;
//      System.out.println("-----START " + answer + "----");
//      System.out.println(set);
//      System.out.println(globalAnswer);
      update(answer);
//      System.out.println(set);
//      System.out.println(globalAnswer);
//      System.out.println("---------");
    }

    boolean flag = true;
    while (flag) {
      flag = false;
      long answer = 1;
      for (final Long l : set) {
        answer = l;
        flag = updateNotNod(l);
        if (flag) break;
      }
      if (flag) {
//        System.out.println("FOUND ANSWER " + answer);
        set.remove(answer);
//        System.out.println("SET " + set);
      }
    }
    System.out.println(globalAnswer);
  }

  private static boolean updateNotNod(final long originalAnswer) {
    long answer = originalAnswer;
    boolean flag = false;
    final long sqrt = (long) Math.sqrt(answer);
    for (long i = 2; i <= sqrt ; ) {
      if (answer % (i * i) == 0) {
        answer /= (i * i);
        updateGlobal(i);
        flag = true;
      } else {
        i++;
      }
    }
    return flag;
  }

  private static long update(final long answerOriginal) {
    long answer = answerOriginal;
//    System.out.println(answerOriginal + " <- ANSWER : ITERATION START : SET -> " + set);
    if (answer == 1) {
      return 1;
    }
    boolean flag = true;
    long reduce = 1;
    while (flag) {
//      System.out.println(answerOriginal + " <- ANSWER : ITERATION START : SET -> " + set);
      flag = false;
      for (final Long l : set) {
        long nod = nod(answer, l);
        if (nod > 1) {
//          System.out.println("NOD " + answer + " BY " + l + " IS " + nod);
          set.remove(l);
          answer /= nod;
          reduce = l / nod;
          updateGlobal(nod);
          flag = true;
          break;
        }
      }
      if (flag && !set.isEmpty()) {
//        System.out.println("UPDATE SET:" + set + "WITH " + answer + " " + reduce);
        reduce = update(reduce);
        answer = update(answer);
      }
//      System.out.println("ADD TO SET:" + set + "WITH " + answer + " " + reduce);
      if (reduce > 1) {
        set.add(reduce);
      }
      if (answer > 1) {
        set.add(answer);
      }

    }
    return 1;
  }

  private static void updateGlobal(long nod) {
//    System.out.println(globalAnswer + "GLOBAL BEFORE");
    globalAnswer *= nod;
    globalAnswer %= MOD;
    globalAnswer *= nod;
    globalAnswer %= MOD;
//    System.out.println(globalAnswer + "GLOBAL AFTER");
  }

  private static long nod(long x, long y) {
    while (y > 0) {
      if (x > y) {
        x = x % y;
      }
      if (x == 0) {
        break;
      }
      y = y % x;
    }
    return x == 0 ? y : x;
  }

}
