#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

#define E1 10
#define E2 100
#define E3 1000
#define E4 10000
#define E5 100000
#define E6 1000000
#define E7 10000000

using namespace std;

void solve();

int main() {
#ifdef MYDEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
	cin.sync_with_stdio(false);
	cout.precision(12);
	solve();
}

long long gcd(long long a, long long b) {
	if (a > b) {
		swap(a, b);
	}
	while (b != 0) {
		a %= b;
		swap(a, b);
	}
	return a;
}

void solve() {
	int n;
	cin >> n;
	while (n--) {
		long long b, d;
		cin >> b >> d;
		long long d1 = b * b;
		long long d2 = b * d / gcd(b, d);
		long long ans = d1 / d2;
		if (d1 % d2 == 0) {
			ans--;
		}
		cout << ans << endl;
	}
}