#include <iostream>
#include <cmath>
#include <algorithm>
#include <map>

using namespace std;

struct node {
    int l;
    int r;
    int w;
};

node g[100009];
int e = 1;
bool impossible = false;

map<pair<int, int>, int> m;

bool req(int v, int a, int b) {
    if (a < 0 || b < 0) {
        return false;
    }
    if (a == 0 && b == 0) {
        return true;
    }
    if (a == 1 && b == 0) {
        g[v].w = 1;
        return true;
    }
    if (a == 0 && b == 1) {
        g[v].w = 2;
        return true;
    }
    if (a == 2 && b == 0) {
        g[v].w = 1;
        e++;
        g[v].l = e;
        g[e].w = 1;
        return true;
    }
    if (b == 2 && a == 0) {
        return false;
    }
    if (a == 1 && b == 1) {
        g[v].w = 2;
        e++;
        g[v].l = e;
        g[e].w = 1;
        return true;
    }
    e++;
    g[v].l = e;
    e++;
    g[v].r = e;
    bool p = false;
    if ((b % 2 == 1 || m[{a, b}] == 2) && m[{a, b}] != 1) {
        g[v].w = 2;
        b--;
        int al, ar, bl, br;
        al = a / 2;
        ar = a - al;
        bl = b / 2;
        br = b - bl;
        if (bl < br) {
            if (a > 1 && a % 2 == 0) {
                al += 2;
                ar -= 2;
            } else {
                al++;
                ar--;
            }
        }
        p = req(g[v].l, al, bl);
        p = p && req(g[v].r, ar, br);
        b++;
        if (p) {
            m[{a, b}] = 2;
        }
    }
    if (a > 0 && !p) {
        g[v].w = 1;
        a--;
        p = req(g[v].l, a / 2, b / 2);

        p = p && req(g[v].r, a - a / 2, b - b / 2);
        a++;
        if (p) {
            m[{a, b}] = 1;
        }
    }

    return p;
}

int main() {
    ios_base::sync_with_stdio(false);
    int a, b;
    cin >> a >> b;

    if (!req(1, a, b)) {
        cout << -1;
        return 0;
    }

    for (int i = 1; i <= a + b; i++) {
        cout << g[i].w << " " << g[i].l << " " << g[i].r << "\n";
    }



    return 0;
}