#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

mt19937 mt(736);


void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n;

	cin >> n;

	vector<vector<int>> arr(n);

	for (auto &row : arr)
	{
		int k;

		cin >> k;

		row.resize(k);

		for (auto &it : row)
			cin >> it;
	}

	unordered_map<int, int> peop;

	reverse(arr.begin(), arr.end());

	vector<int> ans(arr.size(), 1);

	for (int i = 0; i < arr.size(); i++)
	{
		for (auto it : arr[i])
			ans[i] = max(ans[i], peop[it] + 1);
		for (auto it : arr[i])
			peop[it] = ans[i];
	}

	cout << *max_element(ans.begin(), ans.end()) << endl;
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cout << fixed;

#ifdef LOCAL
	auto st = clock();

	ifstream fin("../input.txt");

	do
	{
		solve(fin);

		cout << "===" << endl;

		string str;
		while (getline(fin, str) && str != string(max(1, (int)str.size()), '='));
	} while (fin);

	cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
