#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <cstddef>
#include <cstring>
#include <bitset>
#include <random>
#include <memory>
#include <iomanip>

typedef long long ll;
typedef long double ld;

using namespace std;

const int MX = 1e5 + 7;
vector<int> g[MX];
vector<int> cur(MX, -1);

int main() {

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);

    int n;
    cin >> n;

    for (int i = 0; i < n; i++) {
        int sz;
        cin >> sz;
        while (sz--) {
            int a;
            cin >> a;
            g[i].push_back(a);
        }
    }
    int ans = 0;
    for (int i = n - 1; i >= 0; i--) {
        int mx = -1;
        for (int j : g[i]) mx = max(mx, cur[j]);
        ans = max(ans, mx + 1);
        for (int j : g[i]) cur[j] = max(mx + 1, cur[j]);
    }
    cout << ans + 1 << '\n';


    return 0;
}
