#include <bits/stdc++.h>
using namespace std;
 
#define llong long long 
#define len(x) ((int)x.size())
#define rep(i,n) for (int i = -1; ++ i < n; )
#define rep1(i,n) for (int i = 0; i ++ < n; )
#ifdef testing
mt19937 rng(177013);
#else
mt19937 rng(chrono::system_clock::now().time_since_epoch().count());
#endif
#define rand() (int)(rng() >> 1)
#define CONCAT_(x, y) x##y/*{{{*/
#define CONCAT(x, y) CONCAT_(x, y)
#define SPEC(name) CONCAT(name, __LINE__)
#ifdef LOCAL_DEBUG   
int __db_level = 0;
#define clog cerr << string(__db_level * 2, ' ')
struct debug_block {
    string msg;
    debug_block(const string& s): msg(s) { clog << "{ " << msg << endl; ++__db_level; }
    ~debug_block() { --__db_level; clog << "} " << msg << endl; }
};
#define DB(args...) stringstream SPEC(ss); SPEC(ss)<< args; debug_block SPEC(dbbl)(SPEC(ss).str())
#else
#define clog if (0) cerr
#define DB(...)
#endif
#define db(val) "[" #val " = " << val << "]; "
template<class U, class V> ostream& operator<<(ostream& out, const pair<U, V>& p) {
    return out << "(" << p.first << ", " << p.second << ")";
}
template<size_t i, class T> ostream& print_tuple_utils(ostream& out, const T& tup) {
    if constexpr(i == tuple_size<T>::value) return out << ")";
    else return print_tuple_utils<i + 1, T>(out << (i ? ", " : "(") << get<i>(tup), tup);
}
template<class ...U>
ostream& operator<<(ostream& out, const tuple<U...>& tup) { return print_tuple_utils<0, tuple<U...>>(out, tup); }
template<class, typename = void> struct has_const_iterator : false_type {};
template<class T> struct has_const_iterator<T, void_t<typename T::const_iterator>> : true_type {};
template<class T>
typename enable_if<has_const_iterator<T>::value && !is_same<T, string>::value, ostream&>::type
operator<<(ostream& out, const T& container) { 
    auto beg = container.begin(), end = container.end();
    out << "(" << container.size() << ") {";
    if (beg != end) out << *(beg++);
    while (beg != end) out << ", " << *(beg++);
    return out << "}";
}
#define ptrtype(x) typename iterator_traits<x>::value_type
template<class u> vector<ptrtype(u)> $v(u a, u b) { return vector<ptrtype(u)>(a, b); }/*}}}*/
// ACTUAL SOLUTION START HERE ////////////////////////////////////////////////////////////////
 
bool has_dig[26];
int dig_pos[26];
string formalize(string u, char first_dig, char sec_dig, char skip = '$') {
    vector<int> dig;
    rep(i, len(u)) {
        if (u[i] == skip) continue;
        int ch = u[i] - first_dig;
        if (!has_dig[ch]) {
            has_dig[ch] = 1;
            dig.push_back(ch);
        }
    }
    // cout << dig << endl;  
    rep(i, len(dig)) dig_pos[dig[i]] = i;
     
    for (auto& ch: u) {
        if (ch == skip) continue;
        ch = char(sec_dig + dig_pos[ch - first_dig]);
    }
    for (auto ch: dig) {
        has_dig[ch] = 0;
    }
    return u;
}
 
llong to_num(const string& s, const array<int, 10>& alpha) {
    if (s[0] - 'A' >= 10) return -1;
    if (alpha[s[0] - 'A'] == 0) return -1;
    llong ans = 0;
    for (auto ch: s) {
        ch -= 'A';
        if (ch >= 10) return -1;
        ans = ans * 10 + alpha[ch];
    }
    return ans;
}
 
int main(void) {
#ifdef LOCAL
    freopen("main.inp", "r", stdin);
    freopen("main.out", "w", stdout);
    freopen(".log", "w", stderr);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0); 
    string u, v; cin >> u >> v;
    string org_u = u, org_v = v;
    string temp = formalize(u + v, 'A', 'A');
    // cout << temp << endl; 
    u = temp.substr(0, u.size());
    v = temp.substr(u.size());
     
    string alphabet;
    rep(i, 10) alphabet += char(i + 'A');
    vector<tuple<llong, llong, string>> cnt;
    cnt.reserve(1 * 2 * 3 * 4 * 5 * 6 * 7 * 8 * 9 * 10);
    do {
        array<int, 10> pos;
        bool ok = true;
        rep(i, len(alphabet)) {
            if (alphabet[i] - 'A' >= 10) {
                ok = false;
                break;
            }
            pos[alphabet[i] - 'A'] = i;
        }
        if (!ok) break;
        auto x = to_num(u, pos);
        auto y = to_num(v, pos);
        if (x == -1 or y == -1) continue;
        string new_s = to_string(x + y);
        new_s += to_string(x);
        new_s += to_string(y);
        new_s = formalize(new_s, '0', 'A');
        cnt.emplace_back(x, y, new_s);
    } while (next_permutation(alphabet.begin(), alphabet.end()));
    
    vector<string> has;
    sort(cnt.begin(), cnt.end(), [&](const auto& x, const auto& y) {
            llong d = get<0>(x) - get<0>(y);
            if (d != 0) return d < 0;
            return get<1>(x) < get<1>(y);
    }); 
    has.push_back(get<2>(cnt[0])); 
    int prev = 0;
    rep1(i, len(cnt)) { 
        if (get<0>(cnt[i]) == get<0>(cnt[prev]) and get<1>(cnt[i]) == get<1>(cnt[prev])) continue; 
        has.push_back(get<2>(cnt[i])); 
        prev = i;
    } 
    sort(has.begin(), has.end()); 
     
    int n; cin >> n;
    vector<string> ans;
    rep(i, n) {
        string s; cin >> s;
        string new_s = formalize(s +  org_u + org_v, 'A', 'A');
        auto x = lower_bound(has.begin(), has.end(), new_s);
        auto y = upper_bound(has.begin(), has.end(), new_s);
        if (y - x != 1) continue;
        ans.push_back(s);
    }
    cout << len(ans) << '\n';
    for (auto i: ans) cout << i << '\n';
     
     
    return 0;
}
 
// vim: foldmethod=marker
