
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const int mod = 1e9 + 7;

ll binpow(ll a, ll p) {
    ll res = 1;
    while (p) {
        if (p & 1) {
            (res *= a) %= mod;
        }
        p >>= 1;
        (a *= a) %= mod;
    }
    return res;
}

const int N = 1e5 + 5;
vector<int> g[N];
int val[N];
int cur;
int ok = 1;

int dfs(int a, int b) {
    int v = ++cur;
    if (b) {
        val[v] = 2;
        b--;
    } else {
        val[v] = 1;
        a--;
    }
    int a1 = (a + 1) / 2, b1 = b / 2;
    int a2 = a - a1, b2 = b - b1;
    if (abs(a1 + 2 * b1 - a2 - 2 * b2) > 1) {
        ok = 0;
    }
    if (a1 + b1) {
        g[v].push_back(dfs(a1, b1));
    }
    if (a2 + b2) {
        g[v].push_back(dfs(a2, b2));
    }
    return v;
}

void solve() {
    int a, b;
    cin >> a >> b;
    dfs(a, b);
    if (ok) {
        for (int i = 1; i <= cur; i++) {
            cout << val[i] << ' ';
            if (g[i].size() >= 1) {
                cout << g[i][0] << ' ';
            } else {
                cout << "0 ";
            }
            if (g[i].size() >= 2) {
                cout << g[i][1] << '\n';
            } else {
                cout << "0\n";
            }
        }
    } else {
        cout << -1 << '\n';
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    // cin >> T;
    for (int tc = 1; tc <= T; tc++) {
        // cout << "Case " << tc << ": ";
        solve();
    }
    return 0;
}