#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <sstream>
#include <random>
#include <climits>
#include <iomanip>
#include <queue>
#include <bitset>
#include <cctype>
#include <functional>
#include <complex>
#include <fstream>
#include <unordered_set>
#include <unordered_map>
#include <ctime>
#include <deque>
#include <numeric>
#include <assert.h>
using namespace std;

typedef long long li;

#define forn(i,n) for (li i = 0;i < li(n);i++)
#define ford(i,n) for (li i = li(n)-1;i >=0;i--)
#define fore(i,l,r) for (li i = li(l);i < li(r);i++)
#define forv(v,arr) for (auto& v : (arr))
#define correct(x,n) (((x) >= 0) && ((x) < n))
#define all(a) (a).begin(),(a).end()
#define rnd() (rand() + (RAND_MAX+1)*rand())

//#define x first
//#define y second

using vi = vector<li>;
using vptvi = vector<vi*>;
using pi = pair<li, li>;
using vpi = vector<pi>;
using vvi = vector<vector<li>>;
using vvpi = vector<vpi>;
using ld = long double;
//using Point = pair<li, li>;
//using Point = complex<li>;
using Point = complex<ld>;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector<string> a(n);
	forv(s, a)
		cin >> s;

	auto check = [&](int i, int j)
	{
		int d = abs(i - j);
		int k = 0;
		forn(pos, 8)
			k += (a[i][pos] == a[j][pos]);
		return d <= k;
	};

	vi dp(n,1);
	vi can_get(n,0);
	dp[0] = 0;
	vi ans(n);
	can_get[0] = 1;
	set<int> good_lists;
	set<int> bad_lists;
	forn(i, n)
	{
		int res = 0;
		bool flag = 0;
		forn(j, 8)
		{
			int pos = i - j - 1;
			if (pos < 0)
				break;
			if (!check(i, pos))
				continue;
			if (!can_get[pos])
				continue;
			can_get[i] = 1;
			good_lists.erase(pos);
			bad_lists.erase(pos);
			res = res || (!dp[pos]);
		}
		dp[i] = can_get[i] ? res : dp[i-1];
		if (can_get[i] && dp[i] == 1)
			good_lists.insert(i);
		ans[i] = !good_lists.empty() || !bad_lists.empty();
	}
	forv(v, ans)
		cout << 2 - v;
	cout << endl;
}