#include <bits/stdc++.h>
// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>

using namespace std;
// using namespace __gnu_pbds;

//-----------------------------------------------
#define LOG
#ifdef LOG
  #define db(x)     cerr << #x << ": " << x << endl;
  #define dbA(x, s) cerr << #x << ": "; for (int i = 0; i < s; i++) cerr << x[i] << " "; cerr << endl;
#else
  #define db(x)
  #define dbA(x, s)
#endif
//-----------------------------------------------
template<class K, class V> ostream& operator << (ostream& out, const pair<K, V>& obj) { out << "{ " << obj.first << ", " << obj.second << " }"; return out; }
template<class T> ostream& operator << (ostream& out, const vector<T>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class T> ostream& operator << (ostream& out, const deque<T>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class T> ostream& operator << (ostream& out, const set<T>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class T> ostream& operator << (ostream& out, const unordered_set<T>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class K, class V> ostream& operator << (ostream& out, const map<K, V>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class K, class V> ostream& operator << (ostream& out, const unordered_map<K, V>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
//-----------------------------------------------
#define all(x)  x.begin(), x.end()
#define sz(x)   (int)x.size()
#define sq(x)   (x) * (x)
#define fr      first
#define sc      second
//-----------------------------------------------
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pli = pair<ll, int>;
//-----------------------------------------------
const int N   = 1000 * 1000 + 5;
const ll mod  = 1000000007;
const ll mod3 = 998244353;
const ll INFL = 1000000000 * 1ll * 1000000000 + 500000;
const ll INF  = 1000000000;
const ld pi   = acosl(-1.0);
//-----------------------------------------------

vector<int> order[20];
int n;
vector<vector<int>> tr;
int direction[24];
int ind[24];

void input() {
  cin >> n;
  tr.resize(n);
  for (int i = 1, par; i < n; i++) {
    cin >> par;
    tr[par - 1].push_back(i);
  }
}

void rec_for(vector<int>& indices, int current, int mask, vector<int>& dest) {
  if (current == indices.size()) {
    dest.push_back(mask);
    return;
  }
  int cur_node = indices[current], i;
  for (i = ind[cur_node]; i >= 0 && i < order[cur_node].size(); i += direction[cur_node]) {
    rec_for(indices, current + 1, mask | order[cur_node][i], dest);
  }
  if (i == -1) {
    direction[cur_node] = 1;
    ind[cur_node] = 0;
  } else {
    direction[cur_node] = -1;
    ind[cur_node] = (int)order[cur_node].size() - 1;
  }
}

void calculate(int v) {
  if (tr[v].empty()) {
    order[v] = {0, (1 << v)};
    // db(v);
    // db(order[v]);
    return;
  }

  for (int u : tr[v]) {
    calculate(u);
  }

  order[v].clear();
  for (int u : tr[v]) {
    direction[u] = 1;
    ind[0] = 0;
  }

  order[v].push_back(0);
  rec_for(tr[v], 0, (1 << v), order[v]);
  // db(v);
  // db(order[v]);
}

void solve(int test_id) {
  calculate(0);
  cout << (int)order[0].size() - 2 << endl;
  for (int i = 2; i < order[0].size(); i++) {
    int mask = order[0][i] ^ order[0][i - 1];
    int vert = 0;
    while (mask) {
      vert++;
      mask >>= 1;
    }
    cout << vert << " ";
  }
  cout << endl;
}

int main() {
  int testcases = 1;
  // scanf("%d", &testcases);
  for(int test_id = 1; test_id <= testcases; test_id++) {
    input();
    solve(test_id);
  }
  return 0;
}
