#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 1e5 + 7;

int col[N];
int freq[N];
int par[N];
vector <int> g[N];
vector <int> ord;
vector <int> gen;

int cur_v = 0;

int k = 0;
int x = 1;

void dfs(int a, int b, int h, int pr = 0) {
    if (h + 1 > k) {
        return;
    }
    freq[h]++;
    cur_v = (1 << h) - 1 + freq[h];
    par[cur_v] = pr;
    int cur = a + 2 * b;
    if (cur % 2 == 0) {
        b--;
        col[cur_v] = 2;
    } else {
        a--;
        col[cur_v] = 1;
    }
    dfs(a / 2, b / 2, h + 1, cur_v);
    dfs(a / 2, b / 2, h + 1, cur_v);
}

void solve(int cnt, int j, int s = 0) {
    gen.push_back(s + cnt / j);
    for (int p = 2; p < j; p *= 2) {
        solve(cnt, p, s + cnt / j);
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int a, b;
    cin >> a >> b;
    int n = a + b;
    while (x <= n) {
        x *= 2;
        k++;
        if (x > n) {
            x /= 2;
            k--;
            break;
        }
    }
    x--;
    if (b > x) {
        cout << -1 << endl;
        return 0;
    }
    int need = n - x;
    a -= need;
    dfs(a, b, 0);
    int cnt = (1 << (k - 1));
    int f = k - 2;
    gen.push_back(0);
    gen.push_back(cnt / 2);
    for (int j = 4; j < cnt; j *= 2) {
        solve(cnt, j);
    }
    for (auto &to : gen) {
        to++;
    }
    for (auto to : gen) {
        ord.push_back(to);
    }
    for (auto to : gen) {
        ord.push_back(to + 1);
    }
    int sz = ord.size();
    for (int i = 0; i < sz; i++) {
        ord.push_back(ord[i]);
    }
    for (int i = 0; i < need; i++) {
        int ind = x + i + 1;
        par[ord[i]] = ind;
        col[ind] = 1;
    }
    for (int i = 1; i <= n; i++) {
        g[par[i]].push_back(i);
    }
    for (int i = 1; i <= n; i++) {
        g[i].push_back(0);
        g[i].push_back(0);
        cout << col[i] << ' ' << g[i][0] << ' ' << g[i][1] << endl;
    }
    return 0;
}
