#include <iostream>
#include <vector>
#include <cmath>


int main()
{
    int m, e;
    std::cin >> m >> e;
    int levels = log2((m + e + 1) * 2 - 1);

    std::vector<char> e_levels(levels, 0);
    int ed = e;
    for (int i = 0; ed > 0; ++i, ed /= 2) {
        e_levels[i] = ed % 2;
    }
    int extra_1s = pow(2, levels) - 1 - e - m;
    if (extra_1s > 0 && e_levels[levels - 1] == 1) {
        std::cout << -1 << std::endl;
        return 0;
    }

    std::vector<int> last_inds(pow(2, levels - 1), 1);
    for (int i = 0; i < extra_1s; ++i) {
        int k = i;
        int b = 0;
        for (int j = 0; j < levels - 1; ++j) {
            b <<= 1;
            b += k % 2;
            k >>= 1;
        }
        last_inds[b] = 0;
    }
    int f = 0;
    for (int i = 0; i < last_inds.size(); ++i) {
        if (last_inds[i] != 0) {
            last_inds[i] = last_inds.size() + f++;
        }
    }

    int p_2l = 1;
    for (int l = 0; l < levels; ++l) {
        char v = e_levels[l] == 0 ? '1' : '2';
        for (int i = 0; i < p_2l; ++i) {
            if (l == levels - 1 && last_inds[i] != 0) {
                std::cout << v << " " << 0 << " " << 0 << std::endl;
            } else if (l == levels - 2) {
                std::cout << v << " " << last_inds[2 * i] << " " << last_inds[2 * i + 1] << std::endl;
            } else if (l < levels - 2) {
                std::cout << v << " " << 2 * (p_2l + i) << " " << 2 * (p_2l + i) + 1 << std::endl;
            }
        }
        p_2l *= 2;
    }

    return 0;
}
