#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define sp(n) fixed << setprecision(n)
#define _  << " " <<
#define pb push_back
#define eb emplace_back
#define ff first
#define ss second

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

int common(string& a, string& b) {
    int cnt = 0;
    for (int i = 0; i < 8; i++)
        cnt += (a[i] == b[i]);
    return cnt;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout << sp(10);

#ifdef LOCAL_DEBUG
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif

    int n;
    cin >> n;

    vector<string> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];

    string ans(n, '2');
    vector<int> win(n), lose(n), cur(n);

    cur[0] = 1;
    win[0] = 1;
    lose[0] = 0;

    for (int i = 1; i < n; i++) {
        cur[i] = 0;
        bool ok = false;
        for (int j = i - 1; j > i - 8 && j >= 0; j--) {
            if (i - j < common(a[i], a[j])) {
                if (win[j]) lose[i] = 1;
                if (lose[j]) win[i] = 1;
                cur[j] = 1;
            }
            ok |= (win[j] && cur[j] || lose[j] && !cur[j]);
        }
        ans[i] = (ok ? '1' : '2');
    }

    cout << ans << endl;


#ifdef LOCAL_DEBUG
    cerr << "Execution time: " << 1.0 * clock() / CLOCKS_PER_SEC << "s.\n";
#endif

    return 0;
}
