#!/usr/bin/env python3

ones, twos = [int(x) for x in input().split(' ')]

# {'li': int, 'ri': int, 'val': int, 'parent': int}
tree = {}
def leaf(parent, value):
    return {
        'li': parent * 2,
        'ri': parent * 2 + 1,
        'val': value
    }

def add(pos, s):
    global ones, twos
    if s == 0:
        return
    if twos > 0 and s >= 2:
        tree[pos] = leaf(pos, 2)
        s -= 2
        twos -= 1
    elif ones > 0:
        tree[pos] = leaf(pos, 1)
        s -= 1
        ones -= 1
    else:
        raise Exception("AAA")
    
    sl = s // 2
    sr = s - sl
    add(pos * 2, sl)
    add(pos * 2 + 1, sr)

s = ones + twos * 2
try:
    add(1, s)
    m = {}
    for i, j in zip(tree, range(len(tree))):
        m[i] = j + 1
    for i in tree:
        print(f"{tree[i]['val']} {m[tree[i]['li']] if tree[i]['li'] in tree else 0} {m[tree[i]['ri']] if tree[i]['ri'] in tree else 0}")
except:
    print("-1")