#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
using namespace std;
 
vector <long long> resh;
 
vector <long long> getPrimary (long long x) {
 	 long long lim = floor(sqrt(x))+1;
     vector <long long> primary;
 
      long long i = 0;
      while(resh[i] <= x) {
        while(x % resh[i] == 0) {
         	x = x / resh[i];
            primary.push_back(resh[i]);               
        }
        i++;
      }
 
      return primary; 
}
 
int main() {
	long long a, b, c, n;
  	cin >> a >> b >> c >> n;
 
  	long long allLim = 500000;
	long long allPrim[500001];
  	for(long long i = 0; i < allLim + 1; i++) {
     	 allPrim[i] = 0;
    }
 
  	bool boolResh[allLim + 2];
  	for(long long i = 0; i < allLim + 2; i++) {
     	boolResh[i] = 1; 
    }
 
  	for(long long i = 2; i < allLim + 1; i++) {
     	 if(boolResh[i]) {
          	resh.push_back(i);
 
           	long long j = i * i;
 
            while(j <= allLim) {
            	boolResh[j] = 0;  
              	j += i;             
          	}
         }
    }
 
  	for(long long i = 0 ; i < n; i++) {
     	 vector <long long> prims = getPrimary(a * i * i + b * i + c);
      	for(long long j = 0; j < prims.size(); j++) {
          	allPrim[prims[j]] += 1;
        }     
    }
 
    long long ans = 1;
  	for(long long i = 0; i < allLim + 1; i++) {
     	if(allPrim[i] > 1) {
        	ans = (ans * (long long)pow(i, allPrim[i] - allPrim[i] % 2) ) % 1000000007;
        }
    }
    cout << ans;
 
	return 0;
}