/*
ID: computerbox --> Huseyn Hajiyev
LANG: C++
TASK: target_mode_on
*/
#include <bits/stdc++.h>
#define FLASH ios_base::sync_with_stdio(0);
#define ll int
#define debt(x,y)cout<<"#x = "<<(x)<<" and "<<"#y = "<<(y)<<endl;
#define deb(x)cout<<"#x = "<<(x)<<endl;
#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define endl "\n"
#define arr(a,n) for(ll i=1;i<=n;i++) cout<<a[i]<<" "; cout << "\n";
#define vecc(a,n) for(ll i=0;i<n;i++) cout<<a[i]<<" "; cout << "\n";


using namespace std;

struct seg
{
 ll l,r,k,minn,maxx,h,c;
};

seg node[200010];

ll n,m;
ll cntt=0;
 
ll dp[200010][32];
ll inn[200010];
ll outt[200010];
ll timee=0;
ll k=1;

ll parent(ll a,ll b)
{
  return (inn[a]<=inn[b]) && (outt[a]>=outt[b]);
}

ll lca(ll a,ll b)
{
  if(parent(a,b))return a;
  if(parent(b,a))return b;
  for(ll i=k;i>=0;i--)
  {
    if(!parent(dp[a][i],b))a=dp[a][i];
  }
  return dp[a][0];
}


ll ff(ll v,ll pos,ll x,ll y)
{
  ll r=node[v].r;
  ll l=node[v].l;
  if(node[l].c==0 && node[r].c==0)return v;
  if(x<=node[v].minn && node[v].maxx<=y)
  {
	return v;  
  }
  if(node[v].maxx<x || y<node[v].minn)return v;
  if(l!=0 && pos<=node[l].maxx && pos>=node[l].minn)return ff(l,pos,x,y);
  else if(r!=0 && pos<=node[r].maxx && pos>=node[r].minn)return ff(r,pos,x,y);
  else return v;
	
}


ll f(ll v,ll l,ll r)
{
  //cout<<v<<" "<<l<<" "<<r<<" "<<node[v].minn<<" "<<node[v].maxx<<endl;
  if(v==0)return 0;
  if(l<=node[v].minn && node[v].maxx<=r)
  {
	return 0;  
  }
  if(node[v].maxx<l || r<node[v].minn)return 0;
  ll res=2;
  res+=f(node[v].l,l,r);
  res+=f(node[v].r,l,r);
  return res;	
}


void build(ll v,ll p)
{
  if(v==0)
  {
   node[v].maxx=-INT_MAX;
   node[v].minn=INT_MAX;
   return ;
  }
  if(node[v].l!=0)node[node[v].l].h=node[v].h+1;
  if(node[v].r!=0)node[node[v].r].h=node[v].h+1;
  dp[v][0]=p;
  inn[v]=timee++;
  for(ll i=1;i<=k;i++)
  {
	dp[v][i]=dp[dp[v][i-1]][i-1];
  }
  build(node[v].l,v);
  build(node[v].r,v);
  if(node[v].l!=0)
  {
    node[v].c=node[node[v].l].c+1;  
  }
  if(node[v].r!=0)
  {
	node[v].c+=(node[node[v].r].c+1);  
  }
  node[v].maxx=max(node[v].maxx,max(node[node[v].l].maxx,node[node[v].r].maxx));  
  node[v].maxx=max(node[v].maxx,node[v].k);
  node[v].minn=min(node[v].minn,min(node[node[v].l].minn,node[node[v].r].minn)); 
  node[v].minn=min(node[v].minn,node[v].k);  
  outt[v]=timee++;
}

ll add(ll v,ll l,ll r)
{
  if(l<=node[v].minn && node[v].maxx<=r)
  {
	return 0;  
  }
  else if(node[v].maxx<l || r<node[v].minn)return 0;
  else return 2;	
}

int main(){
scanf("%d",&n);
while((1<<k)<=n)k++;
for(ll i=1;i<=n;i++)
{
  scanf("%d%d%d",&node[i].l,&node[i].r,&node[i].k);
  node[i].maxx=node[i].minn=node[i].k;
}
build(1,1);
scanf("%d",&m);
while(m--)
{
  ll x,y;
  scanf("%d%d",&x,&y);
  ll l=ff(1,x,x,y);
  ll r=ff(1,y,x,y);
  ll lcc=lca(l,r);
  if(l==r && l==1)printf("%d\n",f(1,x,y)+1);
  else if(l!=r)printf("%d\n",1+add(l,x,y)+add(r,x,y)+node[l].h+(node[l].h-1)+node[r].h+(node[r].h-1)-node[lcc].h-max(0,node[lcc].h-1));
  else printf("%d\n",2+add(l,x,y)+node[l].h+(node[l].h-1));
}






return 0;
} 
