import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.*;

public class M {
    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer tk;

        HashMap<Integer, Integer> signsOfPeople = new HashMap<Integer, Integer>();
        int n = Integer.parseInt(br.readLine());
        TreeSet<Integer> signs = new TreeSet<Integer>();

        for (int i = 0; i < n; i++) {
            tk = new StringTokenizer(br.readLine());
            int k = Integer.parseInt(tk.nextToken());
            if(k == 0)
                continue;
            ArrayList<Integer> peopleInDay = new ArrayList<>();
            int sign = signs.isEmpty() ? n:signs.first();
            for (int j = 0; j < k; j++){
                int id = Integer.parseInt(tk.nextToken());
                peopleInDay.add(id);
                if(signsOfPeople.containsKey(id))
                    sign = Math.min(sign, signsOfPeople.get(id) - 1);
            }

            for (int j = 0; j < peopleInDay.size(); j++) {
                signs.add(sign);
                signsOfPeople.put(peopleInDay.get(j), sign);
            }
        }
        System.out.println(signs.size());
    }
}
