#include<iostream>
#include<vector>
#include<iterator>
#include<algorithm>
#include<map>

#define COUNT 10  

using namespace std;

int globalIndex = 0; 

struct node{
	pair<int, int> pr;
	node *left;
	node *right;
};

void preOrder(node* root) 
{ 
    if (root == NULL) 
        return; 
    
    if(root->left == NULL && root->right == NULL){
        cout<<get<0>(root->pr)<<" "<<0<<" "<<0<<endl;
    }else if(root->left == NULL){
        cout<<get<0>(root->pr)<<" "<<0<<" "<<get<1>(root->right->pr)<<endl;
    }else if(root->right == NULL){
        cout<<get<0>(root->pr)<<" "<<get<1>(root->left->pr)<<" "<<0<<endl;
    }else{
        cout<<get<0>(root->pr)<<" "<<get<1>(root->left->pr)<<" "<<get<1>(root->right->pr)<<endl;
    }
    preOrder(root->left); 
    preOrder(root->right); 
}

node* levelOrderInsert(vector<int> numStack, int SIZE, int index){
    node* tmp = NULL;
    if(index < SIZE){
        tmp = new node();
        tmp ->right = NULL;
        tmp ->left = NULL;
        get<0>(tmp->pr) = numStack[index];
        get<1>(tmp->pr) = globalIndex;
        globalIndex++;
        tmp->left = levelOrderInsert(numStack, SIZE, 2*index + 1);
        tmp->right = levelOrderInsert(numStack, SIZE, 2*index + 2);
    }
    return tmp;
}

int main(){

	//btree *tree = new btree();
    node *tree = new node();
    //int numStack[256];
    vector<int> numStack;
    int numStackTop = -1;
    int a,b, i;
    cin>>a>>b;
    if(a == 0 || (a == 1 && b%2 != 0)){
        cout<<-1<<endl;
    }
    a--;
    numStack.push_back(1);
    ++numStackTop;
    for(int i = 0; i<b; i++){
        numStack.push_back(2);
        ++numStackTop;
    }
    for(int i = 0; i<a; i++){
        numStack.push_back(1);
        ++numStackTop;
    }

    tree = levelOrderInsert(numStack, numStackTop+1, 0);
    preOrder(tree);
    //print2D(tree);
	delete tree;

}
