#include <bits/stdc++.h>
using namespace std;
using ll = long long;

#define int ll

int mygcd(int &x, int &y, int a, int b) {
    if (a == 0) {
        x = 0;
        y = 1;
        return b;
    }
    else {
        int x1, y1;
        int g = mygcd(x1, y1, b % a, a);
        x = y1 - (b / a) * x1;
        y = x1;
        return g;
    }
}

int solve(int b, int d) {
    int x, y;
    int g = mygcd(x, y, d, b);
    int r2 = b * b;
    if (r2 % g) {
        return 0;
    }

    int mul = b * b / g;
    x *= mul;
    y *= mul;

    int a = d;
    int stepx = b / g;
    int stepy = a / g;

    if (x <= 0) {
        int need = 1 + (-x) / stepx;
        x += need * stepx;
        y -= need * stepy;
    }
    if (x > stepx) {
        int need = (x - 1) / stepx;
        x -= need * stepx;
        y += need * stepy;
    }
    if (y <= 0) {
        int need = 1 + (-y) / stepy;
        x -= need * stepx;
        y += need * stepy;
    }

    if (x <= 0) {
        return 0;
    }
    else {
        int res = (y - 1) / stepy;
        return res + 1;
    }
}

signed main() {
//#ifndef ONLINE_JUDGE
//    freopen("input.txt", "r", stdin);
//#endif
    ios_base::sync_with_stdio(0); cin.tie(0);

//    for (int iter = 0; iter < 1000; ++iter) {
//        mt19937 rng(iter);
//        int b, d;
//        b = 1 + rng() % 10;
//        d = 1 + rng() % 10;
////        b = 40;
////        d = 60;
//        int slow = 0;
//        for (int a = 1; a < 1000; ++a) {
//            for (int c = 1; c < 1000; ++c) {
//                if (a * d + b * c == b * b) {
//                    ++slow;
//                }
//            }
//        }
//        int fast = solve(b, d);
//        if (slow != fast) {
//            solve(b, d);
//            cout << iter << endl;
//            assert(false);
//        }
//    }

    int n;
    cin >> n;
    while (n--) {
        int b, d;
        cin >> b >> d;
        cout << solve(b, d) << "\n";
    }
}