#include <cmath>
#include <string>
#include <vector>
#include <numeric>
#include <cstddef>
#include <cstdint>
#include <utility>
#include <iostream>

int main() {
	size_t n;
	std::cin >> n;
	std::vector<std::pair<size_t, size_t>> denums;

	for (size_t i = 0; i < n; ++i) {
		size_t b, d;
		std::cin >> b >> d;

		if (b == 1) {
			std::cout << 0 << '\n';
			continue;
		}

		const auto dd = d;
		const auto bb = b * b;

		denums.clear();
		const auto sq = std::sqrt(b);
		for (size_t j = 2; j <= sq + 1; ++j)
			if (b % j == 0) {
				denums.emplace_back(j, 0);
				while (b % j == 0) {
					++denums.back().second;
					b /= j;
				}
			}

		if (denums.empty())
			denums.emplace_back(b, 1);

		for (auto& [j, k] : denums)
			if (d % j == 0) {
				while (d % j == 0 && k > 0) {
					--k;
					d /= j;
				}
			}

		size_t a = 1;
		for (const auto& [j, k] : denums)
			if (k > 0)
				a *= std::pow(j, k);

		const auto da = a * dd;
		std::cout << (bb - 1) / da << '\n';
	}

	std::cout << std::endl;
}
