#include<iostream>
#include<algorithm>
#include <vector>

using namespace std;

int a, b;

int i = 1;

struct Node{
    Node* left = nullptr;
    Node* right= nullptr;
    Node* parent = nullptr;
    int key = 0;
    int left_w = 0;
    int right_w=0;
    int index = 0;

};

vector<int> graph[100001];

void rec(Node* v) {
    if (v == nullptr) return;
    graph[v->index] = {v->key, (v->left == nullptr ? 0 : v->left->index), (v->right == nullptr ? 0 : v->right->index)};
    rec(v->left);
    rec(v->right);
}

void recource(Node* v){
    if (v== nullptr)
        return;
    v->index=i;
    i++;
    recource(v->left);
    recource(v->right);
}



void insert(Node*& root, int val){

    if (root==nullptr){
        root = new Node;
        root->key = val;
        return;
    }
    Node* temp = root;
    while(temp->right!= nullptr && temp->left!= nullptr){
        if(temp->left_w>temp->right_w){
            temp->right_w+=val;
            temp = temp->right;
        } else{
            temp->left_w+=val;
            temp = temp->left;
        }
    }
    if(temp->left==nullptr){
        Node* n = new Node;
        n->parent = temp;
        n->key = val;
        temp->left = n;
        temp->left_w+=val;
    } else{
        Node* n = new Node;
        n->parent = temp;
        n->key = val;
        temp->right = n;
        temp->right_w+=val;
    }

}

int main()
{
    Node* root = nullptr;
     cin >> a >> b;
    {
        int s = a + 2 * b;
        vector<int> gen;
        for (int p = 1; p < 1000000; p *= 2) {
            gen.push_back(p * 2 - 2);
        }
        int mnA = s;
        for (auto x : gen)
            mnA = min(mnA, abs(s - x));
        if (mnA > a) {
            cout << -1 << endl;
            return 0;
        }
    }
    int A=a, B=b;
    while(a+b>0){
        if(b!=0) {
            insert(root, 2);
            b--;
        }
        else {
            insert(root, 1);
            a--;
        }
    }

    recource(root);
    rec(root);
    for (int j = 1; j <= A + B; ++j) {
        cout << graph[j][0] << ' ' << graph[j][1] << ' ' << graph[j][2] << endl;
    }

    return 0;
}
