#include <iostream>
#include <cmath>
#include <vector>
#include <string>

typedef long long int LL;

using namespace std;


int d[300001], n;
string s[300001];

int cmp(string s1, string s2) {
    int res = 0;
    for(int i=0; i<8; i++)
        res += (s1[i] == s2[i]);
    return res;
}

int main() {
    ios::sync_with_stdio(0);
    cin >> n;
    for(int i=0; i<n; i++) {
        cin >>  s[i];
    }
    d[0] = 0;
    for(int i=1; i<n; i++) {
        bool ans = false;
        for(int j=1; j <= 8 && i >= j; j++) {
            if(cmp(s[i], s[i-j]) >= j) {
                if(!d[i-j]) ans = true;
            }
        }
        if(ans) d[i] = 1;
    }
    for(int i=0; i<n; i++)
        cout << (d[i]?1:2);
    return 0;
}

