#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <map>
#include <queue>
#include <string>
#include <algorithm>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <random>

#define ll long long
#define ld long double
#define INF 10e+9

using namespace std;


int main()
{
    cin.tie(nullptr);
    std::istream::sync_with_stdio(false);

    ll n;
    cin >> n;

    ll out = INF, out_id = 0;
    for (ll i = 0; i < n; ++i)
    {
        ll p;
        string s;
        cin >> p >> s;

        ll one_cnt = 0, zr_cnt = 0, two_cnt = 0;
        for (char& ch : s)
        {
            if (ch == '0')
                ++zr_cnt;
            if (ch == '1')
                ++one_cnt;
            if (ch == '2')
                ++two_cnt;
        }
        if (one_cnt >= 1 && zr_cnt >= 1 && two_cnt >= 2)
        {
            if (out > p)
            {
                out = p;
                out_id = i + 1;
            }
        }
    }
    cout << out_id << endl;

    return 0;
}
