#include <bits/stdc++.h>
 
using namespace std;

#ifdef DEBUG_OUT
	#define out(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
	#define out(...) 25;
#endif

#define x first
#define y second
#define mp make_pair
#define pb push_back
#define sqr(a) ((a) * (a))
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define forn(i, n) for(int i = 0; i < int(n); i++) 
#define fore(i, l, r) for(int i = int(l); i < int(r); i++)
 
typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;
 
mt19937 rnd(time(NULL));
 
const int INF = int(1e9);
const li INF64 = li(1e18);
const int MOD = INF + 7;
const ld EPS = 1e-9;

const int N = 300 * 1000 + 13;
const int M = 256;

int n;
int a[N];
int dist[M][M];

bool read () {
	if (scanf("%d", &n) != 1)
		return false;
	static char buf[10];
	forn(i, n) {
		scanf("%s", buf);
		a[i] = 0;
		forn(j, 8)
			a[i] = a[i] * 2 + (buf[j] == 'W');
	}
	//n = 300000;
	//forn(i, n) a[i] = rnd() % M;
	return true;
}

bool win[N];
int nxt[N];

void solve(int l, int r, vector<int> aut) {
	if (l + 1 == r) {
		win[l] = aut.empty() ? 0 : (aut[254] & 1);
		return;
	}
	
	int m = (l + r) >> 1;
	solve(l, m, aut);
	
	vector<int> naut(M);
	forn(mask, M) {
		int cur = mask;
		for (int i = m - 1; i >= l; --i) {
			int tmp = nxt[i] & (~cur);
			int res = tmp ? 1 : 0;
			cur = ((cur << 1) | res) & (M - 1);
		}
		naut[mask] = aut.empty() ? cur : aut[cur];
	}
	
	solve(m, r, naut);
}

void solve() {
	forn(i, M) forn(j, M) dist[i][j] = 8 - __builtin_popcount(i ^ j);
	forn(i, n) {
		fore(j, 1, 9) if (i + j < n && dist[a[i]][a[i + j]] >= j) 
			nxt[i] |= (1 << (j - 1));
	}
	solve(0, n, {});
	forn(i, n) printf("%c", '2' - win[i]);
	puts("");
}

int main() {
#ifdef _DEBUG
	int tt = clock();
#endif
 
	cerr.precision(15);
	cout.precision(15);
	cerr << fixed;
	cout << fixed;
	
	if (read()) {
		solve();
 
#ifdef _DEBUG
	cerr << "TIME = " << clock() - tt << endl;
	tt = clock();
#endif
 
	}
}