#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <queue>
#include <iomanip>
#include <bitset>
#include <unordered_map>
#include <stack>
#include <memory.h>
#include <list>
#include <numeric>
#include <functional>
#include <complex>
#include <cassert>
#include <regex>
#include <random>

#define ll long long
#define ld long double
#define ull unsigned ll
#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define pii pair<int,int> 
#define vi vector<int>
#define vll vector<ll>
#define vpii vector<pii>
#define vvi vector<vector<int>>
#define forn(it,from,to) for(int (it)=from; (it)<to; (it)++)
const int  Inf = 2 * 1000 * 1000 * 1000;
ll LINF = (ll)4e18;

using namespace std;

int a, b, c, n;

ll f(int x) {
	return a * 1LL * x * x + b * 1LL * x + c;
}

ll bp(ll x, ll y, ll mod) {
	ll res = 1;
	while (y > 0) {
		if (y & 1) 
			res = (res % mod * x % mod) % mod;
		x = (x % mod * x % mod) % mod;
		y >>= 1;
	}
	return res % mod;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	
	cin >> a >> b >> c >> n;
	map<ll, int> mp;
	forn(i, 0, n) {
		ll val = f(i);
		for (ll d = 2; d * d <= val; d++) {
			while (val % d == 0) {
				mp[-d]++;
				val /= d;
			}
		}
		if (val != 1)
			mp[-val]++;
	}

	ll ans = 1;
	vector<ll> v;
	const int mod = (1e9 + 7);

	for (auto& p : mp) {
		int k = p.second / 2;
		if (k)
			v.push_back(bp(-p.first, k, mod));
	}

	for (auto&i : v) {
		ans = (ans % mod * i % mod) % mod;
	}

	cout << (ans % mod * ans % mod) % mod;

	return 0;
}