def gcd(a, b):
    if a == 0:
        return 0, 1, b
        
    x, y, d = gcd(b % a, a)
    return y - b // a * x, x, d

def find_any_solution(a, b, c):
    x0, y0, g = gcd(a, b)
    if c % g != 0:
        return x0, y0, g, False
    
    x0 *= c // g
    y0 *= c // g
    
    return x0, y0, g, True
    
def shift_solution(x, y, a, b, cnt):
    return x + cnt * b, y - cnt * a
    
def find_all(a, b, c, minx, maxx, miny, maxy):
    x, y, g, f = find_any_solution(a, b, c)
    if not f:
        return 0
        
    a = a // g
    b = b // g
    
    x, y = shift_solution(x, y, a, b, (minx - x) // b)
    if x < minx:
        x, y = shift_solution(x, y, a, b, 1)
    if x > maxx:
        return 0
    lx1 = x;

    x, y = shift_solution(x, y, a, b, (maxx - x) // b)
    if x > maxx:
        x, y = shift_solution(x, y, a, b, -1)
    rx1 = x;
    
    x, y = shift_solution(x, y, a, b, -(miny - y) // a)
    if y < miny:
        x, y = shift_solution(x, y, a, b, -1)
    if y > maxy:
        return 0
    lx2 = x;

    x, y = shift_solution(x, y, a, b, -(maxy - y) // a)
    if y > maxy:
        x, y = shift_solution(x, y, a, b, 1)
    rx2 = x;

    if lx2 > rx2:
        rx2, lx2 = lx2, rx2
    lx = max(lx1, lx2)
    rx = min(rx1, rx2)

    return (rx - lx) // b + 1
    
n = int(input())

for i in range(n):
    b, d = map(int, input().split())
    print(find_all(d, b, b * b, 1, 2 * b * b, 1, 2 * b))