#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/stack:512000000")
#include<utility>
#include<iostream>
#include<fstream>
#include<vector>
#include<array>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<cmath>
#include<ctime>
#include<functional>
#include<random>
#include<climits>
#include<queue>
#include<stack>
#include<deque>
#include<bitset>
#include<map>
#include<set>
#include<unordered_map>
#include<unordered_set>
#include<cassert>
#include<ccomplex>
#include<chrono>
#include<iomanip>

#ifdef ONLINE_JUDGE
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("unroll-loops")
#define int128 __int128
#else
#define int128 long long
#endif

#define all(x) x.begin(), x.end()
#define make_unique(x) sort(all((x))); (x).resize(unique(all((x))) - (x).begin())
#define mp make_pair
#define X first
#define Y second
#define forn(i, n) for (int i = 0; i < n; i++)
#define sz(x) x.size()

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
mt19937_64 gen(time(nullptr));

namespace {
    struct custom_hash {
        static uint64_t splitmix64(uint64_t x) {
            // http://xorshift.di.unimi.it/splitmix64.c
            x += 0x9e3779b97f4a7c15;
            x = (x ^ (x >> 30)) * 0xbf58476d1ce4e5b9;
            x = (x ^ (x >> 27)) * 0x94d049bb133111eb;
            return x ^ (x >> 31);
        }

        size_t operator()(uint64_t x) const {
            static const uint64_t FIXED_RANDOM = chrono::steady_clock::now().time_since_epoch().count();
            return splitmix64(x + FIXED_RANDOM);
        }
    };

    template<typename T, typename F>
    using HashMap = unordered_map<T, F, custom_hash>;

    template<typename T>
    using HashSet = unordered_set<T, custom_hash>;
}

ll mod = 1e9 + 7;

namespace {
    ll mul(ll a, ll b) {
        ll val = a * b - (ll)((ld)a * b / mod) * mod;
        if (val < 0) val += mod;
        if (val >= mod) val -= mod;
        return val;
    }
    ll poww(ll a, ll b) {
        ll val = 1;
        a %= mod;
        while (b > 0) {
            if (b % 2) val = mul(a, val);
            a = mul(a, a);
            b >>= 1;
        }
        return val % mod;
    }
    ll inv(ll a) {
        return poww(a, mod - 2);
    }
    ll gcd(ll a, ll b) {
        return (a == 0 ? b : gcd(b % a, a));
    }
    ll gcdex(ll a, ll b, ll& x, ll& y) {
        if (a == 0) {
            x = 0; y = 1;
            return b;
        }
        ll x1, y1;
        ll d = gcdex(b % a, a, x1, y1);
        x = y1 - (b / a) * x1;
        y = x1;
        return d;
    }

    ll inv_eu(ll a, ll m) {
        ll x, y;
        ll g = gcdex(a, m, x, y);
        if (g != 1)
            assert(0);
        else {
            x = (x % m + m) % m;
            return x;
        }
    }
}

ll const inf = 1e9 + 9;
ll const maxk = 51;
ll const maxn = 3e5 + 3;

#define db(x) print(#x), print(" = "), print(x), print('\n');

namespace {

    template<class T>
    void print(const T &value) {
        std::cerr << value;
    }

    template<class X, class Y>
    void print(const pair<X, Y> &p) {
        const auto&[a, b] = p;
        print("("), print(a), print(", "), print(b), print(")");
    }

    template<class T>
    void print(const vector<T> &v) {
        print("[ ");
        for (const auto &e: v) {
            print(e);
            print(' ');
        }
        print(']');
    }

    template<class X, class Y>
    void print(const map<X, Y> &m) {
        print("{\n");
        for (const auto&[k, v]: m) {
            print('\t'), print(k), print(" -> "), print(v), print('\n');
        }
        print('}');
    }

    template<class T>
    void print(const set<T> &v) {
        print("{ ");
        for (const auto &e: v) {
            print(e);
            print(' ');
        }
        print('}');
    }

    template<class X, class Y>
    void print(const unordered_map<X, Y> &m) {
        print("{\n");
        for (const auto&[k, v]: m) {
            print('\t'), print(k), print(" -> "), print(v), print('\n');
        }
        print('}');
    }

    template<class T>
    void print(const unordered_set<T> &v) {
        print("{ ");
        for (const auto &e: v) {
            print(e);
            print(' ');
        }
        print('}');
    }

}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int found = 0;

char getc(const string& s, int pos) {
    return s[s.size() - pos - 1];
}

std::optional<int> get(const string& s, int pos, const unordered_map<char, int>& c2d) {
    if (pos >= s.size()) return {};
    if (!c2d.count(s[s.size() - pos - 1])) return {};
    char x = getc(s, pos);
    if (c2d.count(x)) return c2d.at(x);
    return {};
}

bool verify(const string& a, const string& b, const string& c, const unordered_map<char, int>& c2d) {
    //std::cerr << a << " " << b << " " << c << endl;
    //for (const auto& [u, v]: c2d) { cout << u << " = " << v << endl; }
    return c2d.at(a[0]) != 0 && c2d.at(b[0]) != 0 && c2d.at(c[0]) != 0;
}

bool rec(const string& a, const string& b, const string& c, int pos, bool shift, unordered_set<int>& digits, unordered_map<char, int>& c2d) {
    if (found > 1) {
        return false;
    }
    //cout << pos << endl;
    //for (const auto& [c, d]: c2d) {
    //    cout << c << " = " << d << endl;
    //}
    //cout << endl;
    vector<int> dcp(digits.begin(), digits.end());
    // find a[size - pos], b[size - pos], c[size - pos]
    if (pos < a.size()) {
        auto ad = get(a, pos, c2d), bd = get(b, pos, c2d), cd = get(c, pos, c2d);
        if (ad && bd) {
            int val = *ad + *bd + shift;
            bool nshift = false;
            if (val >= 10) {
                val -= 10;
                nshift = true;
            }
            if (!cd) {
                if (digits.count(val)) {
                    c2d[getc(c, pos)] = val;
                    digits.erase(val);
                    if (!rec(a, b, c, pos + 1, nshift, digits, c2d)) {
                        return false;
                    }
                    c2d.erase(getc(c, pos));
                    digits.insert(val);
                }
            } else {
                if (*cd == val) {
                    if (!rec(a, b, c, pos + 1, nshift, digits, c2d)) {
                        return false;
                    }
                }
            }
        } else if (ad) {
            for (int pb: dcp) {
                // tell that bd is pb
                int val = *ad + pb + shift;
                bool nshift = false;
                if (val >= 10) {
                    val -= 10;
                    nshift = true;
                }

                digits.erase(pb);
                c2d[getc(b, pos)] = pb;

                if (auto cdl = get(c, pos, c2d)) {
                    if (*cdl == val) {
                        if (!rec(a, b, c, pos + 1, nshift, digits, c2d)) {
                            return false;
                        }
                    }
                } else {
                    if (digits.count(val)) {
                        digits.erase(val);
                        c2d[getc(c, pos)] = val;
                        if (!rec(a, b, c, pos + 1, nshift, digits, c2d)) {
                            return false;
                        }
                        digits.insert(val);
                        c2d.erase(getc(c, pos));
                    }
                }

                digits.insert(pb);
                c2d.erase(getc(b, pos));
            }
        } else if (bd) {
            for (int pa: dcp) {
                // tell that bd is pb
                int val = *bd + pa + shift;
                bool nshift = false;
                if (val >= 10) {
                    val -= 10;
                    nshift = true;
                }

                digits.erase(pa);
                c2d[getc(a, pos)] = pa;

                if (auto cdl = get(c, pos, c2d)) {
                    if (*cdl == val) {
                        if (!rec(a, b, c, pos + 1, nshift, digits, c2d)) {
                            return false;
                        }
                    }
                } else {
                    if (digits.count(val)) {
                        digits.erase(val);
                        c2d[getc(c, pos)] = val;
                        if (!rec(a, b, c, pos + 1, nshift, digits, c2d)) {
                            return false;
                        }
                        digits.insert(val);
                        c2d.erase(getc(c, pos));
                    }
                }

                digits.insert(pa);
                c2d.erase(getc(a, pos));
            }
        } else {
            if (getc(b, pos) == getc(a, pos)) {
                for (int pa: dcp) {
                    int val = 2 * pa + shift;
                    bool nshift = false;
                    if (val >= 10) {
                        nshift = true;
                        val -= 10;
                    }
                    digits.erase(pa);
                    c2d[getc(a, pos)] = pa;

                    if (auto cdl = get(c, pos, c2d)) {
                        if (*cdl == val) {
                            if (!rec(a, b, c, pos + 1, nshift, digits, c2d)) {
                                return false;
                            }
                        }
                    } else {
                        if (digits.count(val)) {
                            digits.erase(val);
                            c2d[getc(c, pos)] = val;
                            if (!rec(a, b, c, pos + 1, nshift, digits, c2d)) {
                                return false;
                            }
                            digits.insert(val);
                            c2d.erase(getc(c, pos));
                        }
                    }

                    digits.insert(pa);
                    c2d.erase(getc(a, pos));
                }
            } else {
                for (int pa: dcp) {
                    for (int pb: dcp) {
                        if (pb == pa) continue;
                        int val = pa + pb + shift;
                        bool nshift = false;
                        if (val >= 10) {
                            val -= 10;
                            nshift = true;
                        }

                        digits.erase(pa);
                        digits.erase(pb);
                        c2d[getc(a, pos)] = pa;
                        c2d[getc(b, pos)] = pb;

                        if (auto cdl = get(c, pos, c2d)) {
                            if (*cdl == val) {
                                if (!rec(a, b, c, pos + 1, nshift, digits, c2d)) {
                                    return false;
                                }
                            }
                        } else {
                            if (digits.count(val)) {
                                digits.erase(val);
                                c2d[getc(c, pos)] = val;
                                if (!rec(a, b, c, pos + 1, nshift, digits, c2d)) {
                                    return false;
                                }
                                digits.insert(val);
                                c2d.erase(getc(c, pos));
                            }
                        }

                        digits.insert(pa);
                        digits.insert(pb);
                        c2d.erase(getc(a, pos));
                        c2d.erase(getc(b, pos));
                    }
                }
            }
        }
    } else if (pos < b.size()) {
        //cerr << "!!!" << endl;
        if (auto bdl = get(b, pos, c2d)) {
            int val = *bdl + shift;
            bool nshift = false;
            if (val >= 10) {
                val -= 10;
                nshift = true;
            }
            if (auto cdl = get(c, pos, c2d)) {
                if (*cdl == val) {
                    if (!rec(a, b, c, pos + 1, nshift, digits, c2d)) {
                        return false;
                    }
                }
            } else {
                if (digits.count(val)) {
                    digits.erase(val);
                    c2d[getc(c, pos)] = val;
                    if (!rec(a, b, c, pos + 1, nshift, digits, c2d)) {
                        return false;
                    }
                    digits.insert(val);
                    c2d.erase(getc(c, pos));
                }
            }
        } else {
            for (int pb: dcp) {
                int val = pb + shift;
                bool nshift = false;
                if (val >= 10) {
                    val -= 10;
                    nshift = true;
                }

                digits.erase(pb);
                c2d[getc(b, pos)] = pb;

                if (auto cdl = get(c, pos, c2d)) {
                    if (*cdl == val) {
                        if (!rec(a, b, c, pos + 1, nshift, digits, c2d)) {
                            return false;
                        }
                    }
                } else {
                    if (digits.count(val)) {
                        digits.erase(val);
                        c2d[getc(c, pos)] = val;
                        if (!rec(a, b, c, pos + 1, nshift, digits, c2d)) {
                            return false;
                        }
                        digits.insert(val);
                        c2d.erase(getc(c, pos));
                    }
                }

                digits.insert(pb);
                c2d.erase(getc(b, pos));
            }
        }

    } else if (pos < c.size()) {
        if (!shift) {
            return true;
        }
        auto cd = get(c, pos, c2d);
        if (cd) {
            if (*cd != 1) {
                return true;
            }
            if (!rec(a, b, c, pos + 1, 0, digits, c2d)) {
                return false;
            }
            return true;
        } else {
            if (digits.count(1)) {
                digits.erase(1);
                c2d[getc(c, pos)] = 1;
                if (!rec(a, b, c, pos + 1, 0, digits, c2d)) {
                    return false;
                }
                digits.insert(1);
                c2d.erase(getc(c, pos));
            }
            return true;
        }
    } else {
        if (shift) {
            return true;
        }
        if (verify(a, b, c, c2d)) {
            //cerr << "Upd found" << endl;
            found++;
        }
        if (found != 1) {
            return false;
        } else return true;
    }

    return true;
}

bool crack(const string& a, const string& b, const string& c) {
    if (c.size() < b.size() || c.size() > b.size() + 1) return false;
    found = 0;

    unordered_set<int> digits;
    forn(i, 10) digits.insert(i);
    unordered_map<char, int> c2d;
    rec(a, b, c, 0, 0, digits, c2d);

    return found == 1;
}

void solve() {
    string a, b; cin >> a >> b;
    if (a.size() > b.size()) swap(a, b);

    int n; cin >> n;
    vector<string> ans;
    forn(i, n) {
        string c; cin >> c;
        if (crack(a, b, c)) {
            ans.push_back(c);
        }
    }

    cout << sz(ans) << endl;
    for (const auto& s: ans) cout << s << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int t = 1;
    while (t--) {
        solve();
    }
}