#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <random>
#include <ctime>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <queue>
#include <numeric>
#include <limits>
#include <fstream>
#include <stack>
#include <unordered_set>
#include <sstream>
#include <array>
#include <chrono>
#include <unordered_map>
#include <cassert>

using namespace std;

typedef unsigned long long uli;
typedef long long li;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
//#define x first
//#define y second
#define pb push_back
#define mp make_pair
#define forn(i, n) for(int i = 0; i < int(n); ++i)
#define fore(i, l, r) for(int i = int(l); i < int(r); ++i)
#define forb(i, n) for(int i = int(n) - 1; i >= 0; --i)
//#define left 2 * v + 1
//#define right 2 * v + 2

const int INF = 1e9 + 1000;
const li INF64 = 1e18;

const int N = 5e5 + 1000;
const int MOD = 998244353;
const double EPS = 1E-9;
const double PI = acos(-1.);

li gcd(li a, li b) {
	return a == 0 ? b : gcd(b % a, a);
}

bool ok(const string s) {
	vector<int> have(10);

	for (auto c : s) {
		have[c - '0']++;
	}

	return have[0] > 0 && have[2] > 1 && have[1] > 0;
}


int main() {

#ifdef _DEBUG
	freopen("output.txt", "w", stdout);
#endif // _DEBUG

	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n;
	int num = -1;
	int pr = INF;

	cin >> n;
	forn(i, n) {
		int price;
		string s;
		cin >> price >> s;

		if (ok(s) && pr > price) {
			pr = price;
			num = i;
		}
	}
	cout << num + 1;

}
