#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define TIME (clock() * 1.0 / CLOCKS_PER_SEC)

const int M = 3e5 + 239;
const int MS = 260;

int read() {
    string s;
    cin >> s;
    int mask = 0;
    for (int i = 0; i < 8; i++) {
        mask ^= (int)(s[i] == 'R') << i;
    }
    return mask;
}

int common(int m1, int m2) {
    return __builtin_popcount(m1 ^ m2 ^ 255);
}

int dp[M];
int n, mask[M];

int main() {
#ifdef ONPC
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n;
    for (int i = 0; i < n; i++) {
        mask[i] = read();
    }
    for (int i = n - 1; i >= 0; i--) {
        dp[i] = 1;
        for (int to = i + 1; to < min(i + 9, n); to++) {
            if (dp[to] == 1) {
                if (common(mask[i], mask[to]) >= to - i) {
                    dp[i] = 0;
                    break;
                }
            }
        }
    }
    string ans = "";
    for (int i = 1; i < n; i++) {
        ans += (char)(dp[i] + '1');
    }
    ans += "1";
    //reverse(ans.begin(), ans.end());
    cout << ans << "\n";
    return 0;
}