#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define TIME (clock() * 1.0 / CLOCKS_PER_SEC)

const int M = 3e5 + 239;
const int MS = 260;

int read() {
    string s;
    cin >> s;
    int mask = 0;
    for (int i = 0; i < 8; i++) {
        mask ^= (int)(s[i] == 'R') << i;
    }
    return mask;
}

int common(int m1, int m2) {
    return __builtin_popcount(m1 ^ m2 ^ 255);
}

bool dp[M][MS];
int n, mask[M];

int main() {
#ifdef ONPC
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n;
    for (int i = 0; i < n; i++) {
        mask[i] = read();
    }
    for (int i = 0; i < 256; i++) {
        dp[0][i] = 1;
        for (int j = 0; j < min(n, 8); j++) {
            if ((i >> j) & 1) {
                if (common(mask[0], mask[j + 1]) > j) {
                    dp[0][i] = 0;
                    break;
                }
            }
        }
    }
    for (int i = 1; i < n; i++) {
        for (int ms = 0; ms < 256; ms++) {
            int cur = 1;
            for (int j = i + 1; j < min(n, i + 9); j++) {
                if ((ms >> (j - i - 1)) & 1) {
                    if (common(mask[i], mask[j]) >= j - i) {
                        cur = 0;
                        break;
                    }
                }
            }
            dp[i][ms] = dp[i - 1][((ms << 1) & 255) + cur];
        }
    }
    string ans = "";
    for (int i = 0; i < n; i++) {
        ans += (char)((int)dp[i][0] + '1');
    }
    cout << ans << "\n";
    return 0;
}