/*

Code for problem L by cookiedoth
Generated 13 Dec 2020 at 10.51 AM


   ,##.                   ,==.
 ,#    #.                 \ o ',
#        #     _     _     \    \
#        #    (_)   (_)    /    ; 
 `#    #'                 /   .'  
   `##'                   "=="

-_-
z_z
>_<

*/

#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <ctime>
#include <functional>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <queue>
#include <deque>
#include <stack>
#include <complex>
#include <cassert>
#include <random>
#include <cstring>
#include <numeric>
#include <random>
#include <utility>
#include <tuple>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define debug(a) cerr << #a << " = " << a << endl
#define forn(i, n) for (int i = 0; i < n; ++i)
#define length(a) (int)a.size()

using namespace std;

template<class T> int chkmax(T &a, T b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, T b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class iterator> void output(iterator begin, iterator end, ostream& out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T x, ostream& out = cerr) {
	output(x.begin(), x.end(), out);
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 2e5 + 228;
int n, key[mx], l_link[mx], r_link[mx], lo[mx], hi[mx], h[mx], maxH;

void read() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> l_link[i] >> r_link[i] >> key[i];
		l_link[i]--;
		r_link[i]--;
	}
}

void dfs(int v, int hv) {
	h[v] = hv;
	lo[v] = hi[v] = key[v];
	if (l_link[v] != -1) {
		dfs(l_link[v], hv + 1);
		chkmin(lo[v], lo[l_link[v]]);
	}
	if (r_link[v] != -1) {
		dfs(r_link[v], hv + 1);
		chkmax(hi[v], hi[r_link[v]]);
	}
}

int query(int v, int L, int R) {
	if (v == -1) {
		return 1;
	}
	if (L <= lo[v] && hi[v] <= R) {
		return 1;
	}
	if (hi[v] < L || R < lo[v]) {
		return 1;
	}
	return 1 + query(l_link[v], L, R) + query(r_link[v], L, R);
}

void process_queries() {
	int T;
	cin >> T;
	while (T--) {
		int L, R;
		cin >> L >> R;
		int res = query(0, L, R);
		cout << res << '\n';
	}
}

signed main() {
	fast_io();
	read();
	dfs(0, 0);
	process_queries();
}
