#include<bits/stdc++.h>
#define F first
#define S second
#define ll long long
#define pb push_back
#define mp make_pair
#define eb emplace_back

using namespace std;
const int maxN = 200010;
int dep[maxN], l_path[maxN], r_path[maxN], bu[maxN][20];
int L[maxN], R[maxN];
int mi[maxN], ma[maxN];
int ke[maxN];
vector<pair<int, int> > keys;

void dfs(int v) {
    if(l_path[v] == 0) l_path[v] = v;
    if(r_path[v] == 0) r_path[v] = v;
    mi[v] = ma[v] = ke[v];
    for(int i = 1 ; i < 20 ; i++) bu[v][i] = bu[bu[v][i - 1]][i - 1];
    if(L[v] != 0) {
        r_path[L[v]] = r_path[v];
        dep[L[v]] = dep[v] + 1;
        bu[L[v]][0] = v;
        dfs(L[v]);
        mi[v] = mi[L[v]];
    }
    if(R[v] != 0) {
        l_path[R[v]] = l_path[v];
        dep[R[v]] = dep[v] + 1;
        bu[R[v]][0] = v;
        dfs(R[v]);
        ma[v] = ma[R[v]];
    }
}

inline int lb(int x) {
    return lower_bound(keys.begin(), keys.end(), mp(x, 0)) - keys.begin();
}

inline int ub(int x) {
    return lower_bound(keys.begin(), keys.end(), mp(x, maxN)) - keys.begin();
}

int lca(int a, int b) {
    if(dep[a] > dep[b]) swap(a, b);
    for(int i = 19 ; i >= 0 ; i--) {
        if(dep[bu[b][i]] >= dep[a]) b = bu[b][i];
    }
    if(a == b) return a;
    for(int i = 19 ; i >= 0 ; i--) {
        if(bu[a][i] != bu[b][i]) a = bu[a][i], b = bu[b][i];
    }
    return bu[a][0];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    
    int n;
    cin >> n;
    vector<array<int, 3> > A(n);
    bu[1][0] = 1;
    dep[1] = 1;
    for(int i = 1 ; i <= n ; i++) {
        cin >> A[i][0] >> A[i][1] >> A[i][2];
        L[i] = A[i][0], R[i] = A[i][1];
        keys.pb({A[i][2], i});
        ke[i] = A[i][2];
    }
    dfs(1);
    sort(keys.begin(), keys.end());
    int q;
    cin >> q;
    while(q--) {
        int a, b;
        cin >> a >> b;
        int l = lb(a);
        int r = ub(b) - 1;
        if(l > r) {
            if(l == 0 || l == keys.size())
                cout << 1 << '\n';
            else
            {
                int ans = min(dep[keys[l].S], dep[keys[r].S]) * 2 + 1;
                cout << ans << '\n';
            }
            continue;
        }
        l = keys[l].S;
        r = keys[r].S;
        if(l == r) {
            if(mi[l] == ma[l])
                cout << (dep[l] - 1) * 2 + 1 << '\n';
            else {
                cout << dep[l] * 2 + 1 << '\n';
            }
            continue;
        }
        if(mi[l] == ke[l]) l = r_path[l];
        if(ma[r] == ke[r]) r = l_path[r];
        int lc = lca(l, r);
        int ans;
        if(lc == l) {
            ans = (dep[r] - 1)  * 2 + 1;
            if(ma[r] > b || mi[r] < a) ans += 2;
            cout << ans << '\n';
            continue;
        }
        if(lc == r) {
            ans = (dep[l] - 1) * 2 + 1;
            if(ma[l] > b || mi[l] < r) ans += 2;
            cout << ans << '\n';
            continue;
        }
        ans = (dep[l] + dep[r] - dep[lc] - 2) * 2 + 1;
        if(ma[r] > b || mi[r] < a) ans += 2;
        if(ma[l] > b || mi[l] < a) ans += 2;
        cout << ans << '\n';
        continue;


    }
}
