﻿#pragma comment(linker, "/STACK:9759095000")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,abm,mmx,tune=native")
#include<vector>
#include<iostream>
#include<stack>
#include<cmath>
#include<algorithm>
#include<set>
#include<map>
#include<string>
#include<tuple>
#include<bitset>
#include<queue>
#include<unordered_map>
#include<random>
#include<ctime>
//#define double long double
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
using namespace std;
long long gcd(long long i, long long j) {
    if (j == 0)return i;
    else return gcd(j, i % j);
}
template<typename T> inline T getint() {
    T val = 0;
    char c;

    bool neg = false;
    while ((c = getchar()) && !(c >= '0' && c <= '9')) {
        neg |= c == '-';
    }

    do {
        val = (val * 10) + c - '0';
    } while ((c = getchar()) && (c >= '0' && c <= '9'));

    return val * (neg ? -1 : 1);
}
const long long INF = 1e9;
const int mod = 1000000009;
const double eps = 1e-12, pi = acos(-1);
const int maxN = 100100, maxT = 100010;
int a, b;
vector<tuple<int, int, int>>ans;
int y = 0;
void panic() {
    cout << -1;
    exit(0);
}
void mrec(int sum, int v) {
    int wei;
    if (b != 0 && sum != 1) {
        --b;
        wei = 2;
    }
    else {
        if (a == 0)panic();
        --a;
        wei = 1;
    }
    sum -= wei;
    int l = 0, r = 0;
    if (sum != 0) {
        l = y++;
        mrec((sum + 1) / 2, l);
        sum -= (sum + 1) / 2;
    }
    if (sum != 0) {
        r = y++;
        mrec(sum, r);
    }
    ans[v] = make_tuple(wei, (l == 0 ? 0 : l + 1), (r == 0 ? 0 : r + 1));
}
int main()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    cout.precision(11);
#ifdef _MY
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    cin >> a >> b;
    ans.assign(a + b, make_tuple(0, 0, 0));
    mrec(a + 2 * b, y++);
    for (auto x : ans) {
        int a, b, c;
        tie(a, b, c) = x;
        cout << a << " " << b << " " << c << "\n";
    }
}