#include <algorithm>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <deque>
#include <fstream>
#include <iostream>
#include <list>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <string>
#include <string.h>
#include <time.h>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ld;


int main() {
    int n;
    cin >> n;
    set<pair<int, int>> days;
    unordered_map<int, int> last_sign;
    for(int i = 0; i < n; ++i){
        int k, a;
        cin >> k;
        for(int j = 0; j < k; ++j){
            cin >> a;
            days.insert({i + 1, a});
            last_sign[a] = -1;
        }
    }

    int cur_day = -1, cur_sign = 1000000 + 1;
    for(auto& [day, person] : days){
        if(cur_day == -1){
            cur_day = day;
        }
        if(last_sign[person] == -1){
            last_sign[person] = cur_sign;
        } else if(last_sign[person] == cur_sign){
            last_sign[person] = --cur_sign;
        } else {
            continue;
        }
    }

    cout << (1000000 + 1) - cur_sign + 1 << std::endl;
    return 0;
}
