#include <algorithm>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <deque>
#include <fstream>
#include <iostream>
#include <list>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <string>
#include <string.h>
#include <time.h>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ld;


int main() {
    int n;
    cin >> n;

    set<pair<int, int>> days;
    map<int, int> last_sign;
    map<int, vector<int>> map;
    for(int i = 0; i < n; ++i){
        int k, a;
        cin >> k;
        for(int j = 0; j < k; ++j){
            cin >> a;
            days.insert({i + 1, a});
            last_sign[a] = -1;
            map[i + 1].push_back(a);
        }
    }
    int cur_sign = 1000000 + 1, answer = 0;
    for(auto& [day, persons] : map) {
        int min_seen = 1000000 + 1;
        for (auto person : persons) {
            if (last_sign[person] == -1) {
                last_sign[person] = min_seen;
            }
            min_seen = min(min_seen, last_sign[person]);
        }
        if (min_seen == cur_sign) {
            if(day != 1){
                cur_sign = min_seen - 1;
            }
            ++answer;
        }
        for (auto person : persons) {
            last_sign[person] = cur_sign;
        }
    }

    cout << answer << std::endl;
    return 0;
}
