#include <bits/stdc++.h>

using namespace std;
using Graph = vector<vector<int>>;
typedef long long ll;
#define all(x) (x).begin(), (x).end()

template<class T>
std::ostream &operator<<(std::ostream &os, const std::vector<T> &V) {
    os << "[";
    for (int i = 0; i < V.size(); ++i) {
        if (i > 0) os << ", ";
        os << V[i];
    }
    os << "]";
    return os;
}

template<class A, class B>
std::ostream &operator<<(std::ostream &os, const std::pair<A, B> &V) {
    os << "{" << V.first << ", " << V.second << "}";
    return os;
}

template<class A, class B, class C, class D>
std::ostream &operator<<(std::ostream &os, const std::map<A, B, C, D> &V) {
    os << "{";
    for (auto it = V.begin(); it != V.end(); ++it) {
        if (it != V.begin()) {
            os << ", ";
        }
        os << it->first << ": " << it->second;
    }
    os << "}";
    return os;
}

template<class A, class B, class C, class D, class E>
std::ostream &operator<<(std::ostream &os, const std::unordered_map<A, B, C, D, E> &V) {
    os << "{";
    for (auto it = V.begin(); it != V.end(); ++it) {
        if (it != V.begin()) {
            os << ", ";
        }
        os << it->first << ": " << it->second;
    }
    os << "}";
    return os;
}

template<class A, class B, class C>
std::ostream &operator<<(std::ostream &os, const std::set<A, B, C> &V) {
    os << "{";
    for (auto it = V.begin(); it != V.end(); ++it) {
        if (it != V.begin()) {
            os << ", ";
        }
        os << *it;
    }
    os << "}";
    return os;
}

template<class A, class B, class C, class D>
std::ostream &operator<<(std::ostream &os, const std::unordered_set<A, B, C, D> &V) {
    os << "{";
    for (auto it = V.begin(); it != V.end(); ++it) {
        if (it != V.begin()) {
            os << ", ";
        }
        os << *it;
    }
    os << "}";
    return os;
}

void debug_func() {}

template<class Head, class...Tail>
void debug_func(Head H, Tail... T) {
    std::cout << " " << H;
    debug_func(T...);
}

#ifdef OCHKO
#define debug(...) std::cout << "[" << #__VA_ARGS__ "]:"; debug_func(__VA_ARGS__);cout << endl;
#else
#define debug(...) 3;
#endif



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef OCHKO
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
#endif

    int n;
    cin >> n;
    while (n--) {
        int64_t b, d;
        cin >> b >> d;
        int64_t gc = __gcd(b, d);
        int64_t c1 = d / gc;
        int64_t c2 = b / gc;
        int64_t ans = b * b / gc;
        int64_t kek = ans / (c1 * c2);
        if (ans % (c1 * c2) == 0) --kek;
        cout << kek << "\n";
    }
	return 0;
}

