#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string> 
#include <set>
#include <cmath>
#include <bitset>
#include <iomanip>
#include <queue>
#include <stack>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <chrono>
#include <random>
#include <cstring>
using namespace std;

//#pragma comment(linker, "/stack:36777216")
//#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline void boostIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout << fixed << setprecision(10);
}

bool isPrime(int x) {
	if (x <= 4 || x % 2 == 0 || x % 3 == 0) return x == 2 || x == 3;
	for (int i = 5; i * i <= x; i += 6) if (x % i == 0 || x % (i + 2) == 0) return 0; return 1;
}

typedef long long int ll;
typedef long double ld;
typedef unsigned long long ull;

typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair<int, int> pii;

#define fori(n) for(int i = 0; i < (n); ++i)
#define forj(n) for(int j = 0; j < (n); ++j)
#define fork(n) for(int k = 0; k < (n); ++k)
#define forx(n) for(int x = 0; x < (n); ++x)


#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define ff first
#define ss second
#define debug(x) cerr << #x << " = " << x << endl;
#define debug_p(x) cerr << #x << " " << x.ff << " " << x.ss << endl;
#define debug_v(x) cerr << #x << " "; for (auto ii : x) cout << i << " "; cout << endl;
#define debug_vp(x) cerr << #x << " "; for (auto ii : x) cout << '[' << ii.ff << " " << ii.ss << ']'; cout << endl;
#define mp make_pair
#define rand kjsdflsdfsdlsjdlkfsdjflsjdfl 

#define Return cerr<<endl<<"RUNTIME: "<<1.0*clock()/CLOCKS_PER_SEC << " s" <<endl; return 0;

#define PI 3.14159265

ll gcd(ll a, ll b) { return b ? gcd(b, a % b) : a; }
ll lcm(ll a, ll b) { return a * b / gcd(a, b); }

template<typename T> inline T getint() {
	T val = 0;
	char c;

	bool neg = false;
	while ((c = getchar()) && !(c >= '0' && c <= '9')) {
		neg |= c == '-';
	}

	do {
		val = (val * 10) + c - '0';
	} while ((c = getchar()) && (c >= '0' && c <= '9'));

	return val * (neg ? -1 : 1);
}

/////////////////////
//#define int long long
int Mod = 1e9 + 7;
#define endl '\n'
/////////////////////

int32_t main() {
	boostIO();
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n; cin >> n;
	int Color[20] = {};
	int Predok[20] = {};
	int RedKids[20] = {};
	int Kids[20] = {};
	unordered_set<bitset<20>> Set;
	for (int i = 1; i < n; ++i) {
		cin >> Predok[i];
		Predok[i]--;
		Kids[Predok[i]]++;
	}

	Color[0] = 1;

	bitset<20> b;
	b[0] = 1;
	Set.insert(b);
	vector<int> ans;

	int Last[20] = {};
	int g = 0;

	int w = 1;
	while (1) {
		int Best = -1;
		int x = -1;
		for (int i = (g == 0) ? 1 : n - 1; (g == 0) ? (i < n) : (i >= 0); (g == 0) ? ++i : --i) {
			int p = Predok[i];
			if (b[i] == 0) {
				if (Color[p] == 0) continue;
				b[i] = 1;
				if (Set.find(b) != Set.end()) {
					b[i] = 0;
					continue;
				}
				b[i] = 0;
				if (Best < Last[i]) {
					Best = Last[i];
					x = i;
				}
				else if (Best == Last[i] && Kids[i] < Kids[x]) {
					Best = Last[i];
					x = i;
				}
				continue;

				/*
				Color[i] = 1;
				Set.insert(b);
				RedKids[p]++;
				ans.push_back(i + 1);
				*/

			}
			else if (b[i] == 1) {
				if (RedKids[i] != 0) continue;
				b[i] = 0;
				if (Set.find(b) != Set.end()) {
					b[i] = 1;
					continue;
				}
				b[i] = 1;
				if (Best < Last[i]) {
					Best = Last[i];
					x = i;
				}
				else if (Best == Last[i] && Kids[i] < Kids[x]) {
					Best = Last[i];
					x = i;
				}
				continue;

				/*
				Color[i] = 0;
				Set.insert(b);
				RedKids[p]--;
				ans.push_back(i + 1);
				*/
			}
		}
		g = 1 - g;
		if (Best == -1) break;
		int p = Predok[x];
		if (b[x] == 0) {
			Last[x] = w++;
			b[x] = 1;
			Color[x] = 1;
			Set.insert(b);
			RedKids[p]++;
			ans.push_back(x + 1);
		}
		else if (b[x] == 1) {
			Last[x] = w++;
			b[x] = 0;
			Color[x] = 0;
			Set.insert(b);
			RedKids[p]--;
			ans.push_back(x + 1);
		}
	}
	cout << ans.size() << endl;
	for (auto x : ans) {
		cout << x << " ";
	}
	cout << endl;

}
