#include <iostream>
#include <iomanip>
#include <fstream>
#include <sstream>

#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <queue>
#include <stack>
#include <unordered_map>
#include <math.h>

#include <random>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")

//#include <fstream>


//#define int long long

//#define int uint32_t
#define ll long long
#define ull unsigned long long
#define pb push_back
#define vi vector<int>
#define vpi vector<pair<int, int>>
#define vvi vector<vector<int>>
#define fori(n) for(int i = 0; i < (n); ++i)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

ll gcd(ll a, ll b) { return (b == 0 ? a : gcd(b, a % b)); }

const int inf = 1e9;
const double eps = 1e-9;
const int maxn = 1e9 + 7;
const double pi = 3.1415926535897932384626433832795;
const int mod = 1e9 + 7;

using namespace std;


ll mypow(ll x, ll y) {
    ll res = 1;
    for (; y >= 1; y >>= 1) {
        if (y & 1)
            res = (res * x) % mod;
        x = (x * x) % mod;
    }
    return res;
}


int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cout.precision(15);
    cout << fixed;
    //freopen("gas.in", "r", stdin);
    //freopen("gas.out", "w", stdout);
    ////////////////////////////
    ll a, b, c, n;
    cin >> a >> b >> c >> n;
    map<ll, ll> div;
    for (int i = 0; i < n; ++i) {
        ll res = a * i * i + b * i + c;
        for (ll j = 2; j * j <= res; ++j) {
            while (!(res % j)) {
                div[j]++;
                res /= j;
            }
        }
        if (res > 1)
            div[res]++;
    }
    ll ans = 1;
    for (const auto& el : div) {
        int al = el.first;
        int p = el.second - el.second % 2;
        ans = (ans * mypow(al, p)) % mod;
    }
    cout << ans;


    return 0;
}